/**
 * @license
 * Copyright 2023 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import*as e from"@tensorflow/tfjs-core";import{env as t,backend_util as n,util as i,KernelBackend as r,DataStorage as s,engine as a,buffer as o,registerBackend as u,Fill as d,Reshape as l,broadcast_util as h,_FusedMatMul as p,Identity as c,Complex as f,upcastType as m,tidy as g,reshape as x,broadcastTo as y,TensorBuffer as w,slice_util as b,Abs as C,Acos as S,Acosh as v,Add as k,AddN as I,Transpose as R,sumOutType as $,All as P,Any as z,ArgMax as A,ArgMin as N,Asin as D,Asinh as F,Atan as T,Atan2 as E,Atanh as W,Max as L,Mean as B,AvgPool as _,AvgPool3D as O,AvgPool3DGrad as U,AvgPoolGrad as V,BatchMatMul as M,Slice as G,BatchToSpaceND as H,Bincount as X,BroadcastArgs as K,NotEqual as q,Real as Y,Cast as j,Ceil as Q,ClipByValue as Z,ComplexAbs as J,Imag as ee,Concat as te,Conv2D as ne,Conv2DBackpropFilter as ie,Conv2DBackpropInput as re,Conv3D as se,Conv3DBackpropFilterV2 as ae,Conv3DBackpropInputV2 as oe,Cos as ue,Cosh as de,CropAndResize as le,Cumprod as he,Cumsum as pe,DenseBincount as ce,DepthToSpace as fe,DepthwiseConv2dNative as me,DepthwiseConv2dNativeBackpropFilter as ge,DepthwiseConv2dNativeBackpropInput as xe,Diag as ye,Dilation2D as we,Dilation2DBackpropFilter as be,Dilation2DBackpropInput as Ce,Multiply as Se,Sum as ve,Einsum as ke,Elu as Ie,EluGrad as Re,Equal as $e,Erf as Pe,Exp as ze,ExpandDims as Ae,Expm1 as Ne,FFT as De,FlipLeftRight as Fe,Floor as Te,FloorDiv as Ee,FromPixels as We,FusedBatchNorm as Le,FusedConv2D as Be,FusedDepthwiseConv2D as _e,GatherNd as Oe,GatherV2 as Ue,Greater as Ve,GreaterEqual as Me,IFFT as Ge,IsFinite as He,IsInf as Xe,IsNan as Ke,LeakyRelu as qe,Less as Ye,LessEqual as je,LinSpace as Qe,Log as Ze,Log1p as Je,LogicalAnd as et,LogicalNot as tt,LogicalOr as nt,LRN as it,LRNGrad as rt,Maximum as st,MaxPool as at,MaxPool3D as ot,MaxPool3DGrad as ut,MaxPoolGrad as dt,MaxPoolWithArgmax as lt,Min as ht,Minimum as pt,MirrorPad as ct,Mod as ft,Softmax as mt,Multinomial as gt,Neg as xt,NonMaxSuppressionV3 as yt,kernel_impls as wt,NonMaxSuppressionV5 as bt,OneHot as Ct,ZerosLike as St,OnesLike as vt,Pack as kt,PadV2 as It,Pow as Rt,Prelu as $t,Prod as Pt,Range as zt,RealDiv as At,Reciprocal as Nt,Relu as Dt,Relu6 as Ft,ResizeBilinear as Tt,ResizeBilinearGrad as Et,ResizeNearestNeighbor as Wt,ResizeNearestNeighborGrad as Lt,Reverse as Bt,RotateWithOffset as _t,Round as Ot,Rsqrt as Ut,ScatterNd as Vt,SearchSorted as Mt,Select as Gt,Selu as Ht,Sigmoid as Xt,Sign as Kt,Sin as qt,Sinh as Yt,Softplus as jt,SpaceToBatchND as Qt,Tile as Zt,SparseToDense as Jt,SplitV as en,Sqrt as tn,Square as nn,SquaredDifference as rn,Step as sn,StridedSlice as an,StringNGrams as on,Sub as un,Tan as dn,Tanh as ln,TensorScatterUpdate as hn,TopK as pn,Transform as cn,Unpack as fn,UnsortedSegmentSum as mn,registerKernel as gn}from"@tensorflow/tfjs-core";const xn=t();xn.registerFlag("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE",(()=>15)),xn.registerFlag("WEBGPU_CPU_FORWARD",(()=>!0)),xn.registerFlag("WEBGPU_MATMUL_PROGRAM_TYPE",(()=>-1)),xn.registerFlag("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE",(()=>!0)),xn.registerFlag("WEBGPU_USE_LOW_POWER_GPU",(()=>!1)),xn.registerFlag("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD",(()=>1e3)),xn.registerFlag("WEBGPU_USE_PROFILE_TOOL",(()=>!1)),xn.registerFlag("WEBGPU_IMPORT_EXTERNAL_TEXTURE",(()=>!0)),xn.registerFlag("WEBGPU_USE_NAIVE_CONV2D_DEBUG",(()=>!1)),xn.registerFlag("WEBGPU_THRESHOLD_TO_INCREASE_WORKGROUPS_FOR_MATMUL",(()=>0)),xn.registerFlag("WEBGPU_CONV_SEPARATE_IM2COL_SHADER",(()=>!1)),xn.registerFlag("WEBGPU_PRINT_SHADER",(()=>"")),xn.registerFlag("WEBGPU_ENGINE_COMPILE_ONLY",(()=>!1));class yn{constructor(e){e&&(this.vendor=e.vendor,this.architecture=e.architecture,this.intelGPUGeneration=this.getIntelGPUGeneration())}getIntelGPUGeneration(){if(this.isIntel()){if(this.architecture.startsWith("gen"))return Number(this.architecture.match(/\d+/));if(this.architecture.startsWith("xe"))return 12}return 0}isIntel(){return"intel"===this.vendor}}class wn{constructor(e){this.device=e,this.numUsedBuffers=0,this.numFreeBuffers=0,this.freeBuffers=new Map,this.usedBuffers=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireBuffer(e,t,n=!1,i=!0){let r;const s=bn(e,t);return i?(this.freeBuffers.has(s)||this.freeBuffers.set(s,[]),this.freeBuffers.get(s).length>0?(r=this.freeBuffers.get(s).pop(),this.numFreeBuffers--):(r=this.device.createBuffer({size:e,usage:t,mappedAtCreation:n}),this.numBytesAllocated+=e)):(r=this.device.createBuffer({size:e,usage:t,mappedAtCreation:n}),this.numBytesAllocated+=e),this.usedBuffers.has(s)||this.usedBuffers.set(s,[]),this.usedBuffers.get(s).push(r),this.numUsedBuffers++,this.numBytesUsed+=e,r}releaseBuffer(e,t=!0){if(0===this.freeBuffers.size)return;const n=e.size,i=bn(n,e.usage),r=this.usedBuffers.get(i),s=r.indexOf(e);if(s<0)throw new Error("Cannot find the buffer in buffer manager");r[s]=r[r.length-1],r.pop(),this.numUsedBuffers--,this.numBytesUsed-=n,t?(this.freeBuffers.get(i).push(e),this.numFreeBuffers++):(e.destroy(),this.numBytesAllocated-=n)}getNumUsedBuffers(){return this.numUsedBuffers}getNumFreeBuffers(){return this.numFreeBuffers}dispose(){this.freeBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedBuffers.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeBuffers=new Map,this.usedBuffers=new Map,this.numUsedBuffers=0,this.numFreeBuffers=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function bn(e,t){return`${e}_${t}`}class Cn{constructor(e){this.device=e,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures=new Map,this.usedTextures=new Map,this.numBytesUsed=0,this.numBytesAllocated=0}acquireTexture(e,t,n,i){const r=e*t*vn(n),s=Sn(e,t,n,i);if(this.freeTextures.has(s)||this.freeTextures.set(s,[]),this.usedTextures.has(s)||this.usedTextures.set(s,[]),this.numBytesUsed+=r,this.numUsedTextures++,this.freeTextures.get(s).length>0){this.numFreeTextures--;const e=this.freeTextures.get(s).shift();return this.usedTextures.get(s).push(e),e}this.numBytesAllocated+=r;const a=this.device.createTexture({size:[e,t],format:n,usage:i});return this.usedTextures.get(s).push(a),a}releaseTexture(e){if(0===this.freeTextures.size)return;const t=e.width,n=e.height,i=e.format,r=Sn(t,n,i,e.usage);this.freeTextures.has(r)||this.freeTextures.set(r,[]),this.freeTextures.get(r).push(e),this.numFreeTextures++,this.numUsedTextures--;const s=this.usedTextures.get(r),a=s.indexOf(e);if(a<0)throw new Error("Cannot release a texture that was never provided by this texture manager");s.splice(a,1);const o=t*n*vn(i);this.numBytesUsed-=o}getNumUsedTextures(){return this.numUsedTextures}getNumFreeTextures(){return this.numFreeTextures}dispose(){this.freeTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.usedTextures.forEach(((e,t)=>{e.forEach((e=>{e.destroy()}))})),this.freeTextures=new Map,this.usedTextures=new Map,this.numUsedTextures=0,this.numFreeTextures=0,this.numBytesUsed=0,this.numBytesAllocated=0}}function Sn(e,t,n,i){return`${e}_${t}_${n}_${i}`}function vn(e){if("rgba8unorm"===e)return 16;throw new Error(`${e} is not supported!`)}function kn(e,t){if(Math.max(...e)>5)throw new Error("Cannot symbolically compute strides for rank > 6 tensor.");const n=e.length,i=e.map((e=>`${t}.${"xyzwuv"[e]}`)),r=new Array(n-1);r[n-2]=i[n-1];for(let e=n-3;e>=0;--e)r[e]=`(${r[e+1]} * ${i[e+1]})`;return r}const In=(e,t,n)=>"int32"===n?`atomicAdd(${e}, bitcast<i32>(${t}));`:`\n          {\n            var oldValue = 0;\n            loop {\n              let newValueF32 = bitcast<f32>(oldValue) + (${t});\n              let newValue = bitcast<i32>(newValueF32);\n              let res = atomicCompareExchangeWeak(${e}, oldValue, newValue);\n              if res.exchanged {\n                break;\n              }\n              oldValue = res.old_value;\n            }\n          }`,Rn=(e,r,s,a,o)=>{const u=function(e,t,r){const s=[],a=r.workgroupSize[0]*r.workgroupSize[1]*r.workgroupSize[2];if(r.outputComponent=r.outputComponent?r.outputComponent:1,s.push(`\n\n      var<private> localId: vec3<u32>;\n      var<private> localIndex: u32;\n      var<private> globalId: vec3<u32>;\n      var<private> numWorkgroups: vec3<u32>;\n      var<private> workgroupId: vec3<u32>;\n\n      // Only used when the y/z dimension of workgroup size is 1.\n      fn getGlobalIndex() -> i32 {\n        ${Wn(r)?"  return i32(globalId.x);":`  return i32((workgroupId.z * numWorkgroups.x * numWorkgroups.y +\n                workgroupId.y * numWorkgroups.x + workgroupId.x) * ${a}u +\n                localIndex);\n        `}\n      }\n    `),r.isFromPixels){s.push(`\n        struct Uniform {\n          size            : i32,\n          numChannels     : i32,\n          outShapeStrides : vec2<i32>,\n        };\n\n        @group(0) @binding(0) var<storage, read_write> result: array<${Ln(t.dtype,r.outputComponent)}>;\n        @group(0) @binding(2) var<uniform> uniforms: Uniform;\n      `);const e=Bn(r);return[Dn,s.join("\n"),Tn(t.shape),r.getUserCode(),Nn(e,r)].join("\n")}let o,u,d="struct Uniforms { NAN : f32, INFINITY : f32, ";r.variableNames.forEach(((t,n)=>{const i=Pn(e[n].shape.length);d+=`${t.charAt(0).toLowerCase()+t.slice(1)}Shape : ${i}, `,o=e[n].shape.length-1,u=Pn(o),d+=`${t.charAt(0).toLowerCase()+t.slice(1)}ShapeStrides: ${u}, `}));const l=Pn(t.shape.length);d+=`outShape : ${l}, `,o=t.shape.length-1,u=Pn(o),d+=`\n         outShapeStrides: ${u}, `,r.size&&(d+="size : i32, ");r.uniforms&&(d+=r.uniforms);d+="};",d=function(e){const t=/(\w+)\s*:\s*vec(5|6)/g;e=e.replace(t,(e=>"@align(16) "+e));const n=/vec(5|6)\s*,\s*(\w+)/g;return e=e.replace(n,((e,t,n)=>`vec${t}, @align(16) ${n}`))}(d),s.push(d),r.atomic?s.push("\n      @group(0) @binding(0) var<storage, read_write> result: array<atomic<i32>>;\n    "):s.push(`\n      @group(0) @binding(0) var<storage, read_write> result: array<${Ln(t.dtype,r.outputComponent)}>;\n    `);r.variableNames.forEach(((t,n)=>{s.push(`\n      @group(0) @binding(${1+n}) var<storage, read> ${t}: array<${r.variableComponents?Ln(e[n].dtype,r.variableComponents[n]):Ln(e[n].dtype,r.outputComponent)}>;\n        `)})),""!==d&&s.push(`\n      @group(0) @binding(${1+r.variableNames.length}) var<uniform> uniforms: Uniforms;\n      `);const h=function(e,t){const{x:n,y:i=[],z:r=[]}=t,s=e.length,a=n.length+i.length+r.length;if(a!==s)return"";if(n.length===s){return`fn getOutputCoords() -> ${Pn(s)}{\n    let globalIndex = getGlobalIndex();\n    return getCoordsFromIndex(globalIndex);\n  }\n  `}let o="";const u=[n,i,r];for(let e=0;e<u.length;e++){const t=u[e];if(0!==t.length)if(1===t.length)o+=`let d${t[0]} = i32(globalId[${e}]);`;else{const n=kn(t,"uniforms.outShape");o+=`var index${e} = i32(globalId[${e}]);`;for(let i=0;i<n.length;i++)o+=`let d${t[i]} = index${e} / ${n[i]};`,i===n.length-1?o+=`let d${t[i+1]} = index${e} - d${t[i]} * ${n[i]};`:o+=`index${e} = index${e} - d${t[i]} * ${n[i]};`}}const d=[];for(let e=0;e<a;e++)d.push(`d${e}`);const l=Pn(a);let h=`fn getOutputCoords() -> ${l} {\n  ${o}\n`;0===d.length?h+=`return ${l}(0); }`:h+=`return ${l}(${d.join(",")}); }`;return h}(t.shape,r.dispatchLayout),p=[Dn,s.join("\n")+Fn,Tn(t.shape),h,En(t.shape.length)];r.atomic||p.push(function(e,t,n){const i=e.length,r=Ln(t,n);let s=`fn setOutputAtIndex(flatIndex : i32, value : ${$n(n)}) {\n      result[flatIndex] = ${r}(value);\n    }\n\n    fn setOutputAtIndexI32(flatIndex : i32, value : ${$n(n,"i32")}) {\n      result[flatIndex] = ${r}(value);\n    }\n    `;if(i>=2){const e=["d0","d1","d2","d3","d4","d5"].slice(0,i),t=Pn(i);s+=`\n      fn setOutputAtCoords(${e.map((e=>`${e} : i32`)).join(", ")}, value : ${$n(n)}) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndex(flatIndex${1===n?"":` / ${n}`}, value);\n      }\n      fn setOutputAtCoordsI32(${e.map((e=>`${e} : i32`)).join(", ")}, value : ${$n(n,"i32")}) {\n        let flatIndex = getOutputIndexFromCoords(${t}(${e.join(", ")}));\n        setOutputAtIndexI32(flatIndex${1===n?"":` / ${n}`}, value);\n      }\n    `}return s}(t.shape,t.dtype,r.outputComponent));r.variableNames.forEach(((t,n)=>{p.push(`${Tn(e[n].shape,t)}`)}));const c=e.map(((e,s)=>function(e,t,r,s){let a=function(e,t){const n=e.name,i=e.shape.length,r=Pn(i),s="get"+n.charAt(0).toUpperCase()+n.slice(1),a=["d0","d1","d2","d3","d4","d5"].slice(0,i),o=a.map((e=>`${e} : i32`)).join(", ");if(i<1)return`\n      fn ${s}() -> ${$n(t)} {\n        return ${$n(t)}(${n}[0]);\n      }\n    `;const u=`uniforms.${n.charAt(0).toLowerCase()+n.slice(1)}Shape`;let d=`${i}D`;0===i&&(d="1D");return`\n    fn ${s}(${o}) -> ${$n(t)} {\n      return ${$n(t)}(${n}[getIndexFromCoords${d}(${r}(${a.join(",")}),\n        ${u})${1===t?"":` / ${t}`}]);\n    }\n   `}(e,r);e.shape.length<=t.length&&(a+=function(e,t,r,s){const a=e.name,o=a.charAt(0).toUpperCase()+a.slice(1),u="get"+o+"ByOutput",d=e.shape.length,l=t.length,h=Pn(l);if(i.arraysEqual(e.shape,t)&&s)return`\n    fn ${u}Index(globalIndex : i32) -> ${$n(r)} {\n      return ${$n(r)}(${a}[globalIndex]);\n    }\n\n    fn ${u}Coords(coords : ${h}) -> ${$n(r)} {\n      return ${$n(r)}(${a}[${l>1?"getOutputIndexFromCoords(coords)":"coords"}${1===r?"":` / ${r}`}]);\n    }\n    `;const p=n.getBroadcastDims(e.shape,t),c=l-d;let f="";if(0===d)return`\n    fn ${u}Index(globalIndex : i32) -> ${$n(r)}{\n      return get${o}();\n    }\n\n    fn ${u}Coords(coords : ${h}) -> ${$n(r)}{\n      return get${o}();\n    }\n  `;f=l<2&&p.length>=1?"coords = 0;":p.map((e=>`coords.${zn(e+c)} = 0;`)).join("\n");let m="";if(l<2&&d>0)m="coords";else if(l>1){const t=Pn(d),n=e.shape.map(((e,t)=>`coords.${zn(t+c)}`)).join(", ");m=`${t}(${n})`}else m="coords";const g=`uniforms.${a.charAt(0).toLowerCase()+a.slice(1)}Shape`,x=`${d}D`;return`\n  fn ${u}Index(globalIndex : i32) -> ${$n(r)} {\n    var coords = getCoordsFromIndex(globalIndex);\n    ${f}\n    return ${$n(r)}(${a}[getIndexFromCoords${x}(${m}, ${g})${1===r?"":` / ${r}`}]);\n  }\n\n  fn ${u}Coords(coordsIn : ${h}) -> ${$n(r)} {\n    var coords = coordsIn;\n    ${f}\n    return ${$n(r)}(${a}[getIndexFromCoords${x}(${m}, ${g})${1===r?"":` / ${r}`}]);\n  }\n`}(e,t,r,s));return a}(e,t.shape,r.variableComponents?r.variableComponents[s]:r.outputComponent,r.dispatchLayout.x.length===t.shape.length))).join("\n");p.push(c),p.push(r.getUserCode());const f=Bn(r);p.push(Nn(f,r));return p.join("\n")}(s,{dtype:a.dtype,shape:a.shape},r),d=e.createShaderModule({code:u,label:r.constructor.name});let l=t().get("WEBGPU_PRINT_SHADER");if(""!==l){l=l.toLowerCase();const e=l.split(",");("all"===l||e.some((e=>r.shaderKey.toLowerCase().includes(e))))&&(console.group(r.shaderKey),console.debug(u),console.groupEnd())}return o?e.createComputePipelineAsync({compute:{module:d,entryPoint:"_start"},label:r.constructor.name,layout:"auto"}):e.createComputePipeline({compute:{module:d,entryPoint:"_start"},label:r.constructor.name,layout:"auto"})},$n=(e,t="f32")=>{switch(e){case 1:return`${t}`;case 2:return`vec2<${t}>`;case 3:return`vec3<${t}>`;case 4:return`vec4<${t}>`;default:throw new Error(`${e}-component ${t} is not supported.`)}};function Pn(e){if(e<=1)return"i32";if(2===e)return"vec2<i32>";if(3===e)return"vec3<i32>";if(4===e)return"vec4<i32>";if(5===e)return"vec5";if(6===e)return"vec6";throw Error(`GPU for rank ${e} is not yet supported`)}function zn(e){if(0===e)return"x";if(1===e)return"y";if(2===e)return"z";if(3===e)return"w";if(4===e)return"u";if(5===e)return"v";throw Error(`Index ${e} is not yet supported`)}function An(...e){let t;switch(e.length){case 0:t="\n        fn main()\n      ";break;case 1:t=`\n        fn main(${e[0]} : i32)\n      `;break;default:throw Error("Unreachable")}return t}function Nn(e,t){let n;return n=`\n     ${function(e){return`\n  @compute @workgroup_size(${e.workgroupSize[0]}, ${e.workgroupSize[1]}, ${e.workgroupSize[2]})\n`}(t)}\n      fn _start(@builtin(local_invocation_id) LocalId : vec3<u32>,\n                @builtin(global_invocation_id) GlobalId : vec3<u32>,\n                @builtin(local_invocation_index) LocalIndex: u32,\n                @builtin(workgroup_id) WorkgroupId : vec3<u32>,\n                @builtin(num_workgroups) NumWorkgroups : vec3<u32>) {\n        localId = LocalId;\n        localIndex = LocalIndex;\n        globalId = GlobalId;\n        numWorkgroups = NumWorkgroups;\n        workgroupId = WorkgroupId;\n        ${e?"main(getGlobalIndex());":"main();"};\n      }\n    `,n}const Dn="\n  struct vec5 {x: i32, y: i32, z: i32, w: i32, u: i32};\n  struct vec6 {x: i32, y: i32, z: i32, w: i32, u: i32, v: i32};\n\n  // Checks whether coordinates lie within the bounds of the shape.\n  fn coordsInBounds2D(coord : vec2<i32>, shape : vec2<i32>) -> bool {\n    return all(coord >= vec2<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds3D(coord : vec3<i32>, shape : vec3<i32>) -> bool {\n    return all(coord >= vec3<i32>(0)) && all(coord < shape);\n  }\n  fn coordsInBounds4D(coord : vec4<i32>, shape : vec4<i32>) -> bool {\n    return all(coord >= vec4<i32>(0)) && all(coord < shape);\n  }\n\n  fn getIndexFromCoords1D(coord : i32, shape : i32) -> i32 {\n    return coord;\n  }\n  fn getIndexFromCoords2D(coords : vec2<i32>, shape : vec2<i32>) -> i32 {\n    return dot(coords, vec2<i32>(shape.y, 1));\n  }\n  fn getIndexFromCoords3D(coords : vec3<i32>, shape : vec3<i32>) -> i32 {\n    return dot(coords, vec3<i32>(shape.y * shape.z, shape.z, 1));\n  }\n  fn getIndexFromCoords4D(coords : vec4<i32>, shape : vec4<i32>) -> i32 {\n    return dot(coords, vec4<i32>(\n        shape.y * shape.z * shape.w, shape.z * shape.w, shape.w, 1));\n  }\n  fn getIndexFromCoords5D(coords : vec5, shape : vec5) -> i32 {\n    let shapeStrides: vec5 = vec5(shape.y * shape.z * shape.w * shape.u, shape.z * shape.w * shape.u, shape.w * shape.u, shape.u, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u;\n  }\n  fn getIndexFromCoords6D(coords : vec6, shape : vec6) -> i32 {\n    let shapeStrides: vec6 = vec6(shape.y * shape.z * shape.w * shape.u * shape.v, shape.z * shape.w * shape.u * shape.v, shape.w * shape.u * shape.v, shape.u * shape.v, shape.v, 1);\n    return coords.x*shapeStrides.x + coords.y*shapeStrides.y + coords.z*shapeStrides.z + coords.w*shapeStrides.w + coords.u*shapeStrides.u + coords.v*shapeStrides.v;\n  }\n\n  fn idiv(a: i32, b: i32, sign: f32) -> i32 {\n    var res: i32 = a / b;\n    let modulo: i32 = a % b;\n    if (sign < 0. && modulo != 0) {\n      res = res - 1;\n    }\n    return res;\n  }\n\n  // NaN defination in IEEE 754-1985 is :\n  //   - sign = either 0 or 1.\n  //   - biased exponent = all 1 bits.\n  //   - fraction = anything except all 0 bits (since all 0 bits represents infinity).\n  // https://en.wikipedia.org/wiki/IEEE_754-1985#Representation_of_non-numbers\n  fn isnan(val: f32) -> bool {\n    let floatToUint: u32 = bitcast<u32>(val);\n    return (floatToUint & 0x7fffffffu) > 0x7f800000u;\n  }\n  fn isnanVec4(val : vec4<f32>) -> vec4<bool> {\n    let floatToUint: vec4<u32> = bitcast<vec4<u32>>(val);\n    return (floatToUint & vec4<u32>(0x7fffffffu)) > vec4<u32>(0x7f800000u);\n  }\n",Fn="\n  fn isinf(val: f32) -> bool {\n    return abs(val) == uniforms.INFINITY;\n  }\n";function Tn(e,t=""){const n=e.length,r=""!==t?`get${t.charAt(0).toUpperCase()+t.slice(1)}CoordsFromIndex`:"getCoordsFromIndex",s=""!==t?`${t.charAt(0).toLowerCase()+t.slice(1)}ShapeStrides`:"outShapeStrides";if(n<=1)return`fn ${r}(index : i32) -> i32 { return index; }`;const a=i.computeStrides(e),o=Pn(n),u=[];for(let e=0;e<n;e++)u.push(`d${e}`);if(1===a.length)return`    fn ${r}(index : i32) -> vec2<i32> {\n      let d0 = index / uniforms.${s}; let d1 = index - d0 * uniforms.${s};\n      return vec2<i32>(d0, d1);\n    }`;let d;return d="var index2 = index;"+a.map(((e,t)=>`${`let ${u[t]} = index2 / uniforms.${s}.${zn(t)}`}; ${t===a.length-1?`let ${u[t+1]} = index2 - ${u[t]} * uniforms.${s}.${zn(t)}`:`index2 = index2 - ${u[t]} * uniforms.${s}.${zn(t)}`};`)).join(""),`\n    fn ${r}(index : i32) -> ${o} {\n      ${d}\n      return ${o}(${u.join(",")});\n    }\n  `}function En(e){let t="";switch(e){case 0:case 1:t+="\n        fn getOutputIndexFromCoords(coords : i32) -> i32 {\n          return coords;\n        }\n        ";break;case 2:t+="\n        fn getOutputIndexFromCoords(coords : vec2<i32>) -> i32 {\n          return dot(coords, vec2<i32>(uniforms.outShapeStrides, 1));\n        }\n        ";break;case 3:t+="\n        fn getOutputIndexFromCoords(coords : vec3<i32>) -> i32 {\n          return dot(coords, vec3<i32>(uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, 1));\n        }\n        ";break;case 4:t+="\n        fn getOutputIndexFromCoords(coords : vec4<i32>) -> i32 {\n          return dot(coords, vec4<i32>(\n            uniforms.outShapeStrides.x, uniforms.outShapeStrides.y, uniforms.outShapeStrides.z, 1));\n        }\n        ";break;case 5:t+="\n        fn getOutputIndexFromCoords(coords : vec5) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u;\n        }\n        ";break;case 6:t+="\n        fn getOutputIndexFromCoords(coords : vec6) -> i32 {\n          return coords.x * uniforms.outShapeStrides.x +\n              coords.y * uniforms.outShapeStrides.y +\n              coords.z * uniforms.outShapeStrides.z +\n              coords.w * uniforms.outShapeStrides.w +\n              coords.u * uniforms.outShapeStrides.u +\n              coords.v;\n        }\n        ";break;default:i.assert(!1,(()=>`Unsupported ${e}D shape`))}return t}function Wn(e){return 1===e.dispatch[1]&&1===e.dispatch[2]}function Ln(e,t=1){if("float32"===e)return $n(t,"f32");if("int32"===e||"bool"===e)return $n(t,"i32");throw new Error(`type ${e} is not supported.`)}function Bn(e){return(!e.dispatchLayout.hasOwnProperty("y")||0===e.dispatchLayout.y.length)&&(!e.dispatchLayout.hasOwnProperty("z")||0===e.dispatchLayout.z.length)}const _n=e=>{let t=1;for(let n=0;n<e.length;n++)t*=e[n];return t};function On(e,t,n=[1,1,1],i=[1,1,1]){const[r,s,a]=[Math.ceil(_n(e.x.map((e=>t[e])))/(n[0]*i[0])),e.y?Math.ceil(_n(e.y.map((e=>t[e])))/(n[1]*i[1])):1,e.z?Math.ceil(_n(e.z.map((e=>t[e])))/(n[2]*i[2])):1];return[r,s,a]}function Un(e,t,n,i=!1){const r=[8,8,1],s=[4,4,1];return i||(e<=8&&(s[1]=1),t<=16&&n<=16&&(r[0]=4)),{workgroupSize:r,elementsPerThread:s}}function Vn(e,t,n=!1){if(n)return[8,8,1];const i=_n(e.x.map((e=>t[e]))),r=_n(e.y.map((e=>t[e])));return i<=4?[4,16,1]:r<=4?[16,4,1]:[16,16,1]}function Mn(e,t,n=!1){if(n)return[4,4,1];const i=_n(e.x.map((e=>t[e]))),r=_n(e.y.map((e=>t[e])));return i<=4?[1,2,1]:r<=4?[2,1,1]:[2,2,1]}function Gn(e){return{x:e.map(((e,t)=>t))}}function Hn(e){if("float32"===e||"int32"===e||"bool"===e||"string"===e)return 4;if("complex64"===e)return 8;throw new Error(`Unknown dtype ${e}`)}function Xn(){return("undefined"!=typeof window||"undefined"!=typeof WorkerGlobalScope)&&!!navigator.gpu}function Kn(e,t){Array.isArray(e)||(e=[e]),e.forEach((e=>{null!=e&&i.assert("complex64"!==e.dtype,(()=>`${t} does not support complex64 tensors in the WebGPU backend.`))}))}var qn;!function(e){e[e.MatMulReduceProgram=0]="MatMulReduceProgram",e[e.MatMulSplitKProgram=1]="MatMulSplitKProgram",e[e.MatMulSmallOutputSizeProgram=2]="MatMulSmallOutputSizeProgram",e[e.MatMulPackedProgram=3]="MatMulPackedProgram",e[e.MatMulMax=4]="MatMulMax"}(qn||(qn={}));var Yn={__proto__:null,GPUBytesPerElement:Hn,get MatMulProgramType(){return qn},assertNotComplex:Kn,computeDispatch:On,computeWorkPerThreadForConv2d:Mn,computeWorkgroupInfoForMatMul:Un,computeWorkgroupSizeForConv2d:Vn,flatDispatchLayout:Gn,isWebGPUSupported:Xn,tilesFitEvenlyIntoShape:function(e,t){if(e.length!==t.length)throw new Error(`Cannot compute whether rank ${e.length} tiles fit evenly into rank ${t.length} shape - ranks must match.`);return t.every(((t,n)=>t%e[n]==0))}};const jn=t().getNumber("WEBGPU_CPU_HANDOFF_SIZE_THRESHOLD");class Qn extends r{nextDataId(){return Qn.nextDataId++}constructor(e,n){if(super(),this.commandQueueOwnedIds=new WeakSet,this.dispatchCountInPass=0,this.disposed=!1,this.downloadWaitMs=0,this.tensorDataPendingDisposal=[],this.queryResolveBuffer=null,this.querySet=null,this.querySetCount=2,this.stagingPendingDisposal=[],this.uniformPendingDisposal=[],this.uploadWaitMs=0,this.hasReadSyncWarned=!1,this.hasTimestampQueryWarned=!1,!Xn())throw new Error("WebGPU is not supported on this device");this.pipelineCache={},this.device=e,this.queue=e.queue,this.commandEncoder=null,this.computePassEncoder=null,this.adapterInfo=new yn(n),this.supportTimestampQuery=this.device.features.has("timestamp-query"),this.thresholdToIncreaseWorkgroups=this.adapterInfo.intelGPUGeneration>=12?16:8,this.bufferManager=new wn(this.device),this.textureManager=new Cn(this.device),this.tensorMap=new s(this,a()),t().getBool("WEBGPU_USE_PROFILE_TOOL")&&(this.dummyCanvas=document.createElement("canvas"),this.dummyCanvas.width=1,this.dummyCanvas.height=1,this.dummyContext=this.dummyCanvas.getContext("webgpu"),this.dummyContext.configure({device:e,format:"bgra8unorm"}),document.body.appendChild(this.dummyCanvas))}floatPrecision(){return 32}disposeData(e,t=!1){if(!this.tensorMap.has(e))return!0;const n=this.tensorMap.get(e);return t?n.refCount=0:n.refCount--,!(n.refCount>0)&&(null!=n.complexTensorInfos&&(this.disposeData(n.complexTensorInfos.real.dataId),this.disposeData(n.complexTensorInfos.imag.dataId)),this.commandQueueOwnedIds.has(e)?(this.tensorDataPendingDisposal.push(e),!0):(this.releaseResource(e),this.tensorMap.delete(e),!0))}memory(){return{numBytesInGPU:this.bufferManager.numBytesUsed,numBytesAllocatedInGPU:this.bufferManager.numBytesAllocated,unreliable:!1}}releaseResource(e){const t=this.tensorMap.get(e);t&&t.resource&&(t.external||(t.resource instanceof GPUBuffer?this.bufferManager.releaseBuffer(t.resource):t.resource instanceof GPUTexture&&this.textureManager.releaseTexture(t.resource)),t.resource=null)}refCount(e){if(this.tensorMap.has(e)){return this.tensorMap.get(e).refCount}return 0}incRef(e){this.tensorMap.get(e).refCount++}decRef(e){if(this.tensorMap.has(e)){this.tensorMap.get(e).refCount--}}write(e,t,n){if("complex64"===n&&null!=e)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");const i={id:this.nextDataId()};return this.tensorMap.set(i,{dtype:n,shape:t,values:e,refCount:1}),i}move(e,t,n,i,r){if("complex64"===i)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");this.tensorMap.set(e,{dtype:i,shape:n,values:t,refCount:r})}submitQueue(){this.queue.submit([this.commandEncoder.finish()]),this.commandEncoder=null,this.dispatchCountInPass=0,this.commandQueueOwnedIds=new WeakSet,this.tensorDataPendingDisposal.forEach((e=>{this.releaseResource(e),this.tensorMap.delete(e)})),this.uniformPendingDisposal.forEach((e=>this.bufferManager.releaseBuffer(e))),this.stagingPendingDisposal.forEach((e=>this.bufferManager.releaseBuffer(e,!1))),this.tensorDataPendingDisposal=[],this.uniformPendingDisposal=[],this.stagingPendingDisposal=[]}ensureCommandEncoderReady(){this.commandEncoder||(this.commandEncoder=this.device.createCommandEncoder())}endComputePassEncoder(){this.computePassEncoder&&(this.computePassEncoder.end(),this.computePassEncoder=null)}async checkCompileCompletionAsync(){let e;try{e=await Promise.all(Object.values(this.pipelineCache))}catch(e){throw new Error(e.message)}Object.keys(this.pipelineCache).map(((t,n)=>{this.pipelineCache[t]=e[n]}))}async getBufferData(e){if(t().getBool("WEBGPU_ENGINE_COMPILE_ONLY"))return console.warn("The data may be invalid since WEBGPU_ENGINE_COMPILE_ONLY is true, this can only be called when WEBGPU_ENGINE_COMPILE_ONLY is false"),null;const n=e.size,r=this.bufferManager.acquireBuffer(n,GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ);this.ensureCommandEncoderReady(),this.endComputePassEncoder(),this.commandEncoder.copyBufferToBuffer(e,0,r,0,n),this.submitQueue(),await r.mapAsync(GPUMapMode.READ);const s=r.getMappedRange().slice(0);return r.unmap(),null!=r&&this.bufferManager.releaseBuffer(r),t().getBool("WEBGPU_USE_PROFILE_TOOL")&&(i.assert(void 0!==this.dummyContext,(()=>"Fail to get context for profiling tool")),this.dummyContext.getCurrentTexture()),s}convertAndCacheOnCPU(e,t){const n=this.tensorMap.get(e);return n.values=t,n.values}readSync(e){const t=this.tensorMap.get(e),{values:r,complexTensorInfos:s}=t;if(null!=r||"string"===t.dtype)return r;if("complex64"===t.dtype){const t=this.readSync(s.real.dataId),r=this.readSync(s.imag.dataId),a=i.convertBackendValuesAndArrayBuffer(n.mergeRealAndImagArrays(t,r).buffer,"float32");return this.convertAndCacheOnCPU(e,a),a}this.hasReadSyncWarned||(this.hasReadSyncWarned=!0,console.warn("The performance of synchronously reading data from GPU to CPU is poor on the webgpu backend, please use asynchronous APIs instead."));const a=["opaque","premultiplied"],o=t.resource,u=o.size;i.assert(u%4==0,(()=>"Because there is 4 bytes for one pixel, buffer size must be multiple of 4."));const d=u/4,l=new ArrayBuffer(u),h=256,p=256,c=a.map((e=>new OffscreenCanvas(h,p))),f=new OffscreenCanvas(h,p);this.endComputePassEncoder(),c.map(((e,t)=>{const n=e.getContext("webgpu");return n.configure({device:this.device,format:"bgra8unorm",usage:GPUTextureUsage.COPY_DST,alphaMode:a[t]}),n.getCurrentTexture()})).map(((e,t)=>{const n=(n,i,r)=>{this.ensureCommandEncoderReady(),this.commandEncoder.copyBufferToTexture({buffer:o,bytesPerRow:1024,offset:r},{texture:e},{width:n,height:i}),this.submitQueue();const s=f.getContext("2d",{willReadFrequently:!0});s.clearRect(0,0,n,i),s.drawImage(c[t],0,0);const u=s.getImageData(0,0,n,i).data,d=a[t],h=new Uint8ClampedArray(l,r,n*i*4);for(let e=0;e<h.length;e+=4)if("premultiplied"===d)h[e+3]=u[e+3];else{const t=u[e];h[e]=u[e+2],h[e+1]=u[e+1],h[e+2]=t}},i=Math.floor(d/65536);let r=h,s=p,u=0;for(let e=0;e<i;e++)n(r,s,u),u+=262144;const m=d%65536;s=Math.floor(m/h),s>0&&(n(r,s,u),u+=1024*s),r=m%h,r>0&&n(r,1,u)}));const m=i.convertBackendValuesAndArrayBuffer(l,t.dtype);return this.convertAndCacheOnCPU(e,m),m}async read(e){if(!this.tensorMap.has(e))throw new Error(`Tensor ${e} was not registered!`);const t=this.tensorMap.get(e),{values:r}=t;if(null!=r)return r;let s;if("complex64"===t.dtype){const e=await Promise.all([this.read(t.complexTensorInfos.real.dataId),this.read(t.complexTensorInfos.imag.dataId)]),i=e[0],r=e[1];s=n.mergeRealAndImagArrays(i,r)}else{const e=await this.getBufferData(t.resource);s=i.convertBackendValuesAndArrayBuffer(e,t.dtype)}return this.convertAndCacheOnCPU(e,s),s}copyBuffer(e){const t=e.size,n=e.usage,i=this.bufferManager.acquireBuffer(t,n);return this.ensureCommandEncoderReady(),this.endComputePassEncoder(),this.commandEncoder.copyBufferToBuffer(e,0,i,0,t),this.submitQueue(),i}createTensorFromGPUData(e,t,n){let r=e.buffer;if("complex64"===n)throw new Error("Cannot write to a complex64 dtype. ");const s={id:this.nextDataId()};this.tensorMap.set(s,{dtype:n,shape:t,values:null,refCount:1,external:e.zeroCopy});const o=this.tensorMap.get(s),u=Hn(o.dtype)*i.sizeFromShape(o.shape);if(e.buffer.size<u)throw new Error(`GPUBuffer size(${e.buffer.size}) is smaller than tensor size(${u})!`);if((e.buffer.usage&(GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC))!=(GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC))throw new Error("GPUBuffer.usage should include GPUBufferUsage.STORAGE | GPUBufferUsage.COPY_SRC!");return!0!==e.zeroCopy&&(r=this.copyBuffer(r)),o.resource=r,a().makeTensorFromDataId(s,t,n,this)}readToGPU(e){const t=this.tensorMap.get(e),{values:n,dtype:i,shape:r,resource:s}=t;if("complex64"===i)throw new Error("Does not support reading buffer for complex64 dtype.");if(null==s)throw null!=n?new Error("Data is not on GPU but on CPU."):new Error("There is no data on GPU or CPU.");const o=s,u=o.size,d=o.usage,l=this.bufferManager.acquireBuffer(u,d);this.ensureCommandEncoderReady(),this.endComputePassEncoder(),this.commandEncoder.copyBufferToBuffer(s,0,l,0,u),this.submitQueue();const h=this.makeTensorInfo(r,i),p=a().makeTensorFromTensorInfo(h);return this.tensorMap.get(h.dataId).resource=l,{tensorRef:p,buffer:l}}bufferSync(e){const t=this.readSync(e.dataId);if("string"===e.dtype)try{const n=t.map((e=>i.decodeString(e)));return o(e.shape,e.dtype,n)}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8")}return o(e.shape,e.dtype,t)}async time(e){this.supportTimestampQuery||this.hasTimestampQueryWarned||(console.warn("This device doesn't support timestamp-query extension. Start Chrome browser with flag --disable-dawn-features=disallow_unsafe_apis to try it again. Otherwise, zero will be shown for the kernel time when profiling mode is enabled."),this.hasTimestampQueryWarned=!0);const t=this.activeTimers,n=[];let r=!1;null==this.programTimersStack?(this.programTimersStack=n,r=!0):this.activeTimers.push(n),this.activeTimers=n,e();const s=i.flatten(this.activeTimers.map((e=>e.query))).filter((e=>null!=e)),a=i.flatten(this.activeTimers.map((e=>e.name))).filter((e=>null!=e));this.activeTimers=t,r&&(this.programTimersStack=null);const o={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:null,wallMs:null},u=await Promise.all(s);return o.kernelMs=i.sum(u),o.getExtraProfileInfo=()=>u.map(((e,t)=>({name:a[t],ms:e}))).map((e=>`${e.name}: ${e.ms}`)).join(", "),this.uploadWaitMs=0,this.downloadWaitMs=0,o}makeTensorInfo(e,t,n){"string"===t&&null!=n&&n.length>0&&i.isString(n[0])&&(n=n.map((e=>i.encodeString(e))));return{dataId:this.write(n,e,t),shape:e,dtype:t}}tensorToBinding(e){if(!e)return null;const t=this.tensorMap.get(e.dataId).resource;return t instanceof GPUBuffer?{buffer:t}:t instanceof GPUTexture?t.createView():t}uploadToGPU(e){const t=this.tensorMap.get(e);if(null!=t.resource)return;const n=Hn(t.dtype)*i.sizeFromShape(t.shape);let r;const s=GPUBufferUsage.STORAGE|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST;if(t.values){if(r=this.bufferManager.acquireBuffer(n,s,!0),"unmapped"===r.mapState){const e=this.bufferManager.acquireBuffer(n,GPUBufferUsage.MAP_WRITE|GPUBufferUsage.COPY_SRC,!0,!1),i=e.getMappedRange();"int32"===t.dtype||"bool"===t.dtype?new Int32Array(i).set(t.values):new Float32Array(i).set(t.values),e.unmap(),this.ensureCommandEncoderReady(),this.endComputePassEncoder(),this.commandEncoder.copyBufferToBuffer(e,0,r,0,n),this.stagingPendingDisposal.push(e)}else{const e=r.getMappedRange();"int32"===t.dtype||"bool"===t.dtype?new Int32Array(e).set(t.values):new Float32Array(e).set(t.values),r.unmap()}t.values=null}else r=this.bufferManager.acquireBuffer(n,s);t.resource=r}makeUniforms(e){let t=0,n=0;const r=[];let s=1;e.forEach((e=>{let a;switch(0===e.data.length&&(e.data=[1]),e.data.length){case 1:a=4;break;case 2:a=8;break;case 3:case 4:case 5:case 6:a=16;break;default:i.assert(!1,(()=>`Unsupported ${e.data.length}D shape`))}5!==n&&6!==n||(a=16),a>s&&(s=a),t=Math.ceil(t/a)*a,n=e.data.length,r.push(t),t+=4*e.data.length})),t=Math.ceil(t/s)*s;const a=new ArrayBuffer(t);e.forEach(((e,t)=>{const n=r[t];"int32"===e.type?new Int32Array(a,n,e.data.length).set(e.data):"uint32"===e.type?new Uint32Array(a,n,e.data.length).set(e.data):new Float32Array(a,n,e.data.length).set(e.data)}));const o=this.bufferManager.acquireBuffer(t,GPUBufferUsage.COPY_DST|GPUBufferUsage.UNIFORM);return this.queue.writeBuffer(o,0,a,0,t),this.uniformPendingDisposal.push(o),{offset:0,size:t,buffer:o}}runWebGPUProgram(e,r,s,a,o){if(o||(o=this.makeTensorInfo(e.outputShape,s)),0===i.sizeFromShape(o.shape))return this.tensorMap.get(o.dataId).values=i.getTypedArrayFromDType(o.dtype,0),o;this.uploadToGPU(o.dataId),e.dispatch=((e,t)=>{const n=e.limits.maxComputeWorkgroupsPerDimension,r=t.dispatchLayout,s=t.dispatch;if(s.every((e=>e<=n)))return s;i.assert(s[0]>n&&void 0===r.y&&void 0===r.z,(()=>"Dispatch size exceeds WebGPU limits in Y or Z dimension."));let a=Math.ceil(Math.sqrt(s[0]));return a>n?(a=Math.ceil(Math.cbrt(s[0])),i.assert(a<=n,(()=>"Total dispatch size exceeds WebGPU maximum.")),[a,a,a]):[a,a,1]})(this.device,e);const u=r.map(((t,n)=>{if("complex64"===t.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");return this.uploadToGPU(t.dataId),{dtype:this.tensorMap.get(t.dataId).dtype,shape:t.shape,name:e.variableNames[n]}}));e.shaderKey=function(e,t,r){let s=e.shaderKey;if(e.isFromPixels)return s;const a=[],o=[];t.forEach((e=>{a.push(e.shape),o.push(e.dtype)})),a.push(r.shape),o.push(r.dtype);const u=t.map((e=>n.getBroadcastDims(e.shape,r.shape))),d=t.map((e=>i.arraysEqual(e.shape,r.shape))).join("_"),l=u.map((e=>e.join("_"))).join(";"),h=Wn(e)?"flatDispatch":"";return s+="_"+(e.workgroupSize?e.workgroupSize.join(","):"")+a.map((e=>e.length)).join(",")+o.join(",")+e.variableNames.join(",")+l+d+h,s}(e,u,o);const d=t().getBool("WEBGPU_ENGINE_COMPILE_ONLY");return e.shaderKey in this.pipelineCache||(this.pipelineCache[e.shaderKey]=Rn(this.device,e,u,o,d)),e.pipeline=this.pipelineCache[e.shaderKey],d||this.recordAndSubmit(e,o,r,a),o}recordAndSubmit(e,n,r,s){if(e.pipeline instanceof Promise)throw new Error("Please call checkCompileCompletionAsync to ensure parallel compilation is done!");let a=[],o=[];if(!e.isFromPixels){a.push({type:"float32",data:[NaN]},{type:"float32",data:[1/0]}),o=r.concat(n).map((e=>e.shape));const t="int32";if(o.map((e=>{a.push({type:t,data:e});const n=i.computeStrides(e);a.push({type:t,data:n})})),e.size){const n=i.sizeFromShape(e.outputShape);a.push({type:t,data:[e.outputComponent?n/e.outputComponent:n]})}}s&&(a=[...a,...s]);const u=[this.tensorToBinding(n),...r.map((e=>this.tensorToBinding(e))),this.makeUniforms(a)];r.forEach((e=>{this.commandQueueOwnedIds.add(e.dataId)})),this.commandQueueOwnedIds.add(n.dataId);const d=this.device.createBindGroup({layout:e.pipeline.getBindGroupLayout(0),entries:u.map(((e,t)=>({binding:t,resource:e})))}),l=null!=this.activeTimers;this.ensureCommandEncoderReady();const h={};l&&this.supportTimestampQuery?(this.endComputePassEncoder(),null==this.querySet&&(this.querySet=this.device.createQuerySet({type:"timestamp",count:this.querySetCount})),h.timestampWrites=[{querySet:this.querySet,queryIndex:0,location:"beginning"},{querySet:this.querySet,queryIndex:1,location:"end"}],this.computePassEncoder=this.commandEncoder.beginComputePass(h)):this.computePassEncoder||(this.computePassEncoder=this.commandEncoder.beginComputePass(h)),this.computePassEncoder.setPipeline(e.pipeline),this.computePassEncoder.setBindGroup(0,d),this.computePassEncoder.dispatchWorkgroups(e.dispatch[0],e.dispatch[1],e.dispatch[2]),this.dispatchCountInPass++,(l||t().get("WEBGPU_DEFERRED_SUBMIT_BATCH_SIZE")<=this.dispatchCountInPass)&&(this.endComputePassEncoder(),l?this.activeTimers.push({name:e.constructor.name,query:this.getQueryTime()}):this.submitQueue())}async getQueryTime(){if(!this.supportTimestampQuery)return 0;null==this.queryResolveBuffer&&(this.queryResolveBuffer=this.bufferManager.acquireBuffer(8*this.querySetCount,GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST|GPUBufferUsage.QUERY_RESOLVE)),this.commandEncoder.resolveQuerySet(this.querySet,0,this.querySetCount,this.queryResolveBuffer,0);const e=this.bufferManager.acquireBuffer(8*this.querySetCount,GPUBufferUsage.MAP_READ|GPUBufferUsage.COPY_DST);this.commandEncoder.copyBufferToBuffer(this.queryResolveBuffer,0,e,0,8*this.querySetCount),this.submitQueue(),await e.mapAsync(GPUMapMode.READ);const t=new BigUint64Array(e.getMappedRange()),n=Number(t[1]-t[0])/1e6;return e.unmap(),this.bufferManager.releaseBuffer(e),n}shouldExecuteOnCPU(e,n=jn){return t().getBool("WEBGPU_CPU_FORWARD")&&e.every((e=>null==this.tensorMap.get(e.dataId).resource&&i.sizeFromShape(e.shape)<n))}numDataIds(){return this.tensorMap.numDataIds()-this.tensorDataPendingDisposal.length}dispose(){this.disposed||(null!=this.querySet&&this.querySet.destroy(),this.bufferManager.dispose(),this.textureManager.dispose(),this.disposed=!0)}}var Zn;Qn.nextDataId=0,Xn()&&u("webgpu",(async()=>{const e={powerPreference:t().get("WEBGPU_USE_LOW_POWER_GPU")?"low-power":"high-performance"},n=await navigator.gpu.requestAdapter(e),i={};n.features.has("timestamp-query")&&(i.requiredFeatures=["timestamp-query"]);const r=n.limits;i.requiredLimits={maxComputeWorkgroupStorageSize:r.maxComputeWorkgroupStorageSize,maxComputeWorkgroupsPerDimension:r.maxComputeWorkgroupsPerDimension,maxStorageBufferBindingSize:r.maxStorageBufferBindingSize,maxBufferSize:r.maxBufferSize,maxComputeWorkgroupSizeX:r.maxComputeWorkgroupSizeX,maxComputeInvocationsPerWorkgroup:r.maxComputeInvocationsPerWorkgroup};const s=await n.requestDevice(i),a=await n.requestAdapterInfo();return new Qn(s,a)}),3),function(e){e[e.ADD=0]="ADD",e[e.ATAN2=1]="ATAN2",e[e.COMPLEX_MULTIPLY_IMAG=2]="COMPLEX_MULTIPLY_IMAG",e[e.COMPLEX_MULTIPLY_REAL=3]="COMPLEX_MULTIPLY_REAL",e[e.DIV=4]="DIV",e[e.ELU_DER=5]="ELU_DER",e[e.EQUAL=6]="EQUAL",e[e.GREATER=7]="GREATER",e[e.GREATER_EQUAL=8]="GREATER_EQUAL",e[e.INT_DIV=9]="INT_DIV",e[e.LESS=10]="LESS",e[e.LESS_EQUAL=11]="LESS_EQUAL",e[e.LOGICAL_AND=12]="LOGICAL_AND",e[e.LOGICAL_OR=13]="LOGICAL_OR",e[e.MAX=14]="MAX",e[e.MIN=15]="MIN",e[e.MOD=16]="MOD",e[e.MUL=17]="MUL",e[e.NOT_EQUAL=18]="NOT_EQUAL",e[e.POW=19]="POW",e[e.PRELU=20]="PRELU",e[e.SQUARED_DIFFERENCE=21]="SQUARED_DIFFERENCE",e[e.SUB=22]="SUB"}(Zn||(Zn={}));function Jn(e,t){let n;do{switch(e){case Zn.ATAN2:n="var resultTemp = atan2(a, b);";break;case Zn.MAX:n="var resultTemp = max(a, b);";break;case Zn.MIN:n="var resultTemp = min(a, b);";break;case Zn.MOD:n=t?"\n  let isNaN = !vec4<bool>(b);\n  var resultTemp = vec4<f32>(a % b);\n  if (!((a[0] < 0. && b[0] < 0.) || (a[0] >= 0. && b[0] > 0.))) {\n    resultTemp[0] = (resultTemp[0] + b[0]) % b[0];\n  }\n  if (!((a[1] < 0. && b[1] < 0.) || (a[1] >= 0. && b[1] > 0.))) {\n    resultTemp[1] = (resultTemp[1] + b[1]) % b[1];\n  }\n  if (!((a[2] < 0. && b[2] < 0.) || (a[2] >= 0. && b[2] > 0.))) {\n    resultTemp[2] = (resultTemp[2] + b[2]) % b[2];\n  }\n  if (!((a[3] < 0. && b[3] < 0.) || (a[3] >= 0. && b[3] > 0.))) {\n    resultTemp[3] = (resultTemp[3] + b[3]) % b[3];\n  }\n":"\n  let isNaN = b == 0.;\n  var resultTemp = a % b;\n  resultTemp = select((resultTemp + b) % b, resultTemp,\n      (a < 0. && b < 0.) || (a >= 0. && b > 0.));\n";break;case Zn.NOT_EQUAL:n=t?"\n  var resultTemp = vec4<f32>(a != b);\n  let valueForNaN = 1.0;\n":"\n  var resultTemp = f32(a != b);\n  let valueForNaN = 1.0;\n";break;case Zn.POW:n=t?"\n  let isModRound1Bool = vec4<i32>(round(abs(b) % vec4<f32>(2.0))) == vec4<i32>(1);\n  let isModRound1 = vec4<f32>(isModRound1Bool);\n  let multiplier = sign(a) * isModRound1 + (vec4<f32>(1.0) - isModRound1);\n  var resultTemp = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  let isExpZero = b == vec4<f32>(0.0);\n  if (isExpZero.r) {\n    resultTemp.r = 1.0;\n  }\n  if (isExpZero.g) {\n    resultTemp.g = 1.0;\n  }\n  if (isExpZero.b) {\n    resultTemp.b = 1.0;\n  }\n  if (isExpZero.a) {\n    resultTemp.a = 1.0;\n  }\n  let isNaN = (a < vec4<f32>(0.0)) & (floor(b) < b);\n":"\n  let isNaN = a < 0.0 && floor(b) < b;\n  if (b == 0.0) {\n    return 1.0;\n  }\n  var resultTemp = select(sign(a) * pow(abs(a), b), pow(abs(a), b),\n      round(abs(b) % 2.0) != 1.0);\n";break;default:continue}let i,r,s;return t?(i="isnanVec4",r="vec4<f32>",s="vec4<bool>"):(i="isnan",r="f32",s="bool"),`\n      let aIsNaN = ${i}(a);\n      let aPostLegalization = select(a, ${r}(42), aIsNaN);\n      let bIsNaN = ${i}(b);\n      let bPostLegalization = select(b, ${r}(42), bIsNaN);\n      let isNaN = false;\n      let valueForNaN = uniforms.NAN;\n      {\n        let a = aPostLegalization;\n        let b = bPostLegalization;\n        ${n}\n        return select(\n            resultTemp, ${r}(valueForNaN),\n            ${s}(isNaN) | aIsNaN | bIsNaN);\n      }\n    `}while(0);switch(e){case Zn.ADD:return"return a + b;";case Zn.COMPLEX_MULTIPLY_IMAG:return"return areal * bimag + aimag * breal;";case Zn.COMPLEX_MULTIPLY_REAL:return"return areal * breal - aimag * bimag;";case Zn.DIV:return"return a / b;";case Zn.ELU_DER:return t?"return select(a * (b + vec4<f32>(1.0)), a, b >= vec4<f32>(0.));":"return select(a * (b + 1.0), a, b >= 0.);";case Zn.EQUAL:return t?"return vec4<f32>(a == b);":"return f32(a == b);";case Zn.GREATER:return t?"return vec4<f32>(a > b);":"return f32(a > b);";case Zn.GREATER_EQUAL:return t?"return vec4<f32>(a >= b);":"return f32(a >= b);";case Zn.INT_DIV:return t?"\n  let ia = vec4<i32>(round(a));\n  let ib = vec4<i32>(round(b));\n  let cond = ib != vec4<i32>(0);\n  var resultTemp = vec4<i32>(0);\n  let s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    resultTemp[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    resultTemp[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    resultTemp[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    resultTemp[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4<f32>(resultTemp);\n":"\n  let s = sign(a) * sign(b);\n  let ia = i32(round(a));\n  let ib = i32(round(b));\n  return f32(idiv(ia, ib, s));\n";case Zn.LESS:return t?"return vec4<f32>(a < b);":"return f32(a < b);";case Zn.LESS_EQUAL:return t?"return vec4<f32>(a <= b);":"return f32(a <= b);";case Zn.LOGICAL_AND:return t?"return (vec4<f32>(a >= vec4<f32>(1.0)) *\n  vec4<f32>(b >= vec4<f32>(1.0)));":"return f32(a >= 1.0 && b >= 1.0);";case Zn.LOGICAL_OR:return t?"return min(vec4<f32>(a >= vec4<f32>(1.0)) +\n  vec4<f32>(b >= vec4<f32>(1.0)), vec4<f32>(1.0));":"return f32(a >= 1.0 || b >= 1.0);";case Zn.MUL:return"return a * b;";case Zn.PRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (b * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n":"if (a < 0.0) { return b * a; }  return a;";case Zn.SQUARED_DIFFERENCE:return"return (a - b) * (a - b);";case Zn.SUB:return"return a - b;"}return`\n    ${n}\n    return resultTemp;\n  `}var ei;!function(e){e[e.ABS=0]="ABS",e[e.ACOS=1]="ACOS",e[e.ACOSH=2]="ACOSH",e[e.ASIN=3]="ASIN",e[e.ASINH=4]="ASINH",e[e.ATAN=5]="ATAN",e[e.ATANH=6]="ATANH",e[e.CEIL=7]="CEIL",e[e.COS=8]="COS",e[e.COSH=9]="COSH",e[e.ELU=10]="ELU",e[e.ERF=11]="ERF",e[e.EXP=12]="EXP",e[e.EXPM1=13]="EXPM1",e[e.FLOOR=14]="FLOOR",e[e.IS_FINITE=15]="IS_FINITE",e[e.IS_INF=16]="IS_INF",e[e.IS_NAN=17]="IS_NAN",e[e.LINEAR=18]="LINEAR",e[e.LOG=19]="LOG",e[e.LOG1P=20]="LOG1P",e[e.LOGICAL_NOT=21]="LOGICAL_NOT",e[e.NEG=22]="NEG",e[e.RELU=23]="RELU",e[e.RELU6=24]="RELU6",e[e.LEAKYRELU=25]="LEAKYRELU",e[e.RECIPROCAL=26]="RECIPROCAL",e[e.ROUND=27]="ROUND",e[e.RSQRT=28]="RSQRT",e[e.SELU=29]="SELU",e[e.SIGMOID=30]="SIGMOID",e[e.SIGN=31]="SIGN",e[e.SIN=32]="SIN",e[e.SINH=33]="SINH",e[e.SOFTPLUS=34]="SOFTPLUS",e[e.SQRT=35]="SQRT",e[e.SQUARE=36]="SQUARE",e[e.STEP=37]="STEP",e[e.TAN=38]="TAN",e[e.TANH=39]="TANH",e[e.TO_INT=40]="TO_INT"}(ei||(ei={}));const ti=`\n  // Error function is calculated approximately with elementary function.\n  // See "Handbook of Mathematical Functions with Formulas,\n  // Graphs, and Mathematical Tables", Abramowitz and Stegun.\n  let p = ${n.ERF_P};\n  let a1 = ${n.ERF_A1};\n  let a2 = ${n.ERF_A2};\n  let a3 = ${n.ERF_A3};\n  let a4 = ${n.ERF_A4};\n  let a5 = ${n.ERF_A5};\n\n  let sign = sign(a);\n  let absA = abs(a);\n  let t = 1.0 / (1.0 + p * absA);\n  return sign * (1.0 - (((((a5 * t + a4) * t) + a3) * t + a2) * t + a1) * t * exp(-absA * absA));\n`,ni=`\n  if (a >= 0.0) {\n    return ${n.SELU_SCALE} * a;\n  } else {\n    return ${n.SELU_SCALEALPHA} * (exp(a) - 1.0);\n  }\n`;function ii(e,t){switch(e){case ei.ABS:return"return abs(a);";case ei.ACOS:return"\n  if (abs(a) > 1.) {\n    return uniforms.NAN;\n  }\n  return acos(a);\n";case ei.ACOSH:return"\n  if (a < 1.) {\n    return uniforms.NAN;\n  }\n  return acosh(a);\n";case ei.ASIN:return"\n  if (abs(a) > 1.) {\n    return uniforms.NAN;\n  }\n  return asin(a);\n";case ei.ASINH:return"return asinh(a);";case ei.ATAN:return"\n  if (isnan(a)) {\n    return uniforms.NAN;\n  }\n  return atan(a);\n";case ei.ATANH:return"\n  if (abs(a) > 1.) {\n    return uniforms.NAN;\n  }\n  if (a == 1.) {\n    return uniforms.INFINITY;\n  }\n  if (a == -1.) {\n    return -uniforms.INFINITY;\n  }\n  return atanh(a);\n";case ei.COS:return"return cos(a);";case ei.COSH:return"\n  let e2x = exp(-a);\n  return (e2x + 1.0 / e2x) / 2.0;\n";case ei.CEIL:return"return ceil(a);";case ei.ELU:return t?"\n  var resFloat = exp(a) - vec4<f32>(1.0);\n  if (a.r >= 0.0) {\n    resFloat.r = a.r;\n  }\n  if (a.g >= 0.0) {\n    resFloat.g = a.g;\n  }\n  if (a.b >= 0.0) {\n    resFloat.b = a.b;\n  }\n  if (a.a >= 0.0) {\n    resFloat.a = a.a;\n  }\n  return resFloat;\n":"if (a >= 0.0) { return a; }  return (exp(a) - 1.0);";case ei.ERF:return ti;case ei.EXP:return"return exp(a);";case ei.EXPM1:return"return exp(a) - 1.0;";case ei.FLOOR:return"return floor(a);";case ei.IS_FINITE:return"return f32(!isnan(a) && !isinf(a));";case ei.IS_INF:return"return f32(isinf(a));";case ei.IS_NAN:return"return f32(isnan(a));";case ei.LINEAR:return"return a;";case ei.LOG:return"if (a < 0.0) { return uniforms.NAN; }\n  return log(a);";case ei.LOG1P:return"\n  if (isnan(a)) { return a; }\n  return log(1.0 + a);\n";case ei.LOGICAL_NOT:return"return f32(!(a >= 1.0));";case ei.NEG:return"return -a;";case ei.LEAKYRELU:return t?"\n  let aLessThanZero = vec4<f32>(a < vec4<f32>(0.0));\n  return (aLessThanZero * (uniforms.alpha * a)) + ((vec4<f32>(1.0) - aLessThanZero) * a);\n":"if (a < 0.0) { return uniforms.alpha * a; } return a;";case ei.RECIPROCAL:return"return 1.0 / a;";case ei.RELU:return t?"\n  return select(a, vec4<f32>(0.0), a < vec4<f32>(0.0));\n":"return select(a, 0.0, a < 0.0);";case ei.RELU6:return t?"return clamp(a, vec4<f32>(0.0, 0.0, 0.0, 0.0), vec4<f32>(6.0, 6.0, 6.0, 6.0));":"return clamp(a, 0.0, 6.0);";case ei.ROUND:return"return round(a);";case ei.RSQRT:return"return inverseSqrt(a);";case ei.SELU:return ni;case ei.SIGMOID:return"return 1.0 / (1.0 + exp(-1.0 * a));";case ei.SIGN:return"return sign(a);";case ei.SIN:return"return sin(a);";case ei.SINH:return"\n  let e2x = exp(a);\n  return (e2x - 1.0 / e2x) / 2.0;\n";case ei.SOFTPLUS:return"\n  let epsilon = 1.1920928955078125e-7;\n  let threshold = log(epsilon) + 2.0;\n\n  let too_large = a > -threshold;\n  let too_small = a < threshold;\n  let exp_a = exp(a);\n\n  if (too_large) {\n    return a;\n  } else if (too_small) {\n    return exp_a;\n  } else {\n    return log(exp_a + 1.0);\n  }\n";case ei.SQRT:return"return sqrt(a);";case ei.SQUARE:return"return a * a;";case ei.STEP:return"\n  if (isnan(a)) {\n    return a;\n  }\n\n  return select(uniforms.stepAlpha, 1.0, a > 0.0);\n";case ei.TAN:return"return tan(a);";case ei.TANH:return"\n  let e2x = exp(-2.0 * abs(a));\n  return sign(a) * (1.0 - e2x) / (1.0 + e2x);\n";case ei.TO_INT:return"return f32(i32((a)));";default:throw new Error(`BinaryType ${e} is not implemented!`)}}function ri(e,t=!1,n=!1,i=3){if(null===e)return"";let r="";if("linear"===e)r=ii(ei.LINEAR);else if("relu"===e)r=ii(ei.RELU,n);else if("elu"===e)r=ii(ei.ELU,n);else if("relu6"===e)r=ii(ei.RELU6,n);else if("prelu"===e)r=Jn(Zn.PRELU,n);else if("sigmoid"===e)r=ii(ei.SIGMOID,n);else{if("leakyrelu"!==e)throw new Error(`Activation ${e} has not been implemented for the WebGPU backend.`);r=ii(ei.LEAKYRELU,n)}const s=$n(n?4:1);let a="";return a=t?`\n      fn activation(a : ${s}, coords : vec${i}<i32>) -> ${s} {\n        let b = getPreluActivationWeightsByOutputCoords(coords);\n        ${r}\n      }`:`\n      fn activation(a : ${s}, coords : vec${i}<i32>) -> ${s} {\n        ${r}\n      }`,a}function si(e,t){return`\n      ${e?"value = value + getBiasByOutputCoords(coords);":""}\n      ${t?"value = activation(value, coords);":""}\n      `}function ai(e,t,n=!1,r=!1,s=!1,a=1){i.assert(e&&1===a||!e,(()=>`transposeA ${e} is not compatible with component size ${a}`));const o=`\n      ${e?"value = getA(batch, col, row);":"value = getA(batch, row, col);"}\n\n    `,u=t?"value = getB(batch, col, row);":"value = getB(batch, row, col);";return`\n  fn mm_readA(batch: i32, row: i32, colIn: i32) -> ${$n(a)} {\n    var value = ${$n(a)}(0.0);\n    let col = colIn * ${a};\n    ${n&&s?o:`\n    ${e?"if(row < uniforms.dimAOuter && col < uniforms.dimInner)":"if(row < uniforms.aShape[1] && col < uniforms.aShape[2])"}\n    {\n      ${o}\n    }\n    `}\n    return value;\n  }\n\n  fn mm_readB(batch: i32, row: i32, colIn: i32) -> ${$n(a)} {\n    let col = colIn * ${a};\n    var value = ${$n(a)}(0.0);\n    ${u}\n    return value;\n  }\n  `}function oi(e,t,n,i,r=!1,s=!1,a=!1,o=1){return`\n  ${ai(n,i,r,s,a,o)}\n  fn mm_write(batch: i32, row: i32, colIn: i32, valueIn: ${$n(o)}) {\n    let col = colIn * ${o};\n    ${r&&s?"":"if (row < uniforms.dimAOuter && col < uniforms.dimBOuter)"}\n    {\n      var value = valueIn;\n      let coords = vec3<i32>(batch, row, col);\n      ${si(e,t)}\n      setOutputAtCoords(coords[0], coords[1], coords[2], value);\n    }\n  }\n  `}function ui(e,t,n=!1,r=32,s=!1,a=32,o=!1){const u=t[1]*e[1],d=t[0]*e[0],l=n?u:r,h=n?r:u,p=l/t[0],c=r/t[1],f=e[1];return i.assert((n&&4===p&&4===e[1]||!n&&(3===p||4===p))&&l%t[0]==0&&r%t[1]==0&&4===e[0],(()=>`If transposeA ${n} is true, innerElementSize ${p} and workPerThread[1] ${e[1]} must be 4.\n          Otherwise, innerElementSize ${p} must be 3 or 4.\n      tileAWidth ${l} must be divisible by workgroupSize[0]${t[0]}. tileInner ${r} must be divisible by workgroupSize[1] ${t[1]}. colPerThread ${e[0]} must be 4.`)),`\n  var<workgroup> mm_Asub : array<array<vec${p}<f32>, ${l/p}>, ${h}>;\n  var<workgroup> mm_Bsub : array<array<vec4<f32>, ${d/e[0]}>, ${r}>;\n\n  ${An()} {\n    let localRow = i32(localId.y);\n    let tileRow = localRow * ${f};\n    let tileCol = i32(localId.x);\n\n    let globalRow = i32(globalId.y) * ${f};\n    let globalCol = i32(globalId.x);\n    let batch = ${s?"0":"i32(globalId.z)"};\n    let batchA = ${s||!o?"batch":"batch % uniforms.aShape[0]"};\n    let batchB = ${s||!o?"batch":"batch % uniforms.bShape[0]"};\n    let globalRowStart = i32(workgroupId.y) * ${u};\n\n    let numTiles = ${s?`${Math.ceil(a/r)}`:`(uniforms.dimInner - 1) / ${r} + 1`};\n    var kStart = ${s?`i32(globalId.z) * ${a}`:"0"};\n\n    var acc: array<vec4<f32>, ${f}>;\n\n    // Loop over shared dimension.\n    let tileRowB = localRow * ${c};\n    for (var t = 0; t < numTiles; t++) {\n        // Load one tile of A into local memory.\n        for (var innerRow = 0; innerRow < ${f}; innerRow++) {\n            let inputRow = tileRow + innerRow;\n            let inputCol = tileCol;\n            ${((e,t)=>e?`\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          kStart + inputRow,\n          globalRowStart / ${t} + inputCol);\n        `:`\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          globalRow + innerRow,\n          kStart / ${t} + inputCol);\n        `)(n,p)}\n        }\n\n        // Load one tile of B into local memory.\n        for (var innerRow = 0; innerRow < ${c}; innerRow++) {\n            let inputRow = tileRowB + innerRow;\n            let inputCol = tileCol;\n            mm_Bsub[inputRow][inputCol] = mm_readB(batchB, kStart + inputRow, globalCol);\n        }\n        kStart = kStart + ${r};\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < ${r/p}; k++) {\n            let BCached0 = mm_Bsub[k * ${p}][tileCol];\n            let BCached1 = mm_Bsub[k * ${p} + 1][tileCol];\n            let BCached2 = mm_Bsub[k * ${p} + 2][tileCol];\n            ${3===p?"":`let BCached3 = mm_Bsub[k * ${p} + 3][tileCol];`}\n\n            ${((e,t,n)=>e?`\n        let ACached0 = mm_Asub[k * ${t}][localRow];\n        let ACached1 = mm_Asub[k * ${t} + 1][localRow];\n        let ACached2 = mm_Asub[k * ${t} + 2][localRow];\n        ${3===t?"":`let ACached3 = mm_Asub[k * ${t} + 3][localRow];`}\n        for (var i = 0; i < ${n}; i++) {\n          acc[i] = fma(BCached0, vec4<f32>(ACached0[i]), acc[i]);\n          acc[i] = fma(BCached1, vec4<f32>(ACached1[i]), acc[i]);\n          acc[i] = fma(BCached2, vec4<f32>(ACached2[i]), acc[i]);\n          ${3===t?"":"acc[i] = fma(BCached3, vec4<f32>(ACached3[i]), acc[i]);"}\n        }`:`\n        for (var i = 0; i < ${n}; i++) {\n          let ACached = mm_Asub[tileRow + i][k];\n          acc[i] = fma(BCached0, vec4<f32>(ACached.x), acc[i]);\n          acc[i] = fma(BCached1, vec4<f32>(ACached.y), acc[i]);\n          acc[i] = fma(BCached2, vec4<f32>(ACached.z), acc[i]);\n          ${3===t?"":"acc[i] = fma(BCached3, vec4<f32>(ACached.w), acc[i]);"}\n        }`)(n,p,f)}\n        }\n\n        workgroupBarrier();\n    }\n\n    for (var innerRow = 0; innerRow < ${f}; innerRow++) {\n        mm_write(batch, globalRow + innerRow, globalCol, acc[innerRow]);\n    }\n  }`}const di=e=>e?"\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          kStart + inputRow,\n          globalRowStart + inputCol);\n        ":"\n        mm_Asub[inputRow][inputCol] = mm_readA(batchA,\n          globalRowStart + inputRow,\n          kStart + inputCol);\n        ";function li(e,t,n=!1,r=32,s=!1,a=32,o=!1,u=!1){const d=e[1]*t[1],l=e[0]*t[0],h=n?d:r,p=n?r:d;i.assert(p%t[1]==0&&h%t[0]==0&&r%t[1]==0,(()=>`tileAHight ${p} must be divisible by workgroupSize[1]${t[1]}, tileAWidth ${h} must be divisible by workgroupSize[0]${t[0]}, tileInner ${r} must be divisible by workgroupSize[1]${t[1]}`));const c=p/t[1],f=h/t[0],m=r/t[1],g=e[1],x=e[0],y=o?`\n      let localRow = i32(localId.y);\n      let localCol = i32(localId.x);\n      let globalRowStart = i32(workgroupId.y) * ${d};\n      let globalColStart = i32(workgroupId.x) * ${l};\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t++) {\n        // Load one tile of A into local memory.\n        for (var inputRow = localRow; inputRow < ${p}; inputRow = inputRow + ${t[1]}) {\n          for (var inputCol = localCol; inputCol < ${h}; inputCol = inputCol + ${t[0]}) {\n            ${di(n)}\n          }\n        }\n        // Load one tile of B into local memory.\n        for (var inputRow = localRow; inputRow < ${r}; inputRow = inputRow + ${t[1]}) {\n              for (var inputCol = localCol; inputCol < ${l}; inputCol = inputCol + ${t[0]}) {\n            mm_Bsub[inputRow][inputCol] = mm_readB(batchB,\n              kStart + inputRow,\n              globalColStart + inputCol);\n          }\n        }\n        kStart = kStart + ${r};\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        var BCached : array<f32, ${x}>;\n        for (var k = 0; k < ${r}; k++) {\n          for (var inner = 0; inner < ${x}; inner++) {\n            BCached[inner] = mm_Bsub[k][localCol + inner * ${t[0]}];\n          }\n          for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n            let ACached = ${n?`mm_Asub[k][localRow + innerRow * ${t[1]}];`:`mm_Asub[localRow + innerRow * ${t[1]}][k];`}\n            for (var innerCol = 0; innerCol < ${x}; innerCol++) {\n              acc[innerRow][innerCol] =\n                  fma(ACached, BCached[innerCol], acc[innerRow][innerCol]);\n            }\n          }\n        }\n        workgroupBarrier();\n      }\n      for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n        let gRow = globalRowStart + localRow + innerRow * ${t[1]};\n        for (var innerCol = 0; innerCol < ${x}; innerCol++) {\n          let gCol = globalColStart + localCol + innerCol * ${t[0]};\n          mm_write(batch, gRow, gCol, acc[innerRow][innerCol]);\n        }\n      }\n      `:`\n  let tileRow = i32(localId.y) * ${g};\n  let tileCol = i32(localId.x) * ${x};\n\n  let globalRow = i32(globalId.y) * ${g};\n  let globalCol = i32(globalId.x) * ${x};\n  let globalRowStart = i32(workgroupId.y) * ${d};\n\n  let tileRowA = i32(localId.y) * ${c};\n  let tileColA = i32(localId.x) * ${f};\n  let tileRowB = i32(localId.y) * ${m};\n  // Loop over shared dimension.\n  for (var t = 0; t < numTiles; t++) {\n    // Load one tile of A into local memory.\n    for (var innerRow = 0; innerRow < ${c}; innerRow++) {\n      for (var innerCol = 0; innerCol < ${f}; innerCol++) {\n        let inputRow = tileRowA + innerRow;\n        let inputCol = tileColA + innerCol;\n        ${di(n)}\n      }\n    }\n\n    // Load one tile of B into local memory.\n    for (var innerRow = 0; innerRow < ${m}; innerRow++) {\n      for (var innerCol = 0; innerCol < ${x}; innerCol++) {\n        let inputRow = tileRowB + innerRow;\n        let inputCol = tileCol + innerCol;\n        mm_Bsub[inputRow][inputCol] = mm_readB(batchB,\n          kStart + inputRow,\n          globalCol + innerCol);\n      }\n    }\n    kStart = kStart + ${r};\n    workgroupBarrier();\n\n    // Compute acc values for a single thread.\n    var BCached : array<f32, ${x}>;\n    for (var k = 0; k < ${r}; k++) {\n      for (var inner = 0; inner < ${x}; inner++) {\n        BCached[inner] = mm_Bsub[k][tileCol + inner];\n      }\n\n      for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n        ${(e=>e?"let ACached = mm_Asub[k][tileRow + innerRow];":"let ACached = mm_Asub[tileRow + innerRow][k];")(n)}\n        for (var innerCol = 0; innerCol < ${x}; innerCol++) {\n          acc[innerRow][innerCol] =\n              fma(ACached, BCached[innerCol], acc[innerRow][innerCol]);\n        }\n      }\n    }\n\n    workgroupBarrier();\n  }\n\n  for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n    for (var innerCol = 0; innerCol < ${x}; innerCol++) {\n      mm_write(batch, globalRow + innerRow, globalCol + innerCol,\n          acc[innerRow][innerCol]);\n    }\n  }\n  `;return`\n    var<workgroup> mm_Asub : array<array<f32, ${h}>, ${p}>;\n    var<workgroup> mm_Bsub : array<array<f32, ${l}>, ${r}>;\n\n    ${An()} {\n      let batch = ${s?"0":"i32(globalId.z)"};\n      let batchA = ${s||!u?"batch":"batch % uniforms.aShape[0]"};\n      let batchB = ${s||!u?"batch":"batch % uniforms.bShape[0]"};\n      let numTiles = ${s?`${Math.ceil(a/r)}`:`(uniforms.dimInner - 1) / ${r} + 1`};\n      var kStart = ${s?`i32(globalId.z) * ${a}`:"0"};\n\n      var acc : array<array<f32, ${x}>, ${g}>;\n\n      // Without this initialization strange values show up in acc.\n      for (var innerRow = 0; innerRow < ${g}; innerRow++) {\n        for (var innerCol = 0; innerCol < ${x}; innerCol++) {\n          acc[innerRow][innerCol] = 0.0;\n        }\n      }\n      ${y}\n    }\n  `}class hi{constructor(e,t,n=!1,i=!1,r=null,s=null,a=null,o=!1){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=t,this.dispatchLayout={x:[2],y:[1],z:[0]};const u=n?e[1]:e[2];if(this.isVec4=(u%4==0&&!n||t[1]%4==0&&n)&&t[2]%4==0&&!i,this.outputComponent=this.isVec4?4:1,this.isVectorA=1===t[1]&&!n,!this.isVec4&&this.isVectorA)this.elementsPerThread=[1,1,1],this.workgroupSize=[32,1,1];else{const e=Un(t[1],u,t[2],n);this.workgroupSize=e.workgroupSize,this.elementsPerThread=e.elementsPerThread}this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,this.elementsPerThread);const d=null!=r,l=null!=a;d&&this.variableNames.push("bias"),l&&this.variableNames.push("preluActivationWeights"),this.sequentialAccessByThreads=o,this.transposeA=n,this.transposeB=i,this.addBias=d,this.activation=s,this.hasPreluActivationWeights=l,[this.fitAOuter,this.fitBOuter,this.fitInner]=this.getShapeFit(t[1],t[2],u),this.shaderKey=`matMulPacked_${this.elementsPerThread}_${n}_${i}_${this.activation}_${this.fitAOuter}_${this.fitBOuter}_${this.fitInner}_${this.isVec4}_${this.isVectorA}_${this.sequentialAccessByThreads}`}getShapeFit(e,t,n){const i=this.workgroupSize[1]*this.elementsPerThread[1],r=this.workgroupSize[0]*this.elementsPerThread[0];!this.isVec4&&this.isVectorA?this.tileInner=4*this.workgroupSize[0]:this.tileInner=r;return[e%i==0,t%r==0,n%this.tileInner==0]}getUserCode(){const e=`\n      ${ri(this.activation,this.hasPreluActivationWeights,this.isVec4)}\n      ${oi(this.addBias,this.activation,!1,this.transposeB,this.fitAOuter,this.fitBOuter,this.fitInner,this.isVec4?4:1)}\n      ${this.isVec4?ui(this.elementsPerThread,this.workgroupSize,this.transposeA,this.tileInner,!1,null,!0):this.isVectorA?function(e,t=!1){i.assert(1===e[1]&&1===e[2],(()=>`A linear work group size is required. But got ${e}.`));const n=4*e[0];return`\n    var<workgroup> mm_Asub : array<vec4<f32>, ${e[0]}>;\n\n    ${An()} {\n      let tileCol = i32(localId.x);\n      let globalCol = i32(globalId.x);\n      let globalRow = i32(globalId.y);\n\n      let numTiles = (uniforms.dimInner - 1) / ${n} + 1;\n      let batch = i32(globalId.z);\n      let batchA = batch % uniforms.aShape[0];\n      let batchB = batch % uniforms.bShape[0];\n      // Without this initialization strange values show up in acc.\n      var acc = 0.0;\n\n      // Loop over shared dimension.\n      for (var t = 0; t < numTiles; t++) {\n        // Load one tile of A into local memory.\n        let colA = t * ${n} + tileCol * 4;\n        mm_Asub[tileCol] = vec4<f32>(${(e=>e?"\n      mm_readA(batchA, colA, globalRow),\n      mm_readA(batchA, colA + 1, globalRow),\n      mm_readA(batchA, colA + 2, globalRow),\n      mm_readA(batchA, colA + 3, globalRow)\n  ":"\n      mm_readA(batchA, globalRow, colA),\n      mm_readA(batchA, globalRow, colA + 1),\n      mm_readA(batchA, globalRow, colA + 2),\n      mm_readA(batchA, globalRow, colA + 3)\n  ")(t)});\n        workgroupBarrier();\n\n        // Compute acc values for a single thread.\n        for (var k = 0; k < ${n/4}; k++) {\n          let rowB = t * ${n} + k * 4;\n          let BCached = vec4<f32>(mm_readB(batchB, rowB, globalCol),\n                              mm_readB(batchB, rowB + 1, globalCol),\n                              mm_readB(batchB, rowB + 2, globalCol),\n                              mm_readB(batchB, rowB + 3, globalCol));\n\n          let ACached = mm_Asub[k];\n          acc = acc + dot(ACached, BCached);\n        }\n\n        workgroupBarrier();\n      }\n\n      mm_write(batch, globalRow, globalCol, acc);\n    }\n  `}(this.workgroupSize,this.transposeA):li(this.elementsPerThread,this.workgroupSize,this.transposeA,this.tileInner,!1,null,this.sequentialAccessByThreads,!0)}\n    `;return e}}class pi{constructor(e,t=!1,n=!1,i=null,r=null,s=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workgroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout={x:[],y:[1,2],z:[0]},this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize);const a=null!=i,o=null!=s;a&&this.variableNames.push("bias"),o&&this.variableNames.push("preluActivationWeights"),this.transposeA=t,this.transposeB=n,this.addBias=a,this.activation=r,this.hasPreluActivationWeights=o,this.shaderKey=`matMulReduce_${this.activation}_${t}_${n}`}getUserCode(){var e;return`\n      ${ri(this.activation,this.hasPreluActivationWeights)}\n      ${oi(this.addBias,this.activation,this.transposeA,this.transposeB)}\n      ${e=this.workgroupSize[0],`\n    var<workgroup> sumValues : array<f32, ${e}>;\n    ${An()} {\n      let coords = getOutputCoords();\n      let batch = coords[0];\n      let batchA = batch % uniforms.aShape[0];\n      let batchB = batch % uniforms.bShape[0];\n      let row = coords[1];\n      let col = coords[2];\n      var sum = 0.0;\n      let Length = uniforms.dimInner;\n      for (var k = i32(localId.x); k < Length; k = k + ${e}) {\n        let dataA = mm_readA(batchA, row, k);\n        let dataB = mm_readB(batchB, k, col);\n        sum = sum + dataA * dataB;\n      }\n      sumValues[localId.x] = sum;\n      workgroupBarrier();\n\n      for(var currentSize = ${e/2}u; currentSize > 1u;\n          currentSize = currentSize / 2u) {\n        if (localId.x < currentSize)\n        {\n          sumValues[localId.x] = sumValues[localId.x] + sumValues[localId.x + currentSize];\n        }\n        workgroupBarrier();\n      }\n\n      if (localId.x == 0u) {\n        sum = sumValues[0] + sumValues[1];\n        mm_write(batch, row, col, sum);\n      }\n    }\n  `}\n    `}}class ci{constructor(e,t,n,i=!1,r=!1,s=null,a=null,o=null){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workgroupSize=[16,8,1],this.outputShape=n,this.dispatchLayout={x:[2],y:[1],z:[0]},this.dispatch=[Math.ceil(n[2]/this.workgroupSize[0]),Math.ceil(n[1]/this.workgroupSize[1]),n[0]];const u=null!=s;u&&this.variableNames.push("bias");const d=null!=o;d&&this.variableNames.push("preluActivationWeights"),this.transposeA=i,this.transposeB=r,this.addBias=u,this.activation=a,this.hasPreluActivationWeights=d,this.shaderKey=`matMulSmallOutputSize_${this.activation}_${i}_${r}`}getUserCode(){return`\n      ${ri(this.activation,this.hasPreluActivationWeights)}\n      ${oi(this.addBias,this.activation,this.transposeA,this.transposeB)}\n      ${function(e){const t=e[1],n=e[0],i=t>n?t:n;return`\n  var<workgroup> mm_Asub : array<array<f32, ${i}>, ${t}>;\n  var<workgroup> mm_Bsub : array<array<f32, ${n}>, ${i}>;\n\n  // If the output size is small for matrix multiplication, avoid to use vec4\n  // and handle some elements per thread to optimally utilize the ALU.\n  // Read data from global memory to registers firstly, then store them into\n  // shared memory, so it is instruction-Level parallelism for arithmetic\n  // operations and others handle IO operations between barrier api, makes ALU\n  // and load/store units work simultaneously, could improves the performance.\n  ${An()} {\n    let tileRow = i32(localId.y);\n    let tileCol = i32(localId.x);\n    let globalRow = i32(globalId.y);\n    let globalCol = i32(globalId.x);\n    let batch = i32(globalId.z);\n    let batchA = batch % uniforms.aShape[0];\n    let batchB = batch % uniforms.bShape[0];\n\n    // uniforms.dimInner should be greater than 0.\n    let numTiles = (uniforms.dimInner - 1) / ${i} + 1;\n    var acc = 0.0;\n\n    var globalColA = tileCol;\n    var globalRowB = 0;\n    var regA = mm_readA(batchA, globalRow, globalColA);\n    var regB0 = mm_readB(batchB, globalRowB + 2 * tileRow, globalCol);\n    var regB1 = mm_readB(batchB, globalRowB + 2 * tileRow + 1, globalCol);\n    globalColA = globalColA + ${i};\n    globalRowB = globalRowB + ${i};\n\n    for (var t = 0; t < numTiles; t = t + 1) {\n      mm_Asub[tileRow][tileCol] = regA;\n      mm_Bsub[2 * tileRow][tileCol] = regB0;\n      mm_Bsub[2 * tileRow + 1][tileCol] = regB1;\n\n      workgroupBarrier();\n\n      regA = mm_readA(batchA, globalRow, globalColA);\n      regB0 = mm_readB(batchB, globalRowB + 2 * tileRow, globalCol);\n      regB1 = mm_readB(batchB, globalRowB + 2 * tileRow + 1, globalCol);\n      globalColA = globalColA + ${i};\n      globalRowB = globalRowB + ${i};\n\n      for (var k = 0; k < ${i}; k = k + 1) {\n        acc = acc + mm_Asub[tileRow][k] * mm_Bsub[k][tileCol];\n      }\n      workgroupBarrier();\n    }\n\n    mm_write(batch, globalRow, globalCol, acc);\n  }\n  `}(this.workgroupSize)}\n    `}}class fi{constructor(e,t,n=!1,r=!1){this.variableNames=["A","B"],this.uniforms="dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.workgroupSize=[8,8,1],this.atomic=!0,this.splitedDimInner=128,i.assert(1===e[0],(()=>"MatMulSplitKProgram only supports batch = 1.")),this.outputShape=e,this.dispatchLayout={x:[2],y:[1],z:[0,3]};const s=(n&&this.outputShape[1]%4==0||!n&&t%4==0)&&this.outputShape[2]%4==0;this.elementsPerThread=[4,4,this.splitedDimInner],this.outputComponent=s?4:1,s||(this.outputShape[1]<16&&(this.elementsPerThread[1]=1),this.outputShape[2]<16&&(this.elementsPerThread[0]=1)),this.dispatch=On(this.dispatchLayout,[this.outputShape[0],this.outputShape[1],this.outputShape[2],t],this.workgroupSize,this.elementsPerThread),this.transposeA=n,this.transposeB=r,this.shaderKey=`matMulSplitK_${n}_${r}_${this.elementsPerThread}_${this.outputComponent}`}getUserCode(){const e=this.outputComponent;return`\n      ${ai(!1,this.transposeB,!1,!1,!1,e)}\n      fn mm_write(batch: i32, row : i32, colIn : i32, value : ${$n(e)}) {\n        let col = colIn * ${e};\n        if (row < uniforms.dimAOuter && col < uniforms.dimBOuter) {\n          let coords = vec3<i32>(batch, row, col);\n          let flatIndex = getOutputIndexFromCoords(coords);\n          // The problem is that we should initialize output to zero before using.\n          // Otherwise, the original value will be added to the result.\n          for (var i = 0; i < ${e}; i = i + 1) {\n            ${In("&result[flatIndex + i]",""+(e>1?"value[i]":"value"),"float32")}\n          }\n        }\n      }\n      ${4===e?ui(this.elementsPerThread,this.workgroupSize,this.transposeA,32,!0,this.splitedDimInner):li(this.elementsPerThread,this.workgroupSize,this.transposeA,32,!0,this.splitedDimInner)}\n    `}}class mi{constructor(e,t=null,n=null,i=null){this.uniforms="",this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.addBias=null!=t,this.hasPreluActivationWeights=null!=i,this.activation=n,this.addBias&&this.variableNames.push("bias"),this.hasPreluActivationWeights&&this.variableNames.push("preluActivationWeights"),this.shaderKey=`biasActivation_${n}`}getUserCode(){return`\n    ${ri(this.activation,this.hasPreluActivationWeights)}\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        var value = getXByOutputIndex(index);\n        ${si(this.addBias,this.activation)}\n        setOutputAtIndex(index, value);\n      }\n    }\n    `}}class gi{constructor(e){this.variableNames=[],this.outputShape=[],this.uniforms="value : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="fill"}getUserCode(){return`\n    ${An("index")} {\n      if (index < uniforms.size) {\n        setOutputAtIndex(index, uniforms.value);\n      }\n    }\n  `}}function xi(e){const{backend:t,attrs:n}=e,{shape:r,value:s}=n;let{dtype:a}=n;if(a=a||i.inferDtype(s),"string"===a){const e=i.getArrayFromDType(a,i.sizeFromShape(r));return e.fill(s),t.makeTensorInfo(r,a,e)}{const e=new gi(r),n=[{type:"float32",data:[s]}];return t.runWebGPUProgram(e,[],a,n)}}const yi={kernelName:d,backendName:"webgpu",kernelFunc:xi};function wi(e){const{inputs:t,attrs:n}=e,{x:r}=t,{shape:s}=n,a=i.sizeFromShape(r.shape),o=i.inferFromImplicitShape(s,a),u=i.sizeFromShape(o);return i.assert(a===u,(()=>`The new shape (${o}) has ${u} elements and the old shape (${r.shape}) has ${a} elements. The new shape and old shape must have the same number of elements.`)),e.backend.incRef(r.dataId),{dataId:r.dataId,shape:o,dtype:r.dtype}}const bi={kernelName:l,backendName:"webgpu",kernelFunc:wi};function Ci({a:e,b:n,transposeA:r,transposeB:s,backend:a,bias:o=null,preluActivationWeights:u=null,leakyreluAlpha:d=0,activation:l=null}){const p=e.shape.length,c=n.shape.length,f=r?e.shape[p-2]:e.shape[p-1],m=s?n.shape[c-1]:n.shape[c-2],g=r?e.shape[p-1]:e.shape[p-2],x=s?n.shape[c-2]:n.shape[c-1],y=e.shape.slice(0,-2),w=n.shape.slice(0,-2),b=i.sizeFromShape(y),C=i.sizeFromShape(w),S=h.assertAndGetBroadcastShape(e.shape.slice(0,-2),n.shape.slice(0,-2)).concat([g,x]);i.assert(f===m,(()=>`Error in matMul: inner shapes (${f}) and (${m}) of Tensors with shapes ${e.shape} and ${n.shape} and transposeA=${r} and transposeB=${s} must match.`));const v=r?[b,f,g]:[b,g,f],k=s?[C,x,m]:[C,m,x],I=wi({inputs:{x:e},backend:a,attrs:{shape:v}}),R=wi({inputs:{x:n},backend:a,attrs:{shape:k}}),$=[I,R],P=Math.max(b,C),z=[I,R],A=[{type:"int32",data:[g]},{type:"int32",data:[x]},{type:"int32",data:[f]}];let N,D;const F=[P,g,x];let T=t().get("WEBGPU_MATMUL_PROGRAM_TYPE");if(T<0){const e=t().getNumber("WEBGPU_THRESHOLD_TO_INCREASE_WORKGROUPS_FOR_MATMUL"),n=e>0?e:a.thresholdToIncreaseWorkgroups,i=P*Math.ceil(g/32)*Math.ceil(x/32);T=i<=n||g<=8&&i<=2*n?P*g*x<=128?qn.MatMulReduceProgram:1===P&&m>=2e3?qn.MatMulSplitKProgram:qn.MatMulSmallOutputSizeProgram:qn.MatMulPackedProgram}switch(T){case qn.MatMulReduceProgram:N=new pi(F,r,s,o,l,u);break;case qn.MatMulSplitKProgram:if(D=xi({backend:a,attrs:{shape:F,value:0,dtype:e.dtype}}),N=new fi(F,m,r,s),o||l){D=a.runWebGPUProgram(N,z,e.dtype,A,D);const t=new mi(D.shape,o,l,u);let n=null;const i=[D];o&&i.push(o),u&&i.push(u),"leakyrelu"===l&&(n=[{type:"float32",data:[d]}],t.uniforms+=" alpha : f32,");const r=a.runWebGPUProgram(t,i,D.dtype,n);$.push(D);const s=wi({inputs:{x:r},backend:a,attrs:{shape:S}});$.push(r);for(const e of $)a.disposeData(e.dataId);return s}break;case qn.MatMulSmallOutputSizeProgram:N=new ci(v,k,F,r,s,o,l,u);break;case qn.MatMulPackedProgram:const t=a.adapterInfo.isIntel();N=new hi(v,F,r,s,o,l,u,t);break;default:throw new Error(`Unsupported MatMulProgramType ${T}.`)}o&&z.push(o),u&&z.push(u),"leakyrelu"===l&&(A.push({type:"float32",data:[d]}),N.uniforms+=" alpha : f32,"),D=a.runWebGPUProgram(N,z,e.dtype,A,D);const E=wi({inputs:{x:D},backend:a,attrs:{shape:S}});$.push(D);for(const e of $)a.disposeData(e.dataId);return E}const Si={kernelName:p,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{a:r,b:s,bias:a,preluActivationWeights:o}=t,{transposeA:u,transposeB:d,activation:l,leakyreluAlpha:h}=i;return Ci({a:r,b:s,transposeA:u,transposeB:d,backend:n,bias:a,preluActivationWeights:o,leakyreluAlpha:h,activation:l})}};class vi{constructor(e,t,i){this.variableNames=["AReal","AImag","BReal","BImag"],this.workgroupSize=[128,1,1],this.size=!0,this.outputShape=n.assertAndGetBroadcastShape(t,i),this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey=`binaryOpComplex_${e}`,this.op=e}getUserCode(){return`\n      fn binaryOpComplex(\n          areal : f32, aimag : f32, breal : f32, bimag : f32) -> f32 {\n        ${Jn(this.op,!1)}\n      }\n\n      ${An("index")} {\n        if(index < uniforms.size) {\n          let areal = getARealByOutputIndex(index);\n          let aimag = getAImagByOutputIndex(index);\n          let breal = getBRealByOutputIndex(index);\n          let bimag = getBImagByOutputIndex(index);\n          setOutputAtIndex(index, binaryOpComplex(areal, aimag, breal, bimag));\n        }\n      }\n    `}}class ki{constructor(e,t,r){if(this.size=!0,this.variableNames=["A","B"],this.outputShape=n.assertAndGetBroadcastShape(t,r),this.dispatchLayout=Gn(this.outputShape),this.op=e,this.useSharedMemoryWithA=t.length<=1&&r.length>1&&t[0]<128,this.useSharedMemoryWithB=r.length<=1&&t.length>1&&r[0]<128,this.useSharedMemoryWithA||this.useSharedMemoryWithB)this.outputComponent=1,this.variableComponents=[1,1],this.lastDimensionSize=this.useSharedMemoryWithB?r[0]:t[0],this.shaderKey=`binary_${e}_${this.lastDimensionSize}`,this.type="shared",this.workgroupSize=[256,1,1];else{const n=t.length>0&&t[t.length-1]%4==0,s=r.length>0&&r[r.length-1]%4==0;n&&s?(this.outputComponent=4,this.variableComponents=[4,4]):n&&(i.isScalarShape(r)||1===r[r.length-1])||s&&(i.isScalarShape(t)||1===t[t.length-1])?(this.outputComponent=4,this.variableComponents=n?[4,1]:[1,4]):(this.outputComponent=1,this.variableComponents=[1,1]),this.type="nonshared",this.shaderKey=`binary_${e}_${this.variableComponents}`,this.workgroupSize=[128,1,1]}this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.outputComponent,1,1])}getUserCode(){let e;const t=4===this.outputComponent?"vec4<f32>":"f32",n=`\n    fn binaryOperation(a : ${t}, b : ${t}) -> ${t} {\n      ${Jn(this.op,4===this.outputComponent)}\n    };\n    `;if("shared"===this.type){const t=this.lastDimensionSize>1?`coords[${this.outputShape.length-1}]`:"0",i=this.useSharedMemoryWithB?`let a = getAByOutputIndex(index);\n          let b = sharedBuf[${t}];`:`let a = sharedBuf[${t}];\n          let b = getBByOutputIndex(index);`;e=`\n        ${n}\n        var<workgroup> sharedBuf : array<f32, ${this.lastDimensionSize}>;\n        ${An("index")} {\n          // Fill in the shared memory buffer.\n          let localIndex = i32(localId.x);\n          if(localIndex < ${this.lastDimensionSize}) {\n            sharedBuf[localIndex] = f32(${this.useSharedMemoryWithB?"B":"A"}[localIndex]);\n          }\n          workgroupBarrier();\n\n          if(index < uniforms.size) {\n            let coords = getCoordsFromIndex(index);\n            ${i}\n            setOutputAtIndex(index, binaryOperation(a, b));\n          }\n        }\n        `}else e=`\n       ${n}\n       ${An("index")} {\n         if (index < uniforms.size) {\n           let coords = getCoordsFromIndex(index * ${this.outputComponent});\n           let a = ${t}(getAByOutputCoords(coords));\n           let b = ${t}(getBByOutputCoords(coords));\n           setOutputAtIndex(index, binaryOperation(a, b));\n         }\n       }\n       `;return e}}function Ii(e){const{inputs:t}=e,{x:n}=t;return e.backend.incRef(n.dataId),{dataId:n.dataId,shape:n.shape,dtype:n.dtype}}const Ri={kernelName:c,backendName:"webgpu",kernelFunc:Ii};function $i(e){const{inputs:t,backend:n}=e,{real:i,imag:r}=t,s=n.makeTensorInfo(i.shape,"complex64"),a=n.tensorMap.get(s.dataId),o=Ii({inputs:{x:i},backend:n}),u=Ii({inputs:{x:r},backend:n});return a.complexTensorInfos={real:o,imag:u},s}const Pi={kernelName:f,backendName:"webgpu",kernelFunc:$i};class zi{constructor(e,t,n=""){this.variableNames=["A"],this.size=!0;this.workgroupSize=[128,1,1],this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.op=t,""!==n&&(this.uniforms=n),this.shaderKey=`unary_${t}`}getUserCode(){return`\n      fn unaryOperation(a : f32) -> f32 {\n        ${ii(this.op,!1)}\n      }\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let a = getAByOutputIndex(index);\n          setOutputAtIndex(index, unaryOperation(a));\n        }\n      }\n      `}}function Ai({opType:e,cpuKernelImpl:t,dtype:n}){return({inputs:i,backend:r})=>{const{x:s}=i,a=r,o=n||s.dtype;if(a.shouldExecuteOnCPU([s])&&null!=t){const e=a.tensorMap.get(s.dataId),n=t(e.values,o);return a.makeTensorInfo(s.shape,o,n)}const u=new zi(s.shape,e);return a.runWebGPUProgram(u,[s],o)}}function Ni({opType:e,cpuKernelImpl:t,supportsComplex:i=!1,dtype:r}){return({inputs:s,backend:a})=>{const{a:o,b:u}=s,d=a;if(i&&"complex64"===o.dtype){const t=d.tensorMap.get(o.dataId),n=d.tensorMap.get(u.dataId);let i,r;if(e!==Zn.MUL)[i,r]=[[t.complexTensorInfos.real,n.complexTensorInfos.real],[t.complexTensorInfos.imag,n.complexTensorInfos.imag]].map((t=>{const[n,i]=t,r={dataId:n.dataId,dtype:n.dtype,shape:o.shape},s={dataId:i.dataId,dtype:i.dtype,shape:u.shape},a=new ki(e,o.shape,u.shape);return d.runWebGPUProgram(a,[r,s],m(n.dtype,i.dtype))}));else{const e=new vi(Zn.COMPLEX_MULTIPLY_REAL,o.shape,u.shape),s=new vi(Zn.COMPLEX_MULTIPLY_IMAG,o.shape,u.shape),a=[{dataId:t.complexTensorInfos.real.dataId,dtype:t.complexTensorInfos.real.dtype,shape:o.shape},{dataId:t.complexTensorInfos.imag.dataId,dtype:t.complexTensorInfos.imag.dtype,shape:o.shape},{dataId:n.complexTensorInfos.real.dataId,dtype:n.complexTensorInfos.real.dtype,shape:u.shape},{dataId:n.complexTensorInfos.imag.dataId,dtype:n.complexTensorInfos.imag.dtype,shape:u.shape}];i=d.runWebGPUProgram(e,a,"float32"),r=d.runWebGPUProgram(s,a,"float32")}const s=$i({inputs:{real:i,imag:r},backend:d});return d.disposeData(i.dataId),d.disposeData(r.dataId),s}const l=r||m(o.dtype,u.dtype);if(("string"===o.dtype||"string"===u.dtype||d.shouldExecuteOnCPU([o,u]))&&null!=t){const e=d.tensorMap.get(o.dataId).values,i=d.tensorMap.get(u.dataId).values,r="string"===o.dtype?n.fromUint8ToStringArray(e):e,s="string"===o.dtype?n.fromUint8ToStringArray(i):i,[a,h]=t(o.shape,u.shape,r,s,l);return d.makeTensorInfo(h,l,a)}const h=new ki(e,o.shape,u.shape);return d.runWebGPUProgram(h,[o,u],l)}}function Di(e){return(t,r,s,a,o)=>{const u=n.assertAndGetBroadcastShape(t,r),d=u.length,l=i.computeStrides(u),h=i.sizeFromShape(u),p=i.getTypedArrayFromDType(o,h),c=t.length,f=r.length,m=i.computeStrides(t),g=i.computeStrides(r),x=n.getBroadcastDims(t,u),y=n.getBroadcastDims(r,u);if(x.length+y.length===0)for(let t=0;t<p.length;++t)p[t]=e(s[t%s.length],a[t%a.length]);else for(let t=0;t<p.length;++t){const n=i.indexToLoc(t,d,l),r=n.slice(-c);x.forEach((e=>r[e]=0));const o=i.locToIndex(r,c,m),u=n.slice(-f);y.forEach((e=>u[e]=0));const h=i.locToIndex(u,f,g);p[t]=e(s[o],a[h])}return[p,u]}}const Fi=Di(((e,t)=>e+t));const Ti=Di(((e,t)=>e&t));function Ei(e){return(t,n,r)=>{const s=i.getArrayFromDType(n,t.length);for(let n=0;n<t.length;++n)s[n]=e(t[n],r);return s}}const Wi=Ei((e=>Math.ceil(e)));const Li=Di(((e,t)=>e===t?1:0)),Bi=Ei((e=>Math.exp(e))),_i=Ei((e=>Math.expm1(e))),Oi=Ei((e=>Math.floor(e))),Ui=Di(((e,t)=>Math.floor(e/t)));const Vi=Di(((e,t)=>e>t?1:0)),Mi=Di(((e,t)=>e>=t?1:0)),Gi=Di(((e,t)=>e<t?1:0)),Hi=Di(((e,t)=>e<=t?1:0));const Xi=Ei((e=>Math.log(e)));const Ki=Di(((e,t)=>Math.max(e,t))),qi=Di(((e,t)=>Math.min(e,t))),Yi=Di(((e,t)=>e*t));const ji=Di(((e,t)=>e!==t?1:0));function Qi(e,t,n,i){const r=[];let s=0;const a=t.length-1+n.length,o=new Array(a).fill(null).map((()=>[0]));!function(e,t){for(let n=0;n<e.length;++n){const i=e[n],r=n===e.length-1?t:e[n+1].length;if(0===i.length)throw new Error("Ragged splits may not be empty");if(i[0]<0)throw new Error("Ragged splits must be non-negative");if(i[i.length-1]>r)throw new Error("Ragged splits must not point past values");for(let e=1;e<i.length;++e)if(i[e-1]>i[e])throw new Error("Ragged splits must be sorted in ascending order")}}(n,i);let u=1;for(let e=0;e<t.length-1;++e){u*=t[e];const n=t[e+1];for(let t=1;t<u+1;++t)o[e].push(t*n)}for(let i=0;i<e.length;++i){let a=e[i],u=e[i]+1;for(let e=0;e<n.length;++e){const i=n[e],r=e+t.length-1;if(r>=0){const e=o[r],t=e[e.length-1]-i[a];for(let e=a;e<u;++e)o[r].push(i[e+1]+t)}a=i[a],u=i[u]}u!==a&&(r.push([a,u]),s+=u-a)}return{outSplits:o,valueSlices:r,numValues:s}}function Zi(e,t){const n=e.slice(0,t);for(;n.length<t;)n.push(1);for(let i=t;i<e.length;i++)n[t-1]*=e[i];return n}function Ji(e,t,n,r,s){const a=t.slice();a[0]=s;const o=i.getArrayFromDType(n,i.sizeFromShape(a)),u=e.length;return function(e,t,n,i,r,s){const a=Zi(t,2)[1],o=Zi(s,2)[1];let u=0;for(const t of n)for(let n=t[0];n<t[1];++n){for(let t=0;t<i;++t)r[u*o+t]=e[n*a+t];++u}}(e,t,r,0===u?0:u/t[0],o,a),[o,a]}var er=n.RowPartitionType;class tr{constructor(e,t,i,r,s,a,o,u,d,l){this.shape=e,this.shapeShape=t,this.values=i,this.valuesShape=r,this.valuesDType=s,this.defaultValue=a,this.defaultValueShape=o,this.rowPartitionValues=u,this.rowPartitionValuesShapes=d,this.rowPartitionTypes=n.getRowPartitionTypesHelper(l),this.raggedRank=n.getRaggedRank(this.rowPartitionTypes)}getRowPartitionTypeByDimension(e){return this.rowPartitionTypes[0]===er.FIRST_DIM_SIZE?this.rowPartitionTypes[e+1]:this.rowPartitionTypes[e]}getRowPartitionTensor(e){return this.rowPartitionTypes[0]===er.FIRST_DIM_SIZE?this.rowPartitionValues[e+1]:this.rowPartitionValues[e]}getMaxWidth(e){const t=this.getRowPartitionTensor(e-1);switch(this.getRowPartitionTypeByDimension(e-1)){case er.VALUE_ROWIDS:return tr.getMaxWidthValueRowID(t);case er.ROW_SPLITS:return tr.getMaxWidthRowSplit(t);default:throw new Error(`Cannot handle partition type ${er[this.getRowPartitionTypeByDimension(e-1)]}`)}}static getMaxWidthRowSplit(e){const t=e.length;if(0===t||1===t)return 0;let n=0;for(let i=0;i<t-1;++i){const t=e[i+1]-e[i];t>n&&(n=t)}return n}static getMaxWidthValueRowID(e){const t=e.length;if(0===t)return 0;let n=0,i=e[0],r=0;for(let s=1;s<t;++s){const t=e[s];t!==i&&(i=t,r=Math.max(s-n,r),n=s)}return Math.max(t-n,r)}tensorShapeFromTensor(e,t,n=!0){if(0===t.length){if(-1===e[0])return[];throw new Error("The only valid scalar shape tensor is the fully unknown shape specified as -1.")}return ir(e,n)}calculateOutputSize(e){const t=this.valuesShape,i=this.defaultValueShape;n.validateDefaultValueShape(i,t);const r=this.tensorShapeFromTensor(this.shape,this.shapeShape),s=n.combineRaggedTensorToTensorShapes(this.raggedRank,r,t);s[0]<0&&(s[0]=e);for(let e=1;e<=this.raggedRank;++e)s[e]<0&&(s[e]=this.getMaxWidth(e));return s}calculateFirstParentOutputIndex(e,t,n){const r=Math.min(e,n),s=[];let a=0;for(let e=0;e<r;++e,a+=t)s.push(a);for(let t=r;t<e;++t)s.push(-1);return i.assert(s.length===e,(()=>"Final length of result must be equal to firstDimension.")),s}calculateOutputIndexRowSplit(e,t,n,i){const r=e.length,s=[];for(let a=0;a<r-1;++a){const r=e[a+1]-e[a];let o=Math.min(i,r),u=t[a];-1===u&&(o=0);for(let e=0;e<o;++e)s.push(u),u+=n;for(let e=0;e<r-o;++e)s.push(-1)}if(r>0&&s.length!==e[r-1])throw new Error("Invalid row split size.");return s}calculateOutputIndexValueRowID(e,t,n,i){const r=e.length,s=[];if(0===r)return[];let a=0,o=e[0];if(o>=t.length)throw new Error(`Got currentValueRowId=${o}, which is not less than ${t.length}`);let u=t[o];s.push(u);for(let d=1;d<r;++d){const r=e[d];if(r===o)u>=0&&(++a,a<i?u+=n:u=-1);else{if(a=0,o=r,r>=t.length)throw new Error(`Got nextValueRowId=${r} which is not less than ${t.length}`);u=t[r]}s.push(u)}if(s.length!==e.length)throw new Error("Invalid row ids.");return s}calculateOutputIndex(e,t,n,i){const r=this.getRowPartitionTensor(e),s=this.getRowPartitionTypeByDimension(e);switch(s){case er.VALUE_ROWIDS:return this.calculateOutputIndexValueRowID(r,t,n,i);case er.ROW_SPLITS:if(r.length-1>t.length)throw new Error(`Row partition size is greater than output size: ${r.length-1} > ${t.length}`);return this.calculateOutputIndexRowSplit(r,t,n,i);default:throw new Error(`Unsupported partition type: ${er[s]}`)}}getFirstDimensionSize(){const e=this.rowPartitionValues[0];if(0===this.rowPartitionTypes.length)throw new Error("No row_partition_types given.");const t=this.rowPartitionTypes[0];switch(t){case er.FIRST_DIM_SIZE:return e[0];case er.VALUE_ROWIDS:throw new Error("Cannot handle VALUE_ROWIDS in first dimension.");case er.ROW_SPLITS:return this.rowPartitionValuesShapes[0][0]-1;default:throw new Error(`Cannot handle type ${er[t]}`)}}compute(){if(this.rowPartitionValues[0].length<=0)throw new Error("Invalid first partition input. Tensor requires at least one element.");const e=this.getFirstDimensionSize(),t=this.calculateOutputSize(e),n=new Array(this.raggedRank+1);n[n.length-1]=1;for(let e=n.length-2;e>=0;--e)n[e]=n[e+1]*t[e+1];const r=ir(t,!1),s=i.getArrayFromDType(this.valuesDType,i.sizeFromShape(r));if(n[0]*t[0]>0){let i=this.calculateFirstParentOutputIndex(e,n[0],t[0]);for(let e=1;e<=this.raggedRank;++e){i=this.calculateOutputIndex(e-1,i,n[e],t[e])}this.setOutput(this.raggedRank,i,s,r)}return[r,s]}setOutput(e,t,n,r){if(0===n.length)return;const s=this.values,a=n;let o=r.slice();o=o.slice(e+1);const u=i.sizeFromShape(o),d=t.length;let l=this.defaultValue;if(l.length!==u&&1!==l.length){const e=this.defaultValueShape;g((()=>{const t=x(l,e),n=y(t,o);l=n.dataSync()}))}let h=0,p=0,c=0;for(let e=0;e<=d;++e){let i=e<d?t[e]:-1;if(i!==c){if(p<c){const e=s.subarray(h*u);nr(a.subarray(p*u),e,(c-p)*u)}if(e>=d){const e=n.length;i=Math.floor(e/u)}if(i>c)if(1===this.defaultValue.length)a.subarray(c*u,i*u).fill(this.defaultValue[0]),c=i;else for(;i>c;){nr(a.slice(c*u),l,u),++c}i<0?(h=e+1,p=c):(h=e,p=c,c=p+1)}else++c}}}function nr(e,t,n){for(let i=0;i<n;i++)e[i]=t[i]}function ir(e,t){const n=[];for(let i of e){if(i<0){if(!t)throw new Error(`Dimension ${i} must be >= 0`);if(i<-1)throw new Error(`Dimension ${i} must be >= -1`);i=-1}n.push(i)}return n}const rr=Ei((e=>1/Math.sqrt(e)));const sr=Ei((e=>1/(1+Math.exp(-e))));const ar=Ei((e=>Math.sqrt(e))),or=Di(((e,t)=>{const n=e-t;return n*n})),ur=Ei(((e,t)=>{const{pattern:n,replaceGlobal:i,rewrite:r}=t;return e.replace(new RegExp(n,i?"g":""),r)}));class dr{constructor(e,t,n,r,s,a){this.separator=i.encodeString(e),this.nGramWidths=t,this.leftPad=i.encodeString(n),this.rightPad=i.encodeString(r),this.padWidth=s,this.preserveShort=a}getPadWidth(e){return Math.min(this.padWidth<0?e-1:this.padWidth,e-1)}getNumNGrams(e,t){const n=this.getPadWidth(t);return Math.max(0,e+2*n-t+1)}createNGrams(e,t,n,i,r,s){for(let a=0;a<r;++a){const o=this.getPadWidth(s),u=Math.max(0,o-a),d=Math.max(0,o-(r-(a+1))),l=s-(u+d),h=t+(u>0?0:a-o);let p=0;p+=u*this.leftPad.length;for(let t=0;t<l;++t)p+=e[h+t].length;p+=d*this.rightPad.length;p+=(u+d+l-1)*this.separator.length,n[i+a]=new Uint8Array(p);const c=n[i+a];let f=0;const m=e=>e.forEach((e=>c[f++]=e));for(let e=0;e<u;++e)m(this.leftPad),m(this.separator);for(let t=0;t<l-1;++t)m(e[h+t]),m(this.separator);if(l>0){m(e[h+l-1]);for(let e=0;e<d;++e)m(this.separator),m(this.rightPad)}else{for(let e=0;e<d-1;++e)m(this.rightPad),m(this.separator);m(this.rightPad)}}}compute(e,t){const n=e.length,r=t.length;if(r>0){let e=t[0];if(0!==e)throw new Error(`First split value must be 0, got ${e}`);for(let i=1;i<r;++i){let r=t[i]>=e;if(r=r&&t[i]<=n,!r)throw new Error(`Invalid split value ${t[i]}, must be in [${e}, ${n}]`);e=t[i]}if(e!==n)throw new Error(`Last split value must be data size. Expected ${n}, got ${e}`)}const s=r-1,a=i.getArrayFromDType("int32",r);if(0===n||0===r){const e=new Array(n);for(let e=0;e<=s;++e)a[e]=0;return[e,a]}a[0]=0;for(let e=1;e<=s;++e){const n=t[e]-t[e-1];let i=0;this.nGramWidths.forEach((e=>{i+=this.getNumNGrams(n,e)})),this.preserveShort&&n>0&&0===i&&(i=1),a[e]=a[e-1]+i}const o=new Array(a[s]);for(let n=0;n<s;++n){const i=t[n];let r=a[n];if(this.nGramWidths.forEach((s=>{const a=t[n+1]-t[n],u=this.getNumNGrams(a,s);this.createNGrams(e,i,o,r,u,s),r+=u})),this.preserveShort&&r===a[n]){const s=t[n+1]-t[n];if(0===s)continue;const a=s+2*this.padWidth,u=1;this.createNGrams(e,i,o,r,u,a)}}return[o,a]}}function lr(e,t,n,i){if(!e.length)return;if(0===t.length){for(let t=0;t<e.length;++t)i.push(e.subarray(t,t+1));return}if(1===t.length){const r=t[0];let s=e.indexOf(r);for(;-1!==s;){const t=e.subarray(0,s);n&&0===t.length||i.push(t),s=(e=e.subarray(s+1)).indexOf(r)}return void(n&&0===e.length||i.push(e))}let r=0;for(let s=0;s<e.length+1;s++)if(s===e.length||-1!==t.indexOf(e[s])){const t=e.subarray(r,s);n&&0===t.length||i.push(t),r=s+1}}const hr=Di(((e,t)=>e-t));const pr=(e,t)=>{const n=t.value-e.value;return 0===n?e.index-t.index:n};function cr(e,t,n=0,r=e.length-1){for(;r>n;){if(r-n>600){const i=r-n+1,s=t-n+1,a=Math.log(i),o=.5*Math.exp(2*a/3),u=.5*Math.sqrt(a*o*(i-o)/i)*Math.sign(s-i/2);cr(e,t,Math.max(n,Math.floor(t-s*o/i+u)),Math.min(r,Math.floor(t+(i-s)*o/i+u)))}const s=e[t];let a=n,o=r;for(i.swap(e,n,t),pr(e[r],s)>0&&i.swap(e,n,r);a<o;){for(i.swap(e,a,o),a++,o--;pr(e[a],s)<0;)a+=1;for(;pr(e[o],s)>0;)o-=1}0===pr(e[n],s)?i.swap(e,n,o):(o+=1,i.swap(e,o,r)),o<=t&&(n=o+1),t<=o&&(r=o-1)}}var fr={__proto__:null,addImpl:Fi,bincountImpl:function(e,t,n,r,s){const a=i.sizeFromShape(r),o=i.makeZerosTypedArray(s,n);for(let n=0;n<e.length;n++){const i=e[n];if(i<0)throw new Error("Input x must be non-negative!");i>=s||(o[i]+=a>0?t[n]:1)}return o},bincountReduceImpl:function(e,t,n,i=!1){const r=e.shape[0],s=e.shape[1],a=o([r,n],t.dtype);for(let o=0;o<r;o++)for(let r=0;r<s;r++){const s=e.get(o,r);if(s<0)throw new Error("Input x must be non-negative!");s>=n||(i?a.set(1,o,s):t.size>0?a.set(a.get(o,s)+t.get(o,r),o,s):a.set(a.get(o,s)+1,o,s))}return a},bitwiseAndImpl:Ti,castImpl:function(e,t,n,r){if("int32"===r){return[t,"int32",Int32Array.from(e)]}if("bool"===r){const r=i.toTypedArray([0],n),[s,a]=Di(((e,t)=>e!==t?1:0))(t,[],e,r,"bool");return[a,"bool",s]}throw new Error(`Error in Cast: failed to cast ${n} to ${r}`)},ceilImpl:Wi,concatImpl:function(e,t,r,s){const a=i.getArrayFromDType(r,i.sizeFromShape(t));if(s&&"string"!==r){let t=0;e.forEach((e=>{const n=i.sizeFromShape(e.shape);a.set(e.vals,t),t+=n}))}else{let i=0;e.forEach((e=>{const s="string"===r?n.fromUint8ToStringArray(e.vals):e.vals;let o=0;for(let n=0;n<e.shape[0];++n){const r=n*t[1]+i;for(let t=0;t<e.shape[1];++t)a[r+t]=s[o++]}i+=e.shape[1]}))}return a},equalImpl:Li,expImpl:Bi,expm1Impl:_i,floorDivImpl:Ui,floorImpl:Oi,gatherNdImpl:function(e,t,n,i,r,s,a,u,d){const l=o([i,s],n);for(let n=0;n<i;n++){const i=[];let o=0;for(let t=0;t<r;t++){const s=e[n*r+t];o+=s*a[t],i.push(s)}if(o<0||o>=d/s)throw new Error(`Invalid indices: ${i} does not index into ${u}`);for(let e=0;e<s;e++)l.values[n*s+e]=t.get(...t.indexToLoc(o*s+e))}return l},gatherV2Impl:function(e,t,n){const i=o(n,e.dtype);for(let n=0;n<i.size;++n){const r=i.indexToLoc(n).slice(),s=r[0],a=r[2],o=t.locToIndex([s,a]);r[2]=t.values[o];const u=e.locToIndex(r);0<=u&&u<e.values.length&&(i.values[n]=e.values[u])}return i},greaterEqualImpl:Mi,greaterImpl:Vi,lessEqualImpl:Hi,lessImpl:Gi,linSpaceImpl:function(e,t,n){const r=(t-e)/(n-1),s=i.makeZerosTypedArray(n,"float32");s[0]=e;for(let e=1;e<s.length;e++)s[e]=s[e-1]+r;return s},logImpl:Xi,maxImpl:function(e,t,n,r){const s=i.getTypedArrayFromDType(r,i.sizeFromShape(n));for(let n=0;n<s.length;++n){const i=n*t;let r=e[i];for(let n=0;n<t;++n){const t=e[i+n];(Number.isNaN(t)||t>r)&&(r=t)}s[n]=r}return s},maximumImpl:Ki,minimumImpl:qi,multiplyImpl:Yi,negImpl:function(e,t,n){const r=i.createScalarValue(-1,n);return Yi([],t,r,e,n)},notEqualImpl:ji,prodImpl:function(e,t,r,s){const[a,o]=n.computeOutAndReduceShapes(e,s),u=m(t,"int32"),d=i.makeZerosTypedArray(i.sizeFromShape(a),u),l=i.sizeFromShape(o);for(let e=0;e<d.length;++e){const t=e*l;let n=1;for(let e=0;e<l;++e)n*=r[t+e];d[e]=n}return{outVals:d,outShape:a,outDtype:u}},raggedGatherImpl:function(e,t,n,r,s,a,o,u){if(0===e.length)throw new Error("paramsNestedSplits must be non empty");if(0===t[0].length)throw new Error("Split tensors must not be scalars");if(function(e,t,n){e.forEach(((e,r)=>{if(e<0||e>=n){const s=i.indexToLoc(r,t.length,i.computeStrides(t)).join(",");throw new Error(`indices[${s}] = ${e} is not in [0, ${n})`)}}))}(a,o,t[0][0]-1),0===r.length)throw new Error("params.rank must be nonzero");const d=r[0],{outSplits:l,valueSlices:h,numValues:p}=Qi(a,o,e,d),c=function(e){const t=[];for(let n=0;n<e.length;++n){const r=e[n].length,s=i.getArrayFromDType("int32",r);t.push(s),e[n].forEach(((e,t)=>s[t]=e))}return t}(l),f=Ji(n,r,s,h,p);return[c,f[0],f[1]]},raggedRangeImpl:function(e,t,n,r,s,a,o){if(t.length>1)throw new Error("starts must be a scalar or vector");if(s.length>1)throw new Error("limits must be a scalar or vector");if(o.length>1)throw new Error("deltas must be a scalar or vector");const u=0===t.length,d=0===s.length,l=0===o.length,h=[];u||h.push(t[0]),d||h.push(s[0]),l||h.push(o[0]);for(let e=1;e<h.length;++e)if(h[e]!==h[e-1])throw new Error("starts, limits, and deltas must have the same shape");const p=0===h.length?1:h[0],c=i.getArrayFromDType("int32",p+1);c[0]=0;for(let t=0;t<p;++t){const n=u?e[0]:e[t],i=d?r[0]:r[t],s=l?a[0]:a[t];if(0===s)throw new Error("Requires delta != 0");let o;if(s>0&&i<n||s<0&&i>n)o=0;else if(o=Math.ceil(Math.abs((i-n)/s)),o>2147483647)throw new Error("Requires ((limit - start) / delta) <= 2147483647");c[t+1]=c[t]+o}const f=c[p],m=i.getArrayFromDType(n,f);let g=0;for(let t=0;t<p;++t){const n=c[t+1]-c[t];let i=u?e[0]:e[t];const r=l?a[0]:a[t];for(let e=0;e<n;++e)m[g++]=i,i+=r}return[c,m]},raggedTensorToTensorImpl:function(e,t,n,i,r,s,a,o,u,d){return new tr(e,t,n,i,r,s,a,o,u,d).compute()},rangeImpl:function(e,t,n,r){if(e===t||e<t&&n<0||t<e&&n>1)return i.makeZerosTypedArray(0,r);const s=Math.abs(Math.ceil((t-e)/n)),a=i.makeZerosTypedArray(s,r);t<e&&1===n&&(n=-1),a[0]=e;for(let e=1;e<a.length;e++)a[e]=a[e-1]+n;return a},rsqrtImpl:rr,scatterImpl:function(e,t,n,i,r,s,a,u,d,l){const h=[i/r,r],p=e.values,c=t.values;if(0===i)return o(n,t.dtype);const f=d instanceof w?d:o(h,t.dtype);"string"==typeof d||"number"==typeof d?f.values.fill(d):"boolean"==typeof d&&f.values.fill(+d);for(let e=0;e<s;e++){const s=[];let o=0;for(let t=0;t<a;t++){const n=p[e*a+t];s.push(n),o+=n*u[t]}if(o<0||o>=i/r)throw new Error(`Invalid indices: ${s} does not index into ${n}`);for(let n=0;n<r;n++)l?f.values[o*r+n]+=c[e*r+n]:f.values[o*r+n]=0===t.rank?c[0]:c[e*r+n]}return f},sigmoidImpl:sr,simpleAbsImpl:function(e){const t=new Float32Array(e.length);for(let n=0;n<e.length;++n)t[n]=Math.abs(e[n]);return t},sliceImpl:function(e,t,r,s,a){const u=b.isSliceContinous(s,t,r),d=i.sizeFromShape(r),l=i.computeStrides(s);if(u){const n=b.computeFlatOffset(t,l);return"string"===a?e.slice(n,n+d):e.subarray(n,n+d)}const h="string"===a?n.fromUint8ToStringArray(e):e,p=o(s,a,h),c=o(r,a);for(let e=0;e<c.size;++e){const n=c.indexToLoc(e),i=n.map(((e,n)=>e+t[n]));c.set(p.get(...i),...n)}return"string"===a?n.fromStringArrayToUint8(c.values):c.values},sparseFillEmptyRowsImpl:function(e,t,r,s,a,o,u){const d=t[0],l=o[0],h=new Array(l),p=new Array(d),c=t[1];if(0===l){if(0!==d)throw new Error(n.getSparseFillEmptyRowsIndicesDenseShapeMismatch(d));return[i.getArrayFromDType(r,0),[0,c],i.getArrayFromDType(a,0),h,p]}let f=!0,m=0;const g=new Array(l).fill(0);for(let t=0;t<d;++t){const i=e[t*c];if(i<0)throw new Error(n.getSparseFillEmptyRowsNegativeIndexErrorMessage(t,i));if(i>=l)throw new Error(n.getSparseFillEmptyRowsOutOfRangeIndexErrorMessage(t,i,l));++g[i],f=f&&i>=m,m=i}let x=!0;for(let e=0;e<l;++e){const t=0===g[e];h[e]=t,x=x&&!t,g[e]=Math.max(g[e],1),e>0&&(g[e]+=g[e-1])}if(x&&f){const t=e,n=s;for(let e=0;e<d;++e)p[e]=e;return[t,[d,c],n,h,p]}{const t=g[l-1],n=i.getArrayFromDType(r,t*c),o=i.getArrayFromDType(a,t),f=new Array(l).fill(0);for(let t=0;t<d;++t){const i=e[t*c],r=f[i],a=(0===i?0:g[i-1])+r;f[i]++;for(let i=0;i<c;++i)n[a*c+i]=e[t*c+i];o[a]=s[t],p[t]=a}for(let e=0;e<l;++e){if(0===f[e]){const t=0===e?0:g[e-1];n[t*c+0]=e;for(let e=1;e<c;++e)n[t*c+e]=0;o[t]=u}}return[n,[t,c],o,h,p]}},sparseReshapeImpl:function(e,t,r,s,a){const o=i.sizeFromShape(s),u=t[0],d=a.length,l=[];let h=1,p=-1;for(let e=0;e<d;++e){const t=a[e];if(-1===t){if(-1!==p)throw new Error(n.getSparseReshapeMultipleNegativeOneOutputDimErrorMessage(p,e));p=e,l.push(1)}else{if(t<0)throw new Error(n.getSparseReshapeNegativeOutputDimErrorMessage(e,t));h*=t,l.push(t)}}if(-1!==p){if(h<=0)throw new Error(n.getSparseReshapeEmptyTensorZeroOutputDimErrorMessage());const e=Math.trunc(o/h);if(h*e!==o)throw new Error(n.getSparseReshapeInputOutputMultipleErrorMessage(s,l));l[p]=e}if(i.sizeFromShape(l)!==o)throw new Error(n.getSparseReshapeInputOutputMismatchErrorMessage(s,l));const c=s.length,f=[];if(c>0){f[c-1]=1;for(let e=c-2;e>=0;--e)f[e]=f[e+1]*s[e+1]}const m=[];if(d>0){m[d-1]=1;for(let e=d-2;e>=0;--e)m[e]=m[e+1]*l[e+1]}const g=i.getArrayFromDType(r,u*d);for(let t=0;t<u;++t){let n=0;for(let i=0;i<c;++i)n+=e[t*c+i]*f[i];for(let e=0;e<d;++e)g[t*d+e]=Math.trunc(n/m[e]),n%=m[e]}return[g,[u,d],l]},sparseSegmentReductionImpl:function(e,t,r,s,a,o=!1,u=0){const d=s.length,l=[t[0],e.length/t[0]],h=l[1],p=d>0?a[d-1]+1:0;if(p<0)throw new Error(n.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());const c=t.slice();c[0]=p;const f=c.reduce(((e,t)=>e*t),1),m=i.getArrayFromDType(r,f);if(0===d)return p>0&&m.fill(u),[m,c];if(p<=0)throw new Error(n.getSparseSegmentReductionNegativeSegmentIdsErrorMessage());let g=0,x=1,y=0,w=a[g];for(;;){let t=0;if(x<d){if(t=a[x],w===t){++x;continue}if(w>=t)throw new Error(n.getSparseSegmentReductionNonIncreasingSegmentIdsErrorMessage())}if(w<0||w>=p)throw new Error(n.getSparseSegmentReductionSegmentIdOutOfRangeErrorMessage(w,p));w>y&&m.fill(u,y*h,w*h);for(let t=g;t<x;++t){const i=s[t];if(i<0||i>=l[0])throw new Error(n.getSparseSegmentReductionIndicesOutOfRangeErrorMessage(t,s[t],l[0]));for(let t=0;t<h;t++)m[w*h+t]+=e[i*h+t]}if(o)for(let e=0;e<h;e++)m[w*h+e]/=x-g;if(g=x,++x,y=w+1,w=t,x>d)break}return y<p&&m.fill(u,y*h,p*h),[m,c]},sqrtImpl:ar,squaredDifferenceImpl:or,staticRegexReplaceImpl:ur,stridedSliceImpl:function(e,t,n,i){const r=o(e,t.dtype);for(let e=0;e<r.size;e++){const s=r.indexToLoc(e),a=new Array(s.length);for(let e=0;e<a.length;e++)a[e]=s[e]*n[e]+i[e];r.set(t.get(...a),...s)}return r},stringNGramsImpl:function(e,t,n,i,r,s,a,o){return new dr(n,i,r,s,a,o).compute(e,t)},stringSplitImpl:function(e,t,n){const r=e.length,s=[];let a=0,o=0;const u=new Array(r);for(let i=0;i<r;++i){const r=s.length;lr(e[i],t,n,s);const d=s.length-r;u[i]=d,a+=d,o=Math.max(o,d)}const d=i.getArrayFromDType("int32",2*a),l=new Array(a),h=[r,o];let p=0;for(let e=0;e<r;++e)for(let t=0;t<u[e];++t)d[2*p]=e,d[2*p+1]=t,l[p]=s[p],++p;return[d,l,h]},stringToHashBucketFastImpl:function(e,t){const n=i.getArrayFromDType("int32",e.length);for(let r=0;r<e.length;++r)n[r]=i.fingerPrint64(e[r]).modulo(t).getLowBitsUnsigned();return n},subImpl:hr,tileImpl:function(e,t){const n=new Array(e.rank);for(let i=0;i<n.length;i++)n[i]=e.shape[i]*t[i];const i=o(n,e.dtype);for(let t=0;t<i.values.length;++t){const n=i.indexToLoc(t),r=new Array(e.rank);for(let t=0;t<r.length;t++)r[t]=n[t]%e.shape[t];const s=e.locToIndex(r);i.values[t]=e.values[s]}return i},topKImpl:function(e,t,n,r,s){const a=t[t.length-1],[u,d]=[e.length/a,a],l=i.getTypedArrayFromDType(n,u*r),h=i.getTypedArrayFromDType("int32",u*r);for(let t=0;t<u;t++){const n=t*d,i=e.subarray(n,n+d);let a=new Array(i.length);i.forEach(((e,t)=>a[t]={value:e,index:t})),r<a.length&&(cr(a,r),a=a.slice(0,r)),s&&a.sort(pr);const o=t*r,u=l.subarray(o,o+r),p=h.subarray(o,o+r);for(let e=0;e<r;e++)u[e]=a[e].value,p[e]=a[e].index}const p=t.slice();return p[p.length-1]=r,[o(p,n,l),o(p,"int32",h)]},transposeImpl:function(e,t,n,r,s){const a=t.length,o=i.sizeFromShape(t),u=i.computeStrides(t),d=i.computeStrides(s),l=i.getTypedArrayFromDType(n,i.sizeFromShape(s));for(let t=0;t<o;++t){const n=i.indexToLoc(t,a,u),s=new Array(n.length);for(let e=0;e<s.length;e++)s[e]=n[r[e]];l[i.locToIndex(s,a,d)]=e[t]}return l},uniqueImpl:function(e,t,n,r){const s=i.parseAxisParam(t,n)[0],a=[1,n[0],1];for(let e=0;e<s;e++)a[0]*=n[e];a[1]=n[s];for(let e=s+1;e<n.length;e++)a[2]*=n[e];const o=new Map,u=new Int32Array(n[s]),d=new w(a,r,e),l=[],h=1===a[0]&&1===a[2];for(let t=0;t<n[s];t++){let n;if(h)n=e[t].toString();else{const e=[];for(let n=0;n<a[0];n++)for(let i=0;i<a[2];i++)e.push(d.get(n,t,i));n=e.join(",")}const i=o.get(n);if(null!=i)u[t]=i;else{const e=o.size;o.set(n,e),u[t]=e,l.push(t)}}const p=a.slice();p[1]=o.size;const c=new w(p,r);l.forEach(((e,t)=>{for(let n=0;n<a[0];n++)for(let i=0;i<a[2];i++)c.set(d.get(n,e,i),n,t,i)}));const f=n.slice();return f[s]=p[1],{outputValues:c.values,outputShape:f,indices:u}}};const{addImpl:mr,castImpl:gr,ceilImpl:xr,concatImpl:yr,equalImpl:wr,expImpl:br,expm1Impl:Cr,floorImpl:Sr,floorDivImpl:vr,gatherNdImpl:kr,gatherV2Impl:Ir,greaterEqualImpl:Rr,greaterImpl:$r,lessEqualImpl:Pr,lessImpl:zr,logImpl:Ar,maxImpl:Nr,maximumImpl:Dr,minimumImpl:Fr,multiplyImpl:Tr,negImpl:Er,notEqualImpl:Wr,prodImpl:Lr,rangeImpl:Br,rsqrtImpl:_r,scatterImpl:Or,simpleAbsImpl:Ur,sliceImpl:Vr,stridedSliceImpl:Mr,stringNGramsImpl:Gr,subImpl:Hr,tileImpl:Xr,topKImpl:Kr,transposeImpl:qr,uniqueImpl:Yr}=fr,jr={kernelName:C,backendName:"webgpu",kernelFunc:Ai({opType:ei.ABS,cpuKernelImpl:Ur})},Qr={kernelName:S,backendName:"webgpu",kernelFunc:Ai({opType:ei.ACOS})},Zr={kernelName:v,backendName:"webgpu",kernelFunc:Ai({opType:ei.ACOSH})},Jr={kernelName:k,backendName:"webgpu",kernelFunc:Ni({opType:Zn.ADD,cpuKernelImpl:mr,supportsComplex:!0})};class es{constructor(e){this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e[0],this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.shaderKey="addN"}getUserCode(){const e=[];this.variableNames.forEach((t=>{e.push(`let v${t} = get${t}ByOutputCoords(coords);`)}));const t=this.variableNames.map((e=>`v${e}`)).join(" + ");return`\n      ${An("index")} {\n        for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if (flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            ${e.join("\n        ")}\n            setOutputAtIndex(flatIndex, ${t});\n          }\n        }\n      }\n    `}}const ts={kernelName:I,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,i=t;if(1===i.length)return Ii({inputs:{x:i[0]},backend:n});const r=i.map((e=>e.dtype)).reduce(((e,t)=>m(e,t))),s=i.map((e=>e.shape)),a=new es(s);return n.runWebGPUProgram(a,i,r)}};class ns{constructor(e,t){this.variableNames=["A"],this.workgroupSize=[16,16,1];const n=new Array(e.length);for(let i=0;i<n.length;i++)n[i]=e[t[i]];this.outputShape=n,this.dispatchLayout={x:[0],y:[1]},this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[1,1,1]),this.shaderKey="transposeShared"}getUserCode(){i.assert(this.workgroupSize[0]===this.workgroupSize[1],(()=>`Must be a square tile, current tile shape is ${this.workgroupSize[0]} x ${this.workgroupSize[1]}`));const e=this.workgroupSize[0];return`\n      var<workgroup> tile : array<array<f32, ${this.workgroupSize[0]+1}>, ${this.workgroupSize[0]}>;\n      ${An()} {\n        var x = i32(workgroupId.x) * ${e} + i32(localId.x);\n        var y = i32(workgroupId.y) * ${e} + i32(localId.y);\n        let width = uniforms.outShape[0];\n        let height = uniforms.outShape[1];\n        if (x < width && y < height) {\n          tile[localId.y][localId.x] = f32(A[y * width + x]);\n        }\n        workgroupBarrier();\n\n        x = i32(workgroupId.y) * ${e} + i32(localId.x);\n        y = i32(workgroupId.x) * ${e} + i32(localId.y);\n        if (x < height && y < width) {\n          setOutputAtIndex((y * height + x), tile[localId.x]\n            [localId.y]);\n        }\n      }\n    `}}class is{constructor(e,t){this.variableNames=["A"],this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let i=0;i<n.length;i++)n[i]=e[t[i]];this.outputShape=n,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.newDim=t,this.shaderKey=`transpose_${t}`}getUserCode(){const e=Pn(this.outputShape.length),t=rs(this.newDim);return`\n      ${An("index")} {\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            setOutputAtIndex(flatIndex, A[getIndexFromCoords${this.outputShape.length}D(\n              ${e}(${t}), uniforms.aShape)]);\n          }\n        }\n      }\n    `}}function rs(e){const t=e.length;if(t>6)throw Error(`Transpose for rank ${t} is not yet supported`);const n=new Array(t);for(let t=0;t<e.length;t++)n[e[t]]=`coords.${zn(t)}`;return n.join()}function ss(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{perm:a}=r,o=n,u=s.shape.length,d=new Array(u);for(let e=0;e<d.length;e++)d[e]=s.shape[a[e]];if(n.shouldExecuteOnCPU([s])){const e=o.tensorMap.get(s.dataId).values,t=qr(e,s.shape,s.dtype,a,d);return n.makeTensorInfo(d,s.dtype,t)}if(2===s.shape.length&&i.arraysEqual(a,[1,0])){const e=new ns(s.shape,a);return o.runWebGPUProgram(e,[s],s.dtype)}const l=new is(s.shape,a);return o.runWebGPUProgram(l,[s],s.dtype)}const as={kernelName:R,backendName:"webgpu",kernelFunc:ss};class os{constructor(e,t,i){this.variableNames=["x"],this.uniforms="reduceSize : i32,",this.size=!0,this.inputShape=[e.batchSize,e.inSize];const[r]=n.computeOutAndReduceShapes(this.inputShape,[1]);this.outputShape=0===r.length?[1]:r,e.inSize>=32768&&i>=512?this.workgroupSize=[512,1,1]:e.inSize>=4096?this.workgroupSize=[256,1,1]:this.workgroupSize=[64,1,1],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,[1,1,1]),this.reduceType=t,this.shaderKey=`reduce_${t}`}getUserCode(){let e="",t="0.0";const n=this.workgroupSize[0];"min"===this.reduceType||"max"===this.reduceType?(e=`\n         if (isnan(candidate)) {\n          bestValue = uniforms.NAN;\n         } else if (!isnan(bestValue) && candidate ${"min"===this.reduceType?"<":">"} bestValue)\n           {  bestValue = candidate; }`,t="f32(x[offset])"):"sum"===this.reduceType||"mean"===this.reduceType?e=" bestValue = bestValue + candidate; ":"prod"===this.reduceType?(e=" bestValue = bestValue * candidate; ",t="1.0"):"all"===this.reduceType?(e=" bestValue = f32(bestValue >= 1.0 && candidate >= 1.0); ",t="1.0"):"any"===this.reduceType&&(e=" bestValue = f32(bestValue >= 1.0 || candidate >= 1.0); ",t="0.0");const i="mean"===this.reduceType?"setOutputAtIndex(outputIndex, bestValue / f32(uniforms.reduceSize));":"setOutputAtIndex(outputIndex, bestValue);";return`\n       fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n       }\n\n       ${`\n         var<workgroup> xBestValues : array<f32, ${n}>;\n       `}\n       fn getOffset(outputIndex : i32) -> i32 {\n         let outputCoords = getCoordsFromIndex(outputIndex);\n         let offset = ${1===this.outputShape.length?"outputCoords":"outputCoords[0]"} * uniforms.reduceSize;\n          return offset;\n       }\n       ${An("index")} {\n         let outputIndex = index / ${n};\n         let offset = getOffset(outputIndex);\n         var bestValue = ${t};\n         let Length = uniforms.reduceSize;\n         let WorkPerThread = DIV_CEIL(u32(Length), ${n}u);\n         for (var k = i32(localId.x); k < Length && outputIndex < uniforms.size;\n             k = k + ${n}) {\n           let candidate = f32(x[offset + k]);\n           ${e}\n         }\n         xBestValues[localId.x] = bestValue;\n         workgroupBarrier();\n\n         var reduceSize = min(u32(Length), ${n}u);\n         for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n             currentSize = reduceSize / 2u) {\n           let interval = DIV_CEIL(reduceSize, 2u);\n           if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            ${e}\n            xBestValues[localId.x] = bestValue;\n           }\n           reduceSize = interval;\n           workgroupBarrier();\n         }\n\n         if (localId.x == 0u && outputIndex < uniforms.size) {\n          ${i}\n        }\n       }\n     `}}function us(e,t,r,s,a){const o=e.shape.length,u=[],d=i.parseAxisParam(t,e.shape);let l=d;const h=n.getAxesPermutation(l,o);let p=e;null!=h&&(p=ss({inputs:{x:e},attrs:{perm:h},backend:a}),l=n.getInnerMostAxes(l.length,o),u.push(p)),n.assertAxesAreInnerMostDims(s,l,o);const[c,f]=n.computeOutAndReduceShapes(p.shape,l);let m,g=c;if(r&&(g=n.expandShapeToKeepDim(c,d)),"max"!==s&&"prod"!==s||!a.shouldExecuteOnCPU([p])){const t=i.sizeFromShape(f),n={windowSize:t,inSize:t,batchSize:i.sizeFromShape(p.shape)/t,outSize:1},r="mean"===s?"float32":$(e.dtype),o=[{type:"int32",data:[t]}],d=new os(n,s,a.device.limits.maxComputeWorkgroupSizeX),l=a.runWebGPUProgram(d,[p],r,o);u.push(l),m=wi({inputs:{x:l},attrs:{shape:g},backend:a})}else{const t=a.tensorMap.get(p.dataId).values;switch(s){case"max":const n=Nr(t,i.sizeFromShape(f),g,e.dtype);m=a.makeTensorInfo(g,e.dtype,n);break;case"prod":const{outVals:r,outShape:o,outDtype:u}=Lr(p.shape,p.dtype,t,l);m=a.makeTensorInfo(o,u,r);break;default:throw new Error(`${s} CPU implementation is not yet supported.`)}}return u.forEach((e=>a.disposeData(e.dataId))),m}const ds={kernelName:P,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{keepDims:s,axis:a}=i;return us(r,a,s,"all",n)}};const ls={kernelName:z,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{keepDims:s,axis:a}=i;return us(r,a,s,"any",n)}};class hs{constructor(e,t,r){this.workgroupSize=[64,1,1],this.variableNames=["x"],this.uniforms="infinityValue : f32,",this.size=!0;const s=[t];this.op="min"===r?"<":">";const[a,o]=n.computeOutAndReduceShapes(e,s);this.outputShape=0===a.length?[1]:a,this.dispatchLayout=Gn(this.outputShape),i.sizeFromShape(o)<32||i.sizeFromShape(a)>1e3?(this.type="plain",this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize)):(this.type="shared",this.dispatch=On(this.dispatchLayout,this.outputShape,[1,1,1])),this.inputShape=e,this.shaderKey=`argMinMax_${this.op}_${this.type}`}getUserCode(){const e=this.workgroupSize[0],t=()=>1===this.inputShape.length?"uniforms.xShape":`uniforms.xShape.${zn(this.inputShape.length-1)}`,n=()=>{let e="";if(1===this.outputShape.length)1!==this.inputShape.length&&(e+="outputCoords,");else for(let t=0;t<this.outputShape.length;t++)e+=`outputCoords.${zn(t)},`;return e};if("shared"===this.type){return`\n      fn DIV_CEIL(a : u32, b : u32) -> u32 {\n        return ((a - 1u) / b + 1u);\n      }\n\n      ${`\n      var<workgroup> xBestIndices : array<i32, ${e}>;\n      var<workgroup> xBestValues : array<f32, ${e}>;\n    `}\n\n      ${An("index")} {\n        let outputIndex = index / ${e};\n        let reduceLength = ${t()};\n\n        var bestIndex = i32(localId.x);\n        var bestValue = uniforms.infinityValue;\n        let outputCoords = getCoordsFromIndex(outputIndex);\n        for (var k = i32(localId.x); k < reduceLength && outputIndex < uniforms.size;\n            k = k + ${e}) {\n          let candidate = getX(${n()} k);\n          if (!isnan(candidate) && candidate ${this.op} bestValue) {\n            bestValue = candidate;\n            bestIndex = k;\n          }\n        }\n        xBestValues[localId.x] = bestValue;\n        xBestIndices[localId.x] = bestIndex;\n        workgroupBarrier();\n\n        var reduceSize = min(u32(reduceLength), ${e}u);\n        for (var currentSize = reduceSize / 2u; reduceSize > 1u;\n            currentSize = reduceSize / 2u) {\n          let interval = DIV_CEIL(reduceSize, 2u);\n          if (localId.x < currentSize) {\n            let candidate = xBestValues[localId.x + interval];\n            if (candidate ${this.op} bestValue) {\n              bestValue = candidate;\n              xBestValues[localId.x] = bestValue;\n              xBestIndices[localId.x] = xBestIndices[localId.x + interval];\n            }\n          }\n          reduceSize = interval;\n          workgroupBarrier();\n        }\n\n        if (localId.x == 0u && outputIndex < uniforms.size) {\n          setOutputAtIndexI32(outputIndex, xBestIndices[localId.x]);\n        }\n      }\n    `}return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let outputCoords = getCoordsFromIndex(index);\n          var bestIndex = 0;\n          var bestValue = getX(${n()} 0);\n          let reduceLength = ${t()};\n          for (var i = 1; i < reduceLength; i++) {\n            let candidate = getX(${n()} i);\n            if (candidate ${this.op} bestValue) {\n              bestValue = candidate;\n              bestIndex = i;\n            }\n          }\n          setOutputAtIndexI32(index, bestIndex);\n        }\n      }\n      `}}const ps={kernelName:A,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:a}=t,{axis:o}=s;let u=i.parseAxisParam(o,a.shape);const d=n.getAxesPermutation(u,a.shape.length);let l=a;const h=[];null!=d&&(l=ss({inputs:{x:a},backend:r,attrs:{perm:d}}),h.push(l),u=n.getInnerMostAxes(u.length,l.shape.length)),n.assertAxesAreInnerMostDims("argMax",[u[0]],l.shape.length);const p=new hs(l.shape,u[0],"max"),c=[{type:"float32",data:[Number.NEGATIVE_INFINITY]}],f=r.runWebGPUProgram(p,[l],"int32",c);return h.forEach((e=>r.disposeData(e.dataId))),f}};const cs={kernelName:N,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:a}=t,{axis:o}=s;let u=i.parseAxisParam(o,a.shape);const d=n.getAxesPermutation(u,a.shape.length);let l=a;const h=[];null!=d&&(l=ss({inputs:{x:a},backend:r,attrs:{perm:d}}),h.push(l),u=n.getInnerMostAxes(u.length,l.shape.length)),n.assertAxesAreInnerMostDims("argMin",[u[0]],l.shape.length);const p=new hs(l.shape,u[0],"min"),c=[{type:"float32",data:[Number.POSITIVE_INFINITY]}],f=r.runWebGPUProgram(p,[l],"int32",c);return h.forEach((e=>r.disposeData(e.dataId))),f}},fs={kernelName:D,backendName:"webgpu",kernelFunc:Ai({opType:ei.ASIN})},ms={kernelName:F,backendName:"webgpu",kernelFunc:Ai({opType:ei.ASINH})},gs={kernelName:T,backendName:"webgpu",kernelFunc:Ai({opType:ei.ATAN})},xs={kernelName:E,backendName:"webgpu",kernelFunc:Ni({opType:Zn.ATAN2})},ys={kernelName:W,backendName:"webgpu",kernelFunc:Ai({opType:ei.ATANH})};class ws{constructor(e){this.variableNames=["x"],this.uniforms="strides : vec2<i32>,",this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="poolWithFilterSizeEqualsOne"}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let d = coords[3];\n\n          let xRCCorner = coords.yz * uniforms.strides;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          let value = getX(batch, xRCorner, xCCorner, d);\n          setOutputAtIndex(index, value);\n        }\n      }\n    `}}class bs{constructor(e,t,n=!1,i=!1,r=!1){if(this.variableNames=["x"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, dilations : vec2<i32>, convDims : vec2<i32>, filterDims : vec2<i32>,",this.workgroupSize=[128,1,1],this.size=!0,"avg"===t&&n)throw new Error("Cannot compute positions for average pool.");this.outputShape=e.outShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.poolType=t,this.computePositions=n,this.flattenPositions=i,this.includeBatchIndex=r,this.shaderKey=`pool2D_${t}_${n}_${i}_${r}`}getUserCode(){let e;if("avg"===this.poolType)e="resultValue = resultValue + value; count = count + 1.0;";else if(this.computePositions){e=`let currMaxValue = mix(value, maxValue, maxValueFound);\n      if (value >= currMaxValue) {\n        maxValue = value;\n        maxValueFound = 1.0;\n        maxPosition = ${this.flattenPositions?this.includeBatchIndex?"((batch * uniforms.xShape[1] + xR) * uniforms.xShape[2] + xC) * uniforms.xShape[3] + d":"(xR * uniforms.xShape[2] + xC) * uniforms.xShape[3] + d":"wR * uniforms.filterDims.y + wC"};\n      }`}else e="resultValue = max(value, resultValue);";let t="resultValue";"avg"===this.poolType&&(t="resultValue / max(count, 1.0)");return`\n      ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let batch = coords[0];\n          let d = coords[3];\n          let xRCCorner = vec2<i32>(coords.yz) * uniforms.strides - uniforms.pads;\n          let xRCorner = xRCCorner.x;\n          let xCCorner = xRCCorner.y;\n\n          ${this.computePositions?"var maxValue = 0.0;\n            var maxValueFound = 0.0;\n            var maxPosition = 0;":`var resultValue = ${"avg"===this.poolType?"0.0":"-1.0 / pow(10.0, -20.0)"};`}\n\n          var count = 0.0;\n          for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + uniforms.dilations.x) {\n            let xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= uniforms.convDims.x) {\n              continue;\n            }\n\n            for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + uniforms.dilations.y) {\n              let xC = xCCorner + wC;\n              if (xC < 0 || xC >= uniforms.convDims.y) {\n                continue;\n              }\n\n              let value = getX(batch, xR, xC, d);\n              ${e}\n            }\n          }\n\n          ${this.computePositions?"setOutputAtIndexI32(index, maxPosition);":`setOutputAtIndex(index, ${t});`}\n        }\n      }\n    `}}class Cs{constructor(e,t,n=!1,i=!1,r=!1){if(this.variableNames=["x"],this.uniforms="strides : vec3<i32>, pads : vec3<i32>, convDims : vec3<i32>, filterDims : vec3<i32>,",this.workgroupSize=[128,1,1],this.size=!0,"avg"===t&&n)throw new Error("Cannot compute positions for average pool.");this.outputShape=e.outShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.poolType=t,this.computePositions=n,this.flattenPositions=i,this.includeBatchIndex=r,this.shaderKey=`pool3D_${t}_${n}_${i}_${r}`}getUserCode(){let e;if("avg"===this.poolType)e="resultValue += value; count += 1.0;";else if(this.computePositions){e=`let currMaxValue = mix(value, maxValue, maxValueFound);\n      if (value >= currMaxValue) {\n        maxValue = value;\n        maxValueFound = 1.0;\n        maxPosition = ${this.flattenPositions?this.includeBatchIndex?"(((batch * uniforms.xShape.y + xD) * uniforms.xShape.z + xR) * uniforms.xShape.w + xC) * uniforms.xShape.u + ch":"((xD * uniforms.xShape.z + xR) * uniforms.xShape.w + xC) * uniforms.xShape.u + ch":"wD * uniforms.filterDims.y * uniforms.filterDims.y + wR * uniforms.filterDims.z + wC"};\n      }`}else e="resultValue = max(value, resultValue);";let t="resultValue";"avg"===this.poolType&&(t="resultValue / max(count, 1.0)");return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let batch = coords.x;\n          let ch = coords.u;\n\n          let xCorner = vec3<i32>(coords.y, coords.z, coords.w) * uniforms.strides - uniforms.pads;\n          let xDCorner = xCorner.x;\n          let xRCorner = xCorner.y;\n          let xCCorner = xCorner.z;\n\n          ${this.computePositions?"var maxValue = 0.0;\n            var maxValueFound = 0.0;\n            var maxPosition = 0;":`var resultValue = ${"avg"===this.poolType?"0.0":"-1.0 / pow(10.0, -20.0)"};`}\n\n          var count = 0.0;\n          for (var wD = 0; wD < uniforms.filterDims.x; wD++) {\n            let xD = xDCorner + wD;\n            if (xD < 0 || xD >= uniforms.convDims.x) {\n              continue;\n            }\n\n            for (var wR = 0; wR < uniforms.filterDims.y; wR++) {\n              let xR = xRCorner + wR;\n              if (xR < 0 || xR >= uniforms.convDims.y) {\n                continue;\n              }\n\n              for (var wC = 0; wC < uniforms.filterDims.z; wC++) {\n                let xC = xCCorner + wC;\n                if (xC < 0 || xC >= uniforms.convDims.z) {\n                  continue;\n                }\n\n                let value = getX(batch, xD, xR, xC, ch);\n                ${e}\n              }\n            }\n          }\n\n          ${this.computePositions?"setOutputAtIndexI32(index, maxPosition);":`setOutputAtIndex(index, ${t});`}\n        }\n      }\n    `}}function Ss(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{reductionIndices:s,keepDims:a}=i;return us(r,s,a,"max",n)}const vs={kernelName:L,backendName:"webgpu",kernelFunc:Ss};function ks(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{keepDims:s,axis:a}=i;return us(r,a,s,"mean",n)}const Is={kernelName:B,backendName:"webgpu",kernelFunc:ks};function Rs(e,t,n,r){if(1===t.filterWidth&&1===t.filterHeight&&i.arraysEqual(t.inShape,t.outShape))return Ii({inputs:{x:e},backend:r});if(t.filterWidth===t.inWidth&&t.filterHeight===t.inHeight&&1===t.batchSize&&"VALID"===t.padInfo.type){const s=e.shape.length,a=wi({inputs:{x:e},backend:r,attrs:{shape:[e.shape[s-3]*e.shape[s-2],e.shape[s-1]]}});let o;"avg"===n?o=ks({inputs:{x:a},backend:r,attrs:{axis:0,keepDims:!1}}):(i.assert("max"===n,(()=>`Invalid pool type ${n}`)),o=Ss({inputs:{x:a},backend:r,attrs:{reductionIndices:0,keepDims:!1}}));const u=wi({inputs:{x:o},backend:r,attrs:{shape:t.outShape}});return r.disposeData(a.dataId),r.disposeData(o.dataId),u}let s;const a=[{type:"int32",data:[t.strideHeight,t.strideWidth]}];return 1===t.filterHeight&&1===t.filterWidth?s=new ws(t):("avg"===n?s=new bs(t,"avg"):(i.assert("max"===n,(()=>`Invalid pool type ${n}`)),s=new bs(t,"max")),a.push({type:"int32",data:[t.padInfo.top,t.padInfo.left]},{type:"int32",data:[t.dilationHeight,t.dilationWidth]},{type:"int32",data:[t.inHeight,t.inWidth]},{type:"int32",data:[t.effectiveFilterHeight,t.effectiveFilterWidth]})),r.runWebGPUProgram(s,[e],e.dtype,a)}const $s={kernelName:_,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s}=t,{filterSize:a,strides:o,pad:u,dimRoundingMode:d}=r;return Rs(s,n.computePool2DInfo(s.shape,a,o,1,u,d),"avg",i)}};const Ps={kernelName:O,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s}=t,{filterSize:a,strides:o,pad:u,dataFormat:d,dimRoundingMode:l}=r,h=n.computePool3DInfo(s.shape,a,o,[1,1,1],u,l,d),p=new Cs(h,"avg"),c=[{type:"int32",data:[h.strideDepth,h.strideHeight,h.strideWidth]},{type:"int32",data:[h.padInfo.front,h.padInfo.top,h.padInfo.left]},{type:"int32",data:[h.inDepth,h.inHeight,h.inWidth]},{type:"int32",data:[h.effectiveFilterDepth,h.effectiveFilterHeight,h.effectiveFilterWidth]}];return i.runWebGPUProgram(p,[s],s.dtype,c)}};class zs{constructor(e){this.variableNames=["dy"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, dilations : vec2<i32>, filterDims : vec2<i32>,\n       outHeight : i32, outWidth : i32, avgMultiplier : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="avgPool2DBackprop"}getUserCode(){return`\n      ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d = coords[3];\n\n        let dyRCCorner = vec2<i32>(coords.yz) - uniforms.pads;\n        let dyRCorner = dyRCCorner.x;\n        let dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims[0]; wR = wR + uniforms.dilations[0]) {\n          let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[0]);\n\n          if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n            continue;\n          }\n          let idyR = i32(dyR);\n\n          for (var wC = 0; wC < uniforms.filterDims[1]; wC = wC + uniforms.dilations[1]) {\n            let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[1]);\n\n            if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n              continue;\n            }\n            let idyC = i32(dyC);\n\n            let dyValue = getDy(batch, idyR, idyC, d);\n\n            dotProd = dotProd + dyValue * uniforms.avgMultiplier;\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}class As{constructor(e){this.variableNames=["dy"],this.uniforms="strides : vec3<i32>, pads : vec3<i32>, filterDims : vec3<i32>,\n       outDepth : i32, outHeight : i32, outWidth : i32, avgMultiplier : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="avgPool3DBackprop"}getUserCode(){return`\n      ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords.x;\n        let ch = coords.u;\n\n        let dyCorner = vec3<i32>(coords.y, coords.z, coords.w) - uniforms.pads;\n        let dyDCorner = dyCorner.x;\n        let dyRCorner = dyCorner.y;\n        let dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, d) with pos mask(:, :, :, ch) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wD = 0; wD < uniforms.filterDims[0]; wD++) {\n          let dyD = f32(dyDCorner + wD) / f32(uniforms.strides[0]);\n\n          if (dyD < 0.0 || dyD >= f32(uniforms.outDepth) || fract(dyD) > 0.0) {\n            continue;\n          }\n          let idyD = i32(dyD);\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[1]);\n\n            if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n              continue;\n            }\n            let idyR = i32(dyR);\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[2]);\n\n              if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n                continue;\n              }\n              let idyC = i32(dyC);\n\n              let dyValue = getDy(batch, idyD, idyR, idyC, ch);\n              dotProd += dyValue * uniforms.avgMultiplier;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}const Ns={kernelName:U,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{dy:s,input:a}=t,o=a,{filterSize:u,strides:d,pad:l,dimRoundingMode:h}=r,p=n.computePool3DInfo(o.shape,u,d,1,l,h),c=new As(p),f=1/(p.filterDepth*p.filterHeight*p.filterWidth),m=[{type:"int32",data:[p.strideDepth,p.strideHeight,p.strideWidth]},{type:"int32",data:[p.effectiveFilterDepth-1-p.padInfo.front,p.effectiveFilterHeight-1-p.padInfo.top,p.effectiveFilterWidth-1-p.padInfo.left]},{type:"int32",data:[p.effectiveFilterDepth,p.effectiveFilterHeight,p.effectiveFilterWidth]},{type:"int32",data:[p.outDepth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]},{type:"float32",data:[f]}];return i.runWebGPUProgram(c,[s],o.dtype,m)}};const Ds={kernelName:V,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{dy:s,input:a}=t,o=a;Kn([s,a],"avgPoolGrad");const{filterSize:u,strides:d,pad:l}=r,h=n.computePool2DInfo(o.shape,u,d,1,l),p=new zs(h),c=1/(h.filterHeight*h.filterWidth),f=[{type:"int32",data:[h.strideHeight,h.strideWidth]},{type:"int32",data:[h.effectiveFilterHeight-1-h.padInfo.top,h.effectiveFilterWidth-1-h.padInfo.left]},{type:"int32",data:[h.dilationHeight,h.dilationWidth]},{type:"int32",data:[h.effectiveFilterHeight,h.effectiveFilterWidth]},{type:"int32",data:[h.outHeight]},{type:"int32",data:[h.outWidth]},{type:"float32",data:[c]}];return i.runWebGPUProgram(p,[s],o.dtype,f)}};const Fs={kernelName:M,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{a:r,b:s}=t,{transposeA:a,transposeB:o}=i;return Ci({a:r,b:s,transposeA:a,transposeB:o,backend:n})}};class Ts{constructor(e,t){this.variableNames=["source"],this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.rank=t.length,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.start=e,this.uniforms=`start : ${Pn(e.length)}, `,this.shaderKey="slice"}getUserCode(){const e=Pn(this.rank),t=function(e){if(1===e)return"sourceLoc";if(e<=6)return Es.slice(0,e).map((e=>`sourceLoc.${e}`)).join(",");throw Error(`Slicing for rank ${e} is not yet supported`)}(this.rank);let n;n=1===this.start.length?this.outputShape.map(((e,t)=>"sourceLoc = uniforms.start + coords;")):this.outputShape.map(((e,t)=>`sourceLoc.${Es[t]} = uniforms.start.${zn(t)} + coords.${Es[t]};`));return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          var sourceLoc : ${e};\n          let coords = getCoordsFromIndex(index);\n          ${n.join("\n")}\n          setOutputAtIndex(index, getSource(${t}));\n        }\n      }\n    `}}const Es=["x","y","z","w","u","v"];function Ws(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{begin:a,size:o}=r,[u,d]=b.parseSliceParams(s,a,o);if(b.assertParamsValid(s,u,d),n.shouldExecuteOnCPU([s])||"string"===s.dtype){const e=n.tensorMap.get(s.dataId),t=Vr(e.values,u,d,s.shape,s.dtype);return n.makeTensorInfo(d,s.dtype,t)}if(0===i.sizeFromShape(d))return n.makeTensorInfo(d,s.dtype,[]);const l=new Ts(u,d),h=[{type:"int32",data:u}];return n.runWebGPUProgram(l,[s],s.dtype,h)}const Ls={kernelName:G,backendName:"webgpu",kernelFunc:Ws},Bs={kernelName:H,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:r,attrs:s}=e,{x:a}=t,{blockShape:o,crops:u}=s;i.assert(a.shape.length<=4,(()=>"batchToSpaceND for rank > 4 with a WebGPU backend not implemented yet"));const d=o.reduce(((e,t)=>e*t)),l=n.getReshaped(a.shape,o,d),h=n.getPermuted(l.length,o.length),p=n.getReshapedPermuted(a.shape,o,d),c=n.getSliceBeginCoords(u,o.length),f=n.getSliceSize(p,u,o.length),m=[],g=wi({inputs:{x:a},backend:r,attrs:{shape:l}}),x=ss({inputs:{x:g},backend:r,attrs:{perm:h}}),y=wi({inputs:{x:x},backend:r,attrs:{shape:p}}),w=Ws({inputs:{x:y},backend:r,attrs:{begin:c,size:f}});return m.push(g),m.push(x),m.push(y),m.forEach((e=>r.disposeData(e.dataId))),w}},_s=`\n  fn bincount_write(index: i32, value: f32) {\n    ${In("&result[index]","value","float32")}\n  }\n`;class Os{constructor(e,t,n=!1){this.outputShape=[],this.variableNames=["x"],this.uniforms="binCountSize : i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.hasWeights=!0,this.binaryOutput=!1,this.outputShape=e,this.rank=e.length,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.binaryOutput=n,n&&(this.atomic=!1),this.hasWeights=t,this.hasWeights&&this.variableNames.push("w"),this.shaderKey=`bincount_${this.hasWeights}_${this.binaryOutput}_${this.rank}`}getUserCode(){return`\n    ${this.binaryOutput?"\n  fn bincount_write(index: i32, value: f32) {\n    atomicStore(&result[index], bitcast<i32>(value));\n  }\n":_s}\n  ${An("index")} {\n    ${1===this.rank?`if (index < uniforms.xShape) {\n      let indexVal = i32(getX(index));\n      if (indexVal < uniforms.binCountSize) {\n        let value = ${this.binaryOutput?1:this.hasWeights?"getW(index)":"1."};\n        bincount_write(indexVal, value);\n      }\n    }`:`let coord = getCoordsFromIndex(index);\n    if (coordsInBounds2D(coord, uniforms.xShape)) {\n      let indexVal = i32(getX(coord[0], coord[1]));\n      if (indexVal < uniforms.binCountSize) {\n        let value = ${this.binaryOutput?1:this.hasWeights?"getW(coord[0], coord[1])":"1."};\n        bincount_write(coord.x * uniforms.binCountSize + indexVal, value);\n      }\n    }`}\n  }\n  `}}const Us={kernelName:X,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s,weights:a}=t,{size:o}=r,u=i.sizeFromShape(s.shape),d=i.sizeFromShape(a.shape)>0,l=[o],h=a.dtype,p=xi({backend:n,attrs:{shape:l,value:0,dtype:h}}),c=new Os([u],d),f=[{type:"int32",data:[o]}],m=d?[s,a]:[s];return n.runWebGPUProgram(c,m,h,f,p)}};class Vs{constructor(e){this.outputShape=[],this.variableNames=["s0","s1"],this.uniforms="s0Size : i32, s1Size : i32, ",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="broadcastArgs"}getUserCode(){return`\n  ${An("index")} {\n    if (index < uniforms.size) {\n      var s0 = 1.0;\n      var s1 = 1.0;\n      let indexS0 = index - uniforms.size + uniforms.s0Size;\n      let indexS1 = index - uniforms.size + uniforms.s1Size;\n      if (indexS0 >= 0) {\n        s0 = getS0(indexS0);\n      }\n      if (indexS1 >= 0) {\n        s1 = getS1(indexS1);\n      }\n\n      if (s0 == 1.0) {\n        setOutputAtIndex(index, s1);\n      } else if (s1 == 1.0) {\n        setOutputAtIndex(index, s0);\n      } else if (s0 != s1) {\n        setOutputAtIndex(index, uniforms.NAN);\n      } else {\n        setOutputAtIndex(index, s0);\n      }\n    }\n  }\n  `}}const Ms={kernelName:K,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r}=e,{s0:s,s1:a}=t;if(r.shouldExecuteOnCPU([s,a])){const e=r.tensorMap.get(s.dataId),t=r.tensorMap.get(a.dataId),i=e.values,o=t.values,u=n.assertAndGetBroadcastShape(Array.from(i),Array.from(o));return r.makeTensorInfo([u.length],"int32",Int32Array.from(u))}const o=i.sizeFromShape(s.shape),u=i.sizeFromShape(a.shape),d=Math.max(o,u),l=new Vs(d),h=[{type:"int32",data:[o]},{type:"int32",data:[u]}];return r.runWebGPUProgram(l,[s,a],"int32",h)}},Gs=Ni({opType:Zn.NOT_EQUAL,dtype:"bool",cpuKernelImpl:Wr}),Hs={kernelName:q,backendName:"webgpu",kernelFunc:Gs};function Xs(e){const{inputs:t,backend:n}=e,{input:i}=t;return Ii({inputs:{x:n.tensorMap.get(i.dataId).complexTensorInfos.real},backend:n})}const Ks={kernelName:Y,backendName:"webgpu",kernelFunc:Xs};const qs={kernelName:j,backendName:"webgpu",kernelFunc:function t(n){const{inputs:r,backend:s,attrs:a}=n,{x:o}=r,{dtype:u}=a;if("complex64"===u){if("complex64"===o.dtype)return Ii({inputs:{x:o},backend:s});const n=e.zeros(o.shape),i=t({inputs:{x:o},backend:s,attrs:{dtype:"float32"}}),r=$i({inputs:{real:i,imag:n},backend:s});return n.dispose(),s.disposeData(i.dataId),r}if("complex64"===o.dtype){const e=Xs({inputs:{input:o},backend:s}),n=t({inputs:{x:e},backend:s,attrs:{dtype:u}});return s.disposeData(e.dataId),n}if(!i.hasEncodingLoss(o.dtype,u)){const e=Ii({inputs:{x:o},backend:s});return{dataId:e.dataId,shape:e.shape,dtype:u}}if(s.shouldExecuteOnCPU([o])){const e=s.tensorMap.get(o.dataId).values,[t,n,i]=gr(e,o.shape,o.dtype,u);return s.makeTensorInfo(t,n,i)}if("int32"===u)return function(e,t){const n=new zi(e.shape,ei.TO_INT),i=t.runWebGPUProgram(n,[e],"int32");return{dataId:i.dataId,shape:i.shape,dtype:i.dtype}}(o,s);if("bool"===u){const e=s.makeTensorInfo([],"bool",i.getTypedArrayFromDType("bool",1)),t=Gs({inputs:{a:o,b:e},backend:s});return s.disposeData(e.dataId),t}throw new Error(`Error in Cast: failed to cast ${o.dtype} to ${u}`)}},Ys={kernelName:Q,backendName:"webgpu",kernelFunc:Ai({opType:ei.CEIL,cpuKernelImpl:xr})};class js{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workPerThread=4,this.workgroupSize=[64,1,1],this.outputComponent=4,this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.shaderKey="clipVec4"}getUserCode(){return`\n      ${An("index")} {\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          var clampedValue = clamp(\n              value, vec4<f32>(uniforms.minVal), vec4<f32>(uniforms.maxVal));\n          clampedValue = select(clampedValue, value, isnanVec4(value));\n          setOutputAtIndex(index, clampedValue);\n        }\n      }\n    `}}class Qs{constructor(e){this.variableNames=["A"],this.uniforms="minVal : f32, maxVal : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="clip"}getUserCode(){return`\n      ${An("index")} {\n        if(index < uniforms.size) {\n          let value = getAByOutputIndex(index);\n          if (isnan(value)) {\n            setOutputAtIndex(index, value);\n            return;\n          }\n          setOutputAtIndex(index, clamp(value, uniforms.minVal, uniforms.maxVal));\n        }\n      }\n    `}}const Zs={kernelName:Z,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{clipValueMin:a,clipValueMax:o}=r;let u;const d=[{type:"float32",data:[a]},{type:"float32",data:[o]}];return u=i.sizeFromShape(s.shape)%4==0?new js(s.shape):new Qs(s.shape),n.runWebGPUProgram(u,[s],s.dtype,d)}};class Js{constructor(e){this.outputShape=[],this.variableNames=["real","imag"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="complexAbs"}getUserCode(){return`\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let re = abs(getRealByOutputIndex(index));\n        let im = abs(getImagByOutputIndex(index));\n        let mx = max(re, im);\n\n        // The length function in wgsl may be not underflow-safe on some GPUs.\n        // So the safe solution is to ensure underflow-safety in all cases.\n        setOutputAtIndex(index, select(mx * length(vec2<f32>(1, min(re, im)/mx)), 0.0, mx == 0.0));\n      }\n    }\n  `}}function ea(e,t){return{dataId:t.dataId,dtype:t.dtype,shape:e.shape}}const ta={kernelName:J,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:i}=t,r=n.tensorMap.get(i.dataId),s=new Js(i.shape),a=[ea(i,r.complexTensorInfos.real),ea(i,r.complexTensorInfos.imag)];return n.runWebGPUProgram(s,a,a[0].dtype)}};class na{constructor(e){this.uniforms="",this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=n.computeOutShape(e,1),this.variableNames=e.map(((e,t)=>`T${t}`)),this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]),this.offsetLength=e.length-1;for(let e=0;e<this.offsetLength;e++)this.uniforms+=`offset${e} : i32,`;this.shaderKey="concat"}getUserCode(){const e=[];if(this.offsetLength>0){e.push("if (yC < uniforms.offset0){ setOutputAtCoords(coords.x, coords.y, getT0(yR, yC)); }");for(let t=1;t<this.offsetLength;t++)e.push(`else if (yC < uniforms.offset${[t]}){ setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${t-1})); }`);const t=this.offsetLength,n=this.offsetLength-1;e.push(`else { setOutputAtCoords(coords.x, coords.y, getT${t}(yR, yC - uniforms.offset${n})); }`)}else e.push("setOutputAtCoords(coords.x, coords.y, getT0(yR, yC));");return`\n      ${An("index")} {\n        for(var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let flatIndex = index * ${this.workPerThread} + i;\n          if(flatIndex < uniforms.size) {\n            let coords = getCoordsFromIndex(flatIndex);\n            let yR = coords.x;\n            let yC = coords.y;\n\n            ${e.join("\n        ")}\n          }\n        }\n      }\n    `}}function ia(e){const{inputs:t,backend:n}=e,{input:i}=t;return Ii({inputs:{x:n.tensorMap.get(i.dataId).complexTensorInfos.imag},backend:n})}const ra={kernelName:ee,backendName:"webgpu",kernelFunc:ia};function sa(e,t,r){const s=e[0].dtype;if("complex64"===s){const n=e.map((e=>Xs({inputs:{input:e},backend:r}))),i=e.map((e=>ia({inputs:{input:e},backend:r}))),s=sa(n,t,r),a=sa(i,t,r),o=$i({inputs:{real:s,imag:a},backend:r});return n.forEach((e=>r.disposeData(e.dataId))),i.forEach((e=>r.disposeData(e.dataId))),r.disposeData(s.dataId),r.disposeData(a.dataId),o}let a=r.shouldExecuteOnCPU(e);if("string"===s&&(a=!0),a){const a=e.map((e=>{const n=i.sizeFromShape(e.shape.slice(t));return wi({inputs:{x:e},backend:r,attrs:{shape:[-1,n]}})})),o=a.map((e=>({vals:r.readSync(e.dataId),shape:e.shape}))),u=n.computeOutShape(a.map((e=>e.shape)),1),d=1===a[0].shape[0],l=yr(o,u,s,d),h=n.computeOutShape(e.map((e=>e.shape)),t),p=r.makeTensorInfo(h,s,l);return a.forEach((e=>r.disposeData(e.dataId))),p}const o=r.device.limits.maxStorageBuffersPerShaderStage-1;if(e.length>o){const n=[];for(let i=0;i<e.length;i+=o){const s=e.slice(i,i+o);n.push(sa(s,t,r))}const i=sa(n,t,r);for(const e of n)r.disposeData(e.dataId);return i}const{tensors2D:u,outShape:d}=function(e,t,r){const s=n.computeOutShape(e.map((e=>e.shape)),t);return{tensors2D:e.map((e=>wi({inputs:{x:e},backend:r,attrs:{shape:[i.sizeFromShape(e.shape.slice(0,t)),i.sizeFromShape(e.shape.slice(t))]}}))),outShape:s}}(e,t,r),l=u.map((e=>e.shape)),h=new na(l),p=[],c=new Array(l.length-1);if(c.length>0){c[0]=l[0][1],p.push({type:"int32",data:[c[0]]});for(let e=1;e<c.length;e++)c[e]=c[e-1]+l[e][1],p.push({type:"int32",data:[c[e]]})}const f=r.runWebGPUProgram(h,u,u[0].dtype,p);u.forEach((e=>r.disposeData(e.dataId)));const m=wi({inputs:{x:f},backend:r,attrs:{shape:d}});return r.disposeData(f.dataId),m}function aa(e){const{inputs:t,backend:r,attrs:s}=e,{axis:a}=s,o=i.parseAxisParam(a,t[0].shape)[0],u=t.map((e=>e.shape));n.assertParamsConsistent(u,o);const d=n.computeOutShape(t.map((e=>e.shape)),o);if(0===i.sizeFromShape(d))return r.makeTensorInfo(d,t[0].dtype,[]);const l=t.filter((e=>i.sizeFromShape(e.shape)>0));return 1===l.length?Ii({inputs:{x:l[0]},backend:r}):sa(l,o,r)}const oa={kernelName:te,backendName:"webgpu",kernelFunc:aa};class ua{constructor(e,t,n,i,r=!1,s=null,a=!1,o=!1){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, strides : vec2<i32>, dilations : vec2<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.outShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.isVec4=((e.inChannels%4==0||e.inChannels%3==0)&&this.isChannelsLast||e.outWidth%4==0&&!this.isChannelsLast)&&e.outChannels%4==0,this.dispatchLayout=this.isChannelsLast?{x:[3],y:[1,2],z:[0]}:{x:[2,3],y:[1],z:[0]},this.workgroupSize=Vn(this.dispatchLayout,this.outputShape,this.isVec4),this.elementsPerThread=Mn(this.dispatchLayout,this.outputShape,this.isVec4),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,this.elementsPerThread),this.isVec4?(this.outputComponent=4,this.isChannelsLast&&e.inChannels%4!=0?(this.innerElementSize=3,this.variableComponents=[1,4]):(this.innerElementSize=4,this.variableComponents=[4,4]),r&&(this.variableNames.push("bias"),this.variableComponents.push(4)),a&&(this.variableNames.push("preluActivationWeights"),this.variableComponents.push(4))):(this.innerElementSize=this.elementsPerThread[0],r&&this.variableNames.push("bias"),a&&this.variableNames.push("preluActivationWeights")),this.sequentialAccessByThreads=o,this.addBias=r,this.activation=s,this.hasPreluActivationWeights=a,this.tileAOuter=this.workgroupSize[1]*this.elementsPerThread[1],this.tileBOuter=this.workgroupSize[0]*this.elementsPerThread[0],this.tileInner=Math.max(this.workgroupSize[0]*this.innerElementSize,this.workgroupSize[1]),this.fitAOuter=t%this.tileAOuter==0,this.fitBOuter=n%this.tileBOuter==0,this.fitInner=i%this.tileInner==0,this.shaderKey=`conv2DMM_${this.elementsPerThread}_${this.activation}}_${this.fitAOuter}_${this.fitBOuter}_${this.fitInner}_${this.isVec4}_${this.innerElementSize}_${this.isChannelsLast}_${this.sequentialAccessByThreads}`}getUserCode(){const e=this.isVec4?ui(this.elementsPerThread,this.workgroupSize,!this.isChannelsLast,this.tileInner):li(this.elementsPerThread,this.workgroupSize,!this.isChannelsLast,this.tileInner,!1,null,this.sequentialAccessByThreads),t=this.isVec4?[this.innerElementSize,4,4]:[1,1,1];return`\n    ${function(e,t,n,i,r=!1,s=null,a=!1,o=4,u=4,d=4){const l=e?"\n      let coord = vec4<i32>(batch, xRow, xCol, xCh);\n      ":"\n      let coord = vec4<i32>(batch, xCh, xRow, xCol);\n      ",h=e?"\n      let coords = vec4<i32>(\n        batch,\n        row / outWidth,\n        row % outWidth,\n        col);\n      ":"\n      let coords = vec4<i32>(\n        batch,\n        row,\n        col / outWidth,\n        col % outWidth);\n      ",p=e?"uniforms.xShape[1]":"uniforms.xShape[2]",c=e?"uniforms.xShape[2]":"uniforms.xShape[3]",f=e?"row":"col",m=e?"col":"row",g=`\n      let inChannels = uniforms.wShape[2];\n      let outWidth = ${e?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n      let outRow = ${f} / outWidth;\n      let outCol = ${f} % outWidth;\n\n      let WRow = ${m} / (uniforms.filterDims[1] * inChannels);\n      let WCol = ${m} / inChannels % uniforms.filterDims[1];\n      let xRow = outRow * uniforms.strides[0] + uniforms.dilations[0] * WRow - uniforms.pads[0];\n      let xCol = outCol * uniforms.strides[1] + uniforms.dilations[1] * WCol - uniforms.pads[1];\n      let xCh = ${m} % inChannels;\n      var resData = ${$n(o)}(0.0);\n      // The bounds checking is always needed since we use it to pad zero for\n      // the 'same' padding type.\n      if (xRow >= 0 && xRow < ${p} && xCol >= 0 && xCol < ${c}) {\n        ${l}\n        let xIndex = getIndexFromCoords4D(coord, uniforms.xShape);\n        ${(e=>{switch(e){case 1:return"resData = x[xIndex];";case 3:return"resData = vec3<f32>(x[xIndex], x[xIndex + 1], x[xIndex + 2]);";case 4:return"resData = x[xIndex / 4];";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(o)}\n      }\n      return resData;`,x=e?t&&i?`\n      let col = colIn * ${o};\n      ${g}`:`\n      let col = colIn * ${o};\n      if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n        ${g}\n      }\n      return ${$n(o)}(0.0);`:i&&n?`\n      let col = colIn * ${o};\n      ${g}`:`\n      let col = colIn * ${o};\n      if (row < uniforms.dimInner && col < uniforms.dimBOuter) {\n        ${g}\n      }\n      return ${$n(o)}(0.0);`,y=`${(e=>{switch(e){case 1:return"return W[row * uniforms.wShape[3] + colIn];";case 4:return"return W[row * uniforms.wShape[3] / 4 + colIn];";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(u)}`,w=$n(d),b=$n(e?o:u),C=$n(e?u:o);return`\n      ${ri(s,a,4===d,4)}\n      fn mm_readA(batch: i32, row : i32, colIn : i32) -> ${b} {\n        ${e?x:y}\n      }\n\n      fn mm_readB(batch: i32, row : i32, colIn : i32) -> ${C} {\n        ${e?y:x}\n      }\n\n      fn mm_write(batch: i32, row : i32, colIn : i32, valueIn : ${w}) {\n        let col = colIn * ${d};\n        if (row < uniforms.dimAOuter && col < uniforms.dimBOuter)\n        {\n        var value = valueIn;\n        let outWidth = ${e?"uniforms.outShape[2]":"uniforms.outShape[3]"};\n        ${h}\n        ${si(r,s)}\n        setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }`}(this.isChannelsLast,this.fitAOuter,this.fitBOuter,this.fitInner,this.addBias,this.activation,this.hasPreluActivationWeights,t[0],t[1],t[2])}\n    ${e}\n  `}}class da{constructor(e,t=!1,n=null,i=!1){this.variableNames=["x","W"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>,",this.workgroupSize=[4,4,8],this.outputShape=e.outShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.dispatchLayout=this.isChannelsLast?{x:[2],y:[1],z:[0,3]}:{x:[3],y:[2],z:[0,1]},this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.addBias=t,this.activation=n,this.hasPreluActivationWeights=i,t&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.shaderKey=`conv2dnaive_${this.activation}_${this.isChannelsLast}`}getUserCode(){return`\n       ${ri(this.activation,this.hasPreluActivationWeights,!1,4)}\n       fn readInp(batch : i32, row : i32, col : i32, chan : i32) -> f32{\n         let coords = vec4<i32>(batch, row, col, chan);\n         if (coordsInBounds4D(coords, uniforms.xShape)) {\n           return  getX(batch, row, col, chan);\n         } else {\n          return 0.0;\n         }\n       }\n       fn readFilt(row : i32, col : i32, xChannel : i32, outChannel : i32) -> f32{\n         let coords = vec4<i32>(row, col, xChannel, outChannel);\n         if(coordsInBounds4D(coords, uniforms.wShape)) {\n           return getW(row, col, xChannel, outChannel);\n          } else {\n            return 0.0;\n          }\n       }\n       fn writeResult(batch : i32, row : i32, col : i32, chan : i32, valueIn : f32) {\n         let coords = ${this.isChannelsLast?"vec4<i32>(batch, row, col, chan);":"vec4<i32>(batch, chan, row, col);"}\n         if (coordsInBounds4D(coords, uniforms.outShape)) {\n           var value = valueIn;\n           ${si(this.addBias,this.activation)}\n           setOutputAtCoords(coords.x, coords.y, coords.z, coords.w, value);\n         }\n       }\n       ${An("index")} {\n         let coords = getOutputCoords();\n         let batch = coords[0];\n         let outChannel = ${this.isChannelsLast?"coords[3];":"coords[1];"}\n         let outRow = ${this.isChannelsLast?"coords[1];":"coords[2];"}\n         let outCol = ${this.isChannelsLast?"coords[2];":"coords[3];"}\n         var acc : f32 = 0.0;\n         for (var row = 0; row < uniforms.filterDims[0]; row = row + 1) {\n           for (var col = 0; col < uniforms.filterDims[1]; col = col + 1) {\n             let xRow = outRow * uniforms.strides[0] + uniforms.dilations[0] * row - uniforms.pads[0];\n             let xCol = outCol * uniforms.strides[1] + uniforms.dilations[1] * col - uniforms.pads[1];\n             for (var xChannel = 0; xChannel < ${this.isChannelsLast?"uniforms.xShape[3];":"uniforms.xShape[1];"} xChannel = xChannel + 1) {\n               ${this.isChannelsLast?"let v = readInp(batch, xRow, xCol, xChannel);":"let v = readInp(batch, xChannel, xRow, xCol);"}\n               let f = readFilt(row, col, xChannel, outChannel);\n               acc = acc + v * f;\n             }\n           }\n         }\n         writeResult(batch, outRow, outCol, outChannel, acc);\n       }\n     `}}class la{constructor(e,t){this.variableNames=["x"],this.uniforms="pads : vec2<i32>, strides : vec2<i32>, dilations : vec2<i32>, outWidth : i32, itemsPerBlockRow : i32,\n       inChannels : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.isChannelsLast=t,this.shaderKey=`im2col_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?1:2,t=this.isChannelsLast?2:3,n=this.isChannelsLast?"coords[1]":"coords[2]",i=this.isChannelsLast?"coords[2]":"coords[1]",r=this.isChannelsLast?"getX(batch, xRow, xCol, ch)":"getX(batch, ch, xRow, xCol)";return`\n    ${An("index")} {\n      let coords = getCoordsFromIndex(index);\n      if(index < uniforms.size) {\n        let batch = coords[0];\n        let row = ${n};\n        let col = ${i};\n        let offsetY = (row / uniforms.outWidth) * uniforms.strides[0] - uniforms.pads[0];\n        let xRow = offsetY + uniforms.dilations[0] * (col / uniforms.itemsPerBlockRow);\n        var value = 0.0;\n        if(xRow < uniforms.xShape[${e}] && xRow >= 0) {\n          let offsetX = (row % uniforms.outWidth) * uniforms.strides[1] -\n              uniforms.pads[1];\n          let xCol = offsetX + uniforms.dilations[1] * ((col %\n              uniforms.itemsPerBlockRow) / uniforms.inChannels);\n          let ch = col % uniforms.inChannels;\n          if(xCol < uniforms.xShape[${t}] && xCol >= 0) {\n            value = ${r};\n          }\n        }\n        setOutputAtIndex(index, value);\n      }\n    }\n   `}}function ha(e,t){const n=e.length;return n>=3?t?[...e.slice(0,-3),e[n-3]*e[n-2],e[n-1]]:[...e.slice(0,-3),e[n-3],e[n-2]*e[n-1]]:!t&&1===n&&e[0]>1?[e[0],1]:null}function pa({x:e,filter:n,convInfo:i,backend:r,bias:s=null,preluActivationWeights:a=null,leakyreluAlpha:o=0,activation:u=null}){const d=null!=s,l=null!=a,h="channelsLast"===i.dataFormat,p=h&&i.filterHeight===i.inHeight&&i.filterWidth===i.inWidth&&"VALID"===i.padInfo.type,c=t().getBool("WEBGPU_USE_NAIVE_CONV2D_DEBUG");if(!c&&(p||1===i.filterHeight&&1===i.filterWidth&&1===i.dilationHeight&&1===i.dilationWidth&&1===i.strideHeight&&1===i.strideWidth&&("SAME"===i.padInfo.type||"VALID"===i.padInfo.type)))return function({x:e,filter:t,convInfo:n,backend:i,bias:r=null,preluActivationWeights:s=null,leakyreluAlpha:a=0,activation:o=null}){const u="channelsLast"===n.dataFormat,d=!u,l=[];let h,p;if(u&&n.filterHeight===n.inHeight&&n.filterWidth===n.inWidth&&"VALID"===n.padInfo.type){const r=n.inHeight*n.inWidth*n.inChannels;h=wi({inputs:{x:e},backend:i,attrs:{shape:[1,n.batchSize,r]}}),p=wi({inputs:{x:t},backend:i,attrs:{shape:[1,r,n.outChannels]}})}else h=wi({inputs:{x:e},backend:i,attrs:{shape:u?[n.batchSize,n.inHeight*n.inWidth,n.inChannels]:[n.batchSize,n.inChannels,n.inHeight*n.inWidth]}}),p=wi({inputs:{x:t},backend:i,attrs:{shape:[1,n.inChannels,n.outChannels]}});if(l.push(h),l.push(p),null!=s){const e=ha(s.shape,u);null!=e&&(s=wi({inputs:{x:s},backend:i,attrs:{shape:e}}),l.push(s))}if(null!=r){const e=ha(r.shape,u);null!=e&&(r=wi({inputs:{x:r},backend:i,attrs:{shape:e}}),l.push(r))}const c=Ci({a:u?h:p,b:u?p:h,transposeA:d,transposeB:!1,backend:i,bias:r,activation:o,preluActivationWeights:s,leakyreluAlpha:a}),f=wi({inputs:{x:c},backend:i,attrs:{shape:n.outShape}});l.push(c);for(const e of l)i.disposeData(e.dataId);return f}({x:e,filter:n,convInfo:i,backend:r,bias:s,activation:u,preluActivationWeights:a,leakyreluAlpha:o});const f=t().getNumber("WEBGPU_THRESHOLD_TO_INCREASE_WORKGROUPS_FOR_MATMUL"),m=f>0?f:r.thresholdToIncreaseWorkgroups,g=i.batchSize*Math.ceil(i.outHeight*i.outWidth/32)*Math.ceil(i.outChannels/32);if(t().getBool("WEBGPU_CONV_SEPARATE_IM2COL_SHADER")||g<=m)return function({x:e,filter:t,convInfo:n,backend:i,bias:r=null,preluActivationWeights:s=null,leakyreluAlpha:a=0,activation:o=null}){const{filterWidth:u,filterHeight:d,inChannels:l,strideWidth:h,strideHeight:p,padInfo:c,outWidth:f,outHeight:m,dilationWidth:g,dilationHeight:x,dataFormat:y}=n,w="channelsLast"===y,b=u*d*l,C=m*f,S=w?[n.batchSize,C,b]:[n.batchSize,b,C],v=new la(S,w),k=[{type:"int32",data:[c.top,c.left]},{type:"int32",data:[p,h]},{type:"int32",data:[x,g]},{type:"int32",data:[f]},{type:"int32",data:[l*u]},{type:"int32",data:[l]}],I=i.runWebGPUProgram(v,[e],e.dtype,k),R=[];R.push(I);const $=wi({inputs:{x:t},backend:i,attrs:{shape:[1,b,-1]}});if(R.push($),null!=s){const e=ha(s.shape,w);null!=e&&(s=wi({inputs:{x:s},backend:i,attrs:{shape:e}}),R.push(s))}if(null!=r){const e=ha(r.shape,w);null!=e&&(r=wi({inputs:{x:r},backend:i,attrs:{shape:e}}),R.push(r))}const P=Ci({a:w?I:$,b:w?$:I,transposeA:!w,transposeB:!1,backend:i,bias:r,activation:o,preluActivationWeights:s,leakyreluAlpha:a}),z=wi({inputs:{x:P},backend:i,attrs:{shape:n.outShape}});R.push(P);for(const e of R)i.disposeData(e.dataId);return z}({x:e,filter:n,convInfo:i,backend:r,bias:s,preluActivationWeights:a,leakyreluAlpha:o,activation:u});let x;const y=[i.padInfo.top,i.padInfo.left],w=[{type:"int32",data:[i.filterHeight,i.filterWidth]},{type:"int32",data:[...y]},{type:"int32",data:[i.strideHeight,i.strideWidth]},{type:"int32",data:[i.dilationHeight,i.dilationWidth]}];if(c)x=new da(i,d,u,l);else{const e=h?i.outHeight*i.outWidth:i.outChannels,t=h?i.outChannels:i.outHeight*i.outWidth,n=i.filterHeight*i.filterWidth*i.inChannels;w.push({type:"int32",data:[e]},{type:"int32",data:[t]},{type:"int32",data:[n]});const s=r.adapterInfo.isIntel();x=new ua(i,e,t,n,d,u,l,s)}const b=[],C=[e,n];d&&(h||1!==s.shape.length||(s=wi({inputs:{x:s},backend:r,attrs:{shape:[s.shape[0],1,1]}}),b.push(s)),C.push(s)),l&&(h||1!==a.shape.length||(a=wi({inputs:{x:a},backend:r,attrs:{shape:[a.shape[0],1,1]}}),b.push(a)),C.push(a)),"leakyrelu"===u&&(w.push({type:"float32",data:[o]}),x.uniforms+=" alpha : f32,");const S=r.runWebGPUProgram(x,C,e.dtype,w);for(const e of b)r.disposeData(e.dataId);return S}const ca={kernelName:ne,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,attrs:i,backend:r}=e,{x:s,filter:a}=t,{strides:o,pad:u,dataFormat:d,dilations:l,dimRoundingMode:h}=i,p=n.convertConv2DDataFormat(d);return pa({x:s,filter:a,convInfo:n.computeConv2DInfo(s.shape,a.shape,o,l,u,h,!1,p),backend:r})}};class fa{constructor(e){this.variableNames=["dy","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, strides : vec2<i32>, outBackprop : vec4<i32>,",this.workgroupSize=[64,1,1],this.size=!1,this.isVec4=!1,this.workPerThread=1,this.outputShape=e.inShape,this.isChannelsLast="channelsLast"===e.dataFormat,this.isVec4=this.isChannelsLast&&e.outChannels%4==0&&e.inChannels%4==0,this.isVec4?(this.workPerThread=2,this.outputComponent=4,this.workgroupSize=[4,4,4],this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[4,this.workPerThread,1])):(this.size=!0,this.workPerThread=1,this.workgroupSize=[64,1,1],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize)),this.shaderKey=`conv2DDerInput_${this.isChannelsLast}_${this.isVec4}_${this.workPerThread}`}getUserCode(){const e=this.isChannelsLast?1:2,t=this.isChannelsLast?2:3,n=this.isChannelsLast?3:1,i=`\n    ${An()} {\n      let batch = i32(globalId.z) / uniforms.outShape[1];\n      let r = i32(globalId.z) % uniforms.outShape[1];\n      let c = i32(globalId.y) * ${this.workPerThread};\n      let d1 = i32(globalId.x) * 4;\n\n      let dyCorner = vec2<i32>(r, c) - uniforms.pads;\n\n      // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n      // ? = to be determined. : = across all values in that axis.\n      var dotProd: array<vec4<f32>, ${this.workPerThread}>;\n      for (var i = 0; i < ${this.workPerThread}; i++) {\n        dotProd[i] = vec4<f32>(0.0);\n      }\n      for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + 1) {\n        let dyR = f32(dyCorner.x + wR) / f32(uniforms.strides.x);\n        let wRPerm = uniforms.filterDims.x - 1 - wR;\n        if (dyR < 0.0 || dyR >= f32(uniforms.outBackprop[1]) ||\n            fract(dyR) > 0.0) {\n          continue;\n        }\n        let idyR = i32(dyR);\n\n        for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + 1) {\n          let dyC = f32(dyCorner.y + wC) / f32(uniforms.strides.y);\n          let dyC2 = f32(dyCorner.y + 1 + wC) / f32(uniforms.strides.y);\n          let wCPerm = uniforms.filterDims.y - 1 - wC;\n          var bDyCVal = true;\n          var bDyCVal2 = true;\n          if (dyC < 0.0 || dyC >= f32(uniforms.outBackprop[2]) ||\n              fract(dyC) > 0.0) {\n            bDyCVal = false;\n          }\n          if (dyC2 < 0.0 || dyC2 >= f32(uniforms.outBackprop[2]) ||\n              fract(dyC2) > 0.0) {\n            bDyCVal2 = false;\n          }\n\n          let idyC = i32(dyC);\n          let idyC2 = i32(dyC2);\n          if (bDyCVal && bDyCVal2) {\n            let d2Length = uniforms.outBackprop[3];\n            for (var d2 = 0; d2 < d2Length; d2 = d2 + 4) {\n              let wValue0 = getW(wRPerm, wCPerm, d1, d2);\n              let wValue1 = getW(wRPerm, wCPerm, d1 + 1, d2);\n              let wValue2 = getW(wRPerm, wCPerm, d1 + 2, d2);\n              let wValue3 = getW(wRPerm, wCPerm, d1 + 3, d2);\n              var xValue =  getDy(batch, idyR, idyC, d2);\n              let tmpval = vec4<f32>(dot(xValue, wValue0),\n                                     dot(xValue, wValue1),\n                                     dot(xValue, wValue2),\n                                     dot(xValue, wValue3));\n              dotProd[0] = dotProd[0] + tmpval;\n              xValue = getDy(batch, idyR, idyC2, d2);\n              dotProd[1] = dotProd[1] + vec4<f32>(dot(xValue, wValue0),\n                                                  dot(xValue, wValue1),\n                                                  dot(xValue, wValue2),\n                                                  dot(xValue, wValue3));\n            }\n          } else if (bDyCVal) {\n            let d2Length = uniforms.outBackprop[3];\n            for (var d2 = 0; d2 < d2Length; d2 = d2 + 4) {\n              let wValue0 = getW(wRPerm, wCPerm, d1, d2);\n              let wValue1 = getW(wRPerm, wCPerm, d1 + 1, d2);\n              let wValue2 = getW(wRPerm, wCPerm, d1 + 2, d2);\n              let wValue3 = getW(wRPerm, wCPerm, d1 + 3, d2);\n              var xValue =  getDy(batch, idyR, idyC, d2);\n              let tmpval = vec4<f32>(dot(xValue, wValue0),\n                                     dot(xValue, wValue1),\n                                     dot(xValue, wValue2),\n                                     dot(xValue, wValue3));\n              dotProd[0] = dotProd[0] + tmpval;\n            }\n          } else if (bDyCVal2) {\n            let d2Length = uniforms.outBackprop[3];\n            for (var d2 = 0; d2 < d2Length; d2 = d2 + 4) {\n              let wValue0 = getW(wRPerm, wCPerm, d1, d2);\n              let wValue1 = getW(wRPerm, wCPerm, d1 + 1, d2);\n              let wValue2 = getW(wRPerm, wCPerm, d1 + 2, d2);\n              let wValue3 = getW(wRPerm, wCPerm, d1 + 3, d2);\n              var xValue =  getDy(batch, idyR, idyC2, d2);\n              let tmpval = vec4<f32>(dot(xValue, wValue0),\n                                     dot(xValue, wValue1),\n                                     dot(xValue, wValue2),\n                                     dot(xValue, wValue3));\n              dotProd[1] = dotProd[1] + tmpval;\n            }\n          }\n        }\n      }\n\n      for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n        let coords = vec4<i32>(batch, r, c + i, d1);\n        if (coordsInBounds4D(coords, uniforms.outShape)) {\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], dotProd[i]);\n        }\n      }\n    }\n    `;return this.isVec4?`\n    ${i}\n    `:`\n    ${An("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d1 = coords[${n}];\n\n        let dyCorner = vec2<i32>(coords[${e}], coords[${t}]) - uniforms.pads;\n        let dyRCorner = dyCorner.x;\n        let dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims.x; wR = wR + 1) {\n          let dyR = (f32(dyRCorner) + f32(wR)) / f32(uniforms.strides.x);\n          let wRPerm = uniforms.filterDims.x - 1 - wR;\n          if (dyR < 0.0 || dyR >= f32(uniforms.outBackprop[1]) || fract(dyR) > 0.0 ||\n              wRPerm < 0) {\n            continue;\n          }\n          let idyR = i32(dyR);\n\n          for (var wC = 0; wC < uniforms.filterDims.y; wC = wC + 1) {\n            let dyC = (f32(dyCCorner) + f32(wC)) / f32(uniforms.strides.y);\n            let wCPerm = uniforms.filterDims.y - 1 - wC;\n            if (dyC < 0.0 || dyC >= f32(uniforms.outBackprop[2]) ||\n                fract(dyC) > 0.0 || wCPerm < 0) {\n              continue;\n            }\n            let idyC = i32(dyC);\n\n            for (var d2 = 0; d2 < uniforms.outBackprop[3]; d2 = d2 + 1) {\n              let xValue = ${this.isChannelsLast?"getDy(batch, idyR, idyC, d2)":"getDy(batch, d2, idyR, idyC)"};\n              let wValue = getW(wRPerm, wCPerm, d1, d2);\n              dotProd = dotProd + xValue * wValue;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}class ma{constructor(e){this.variableNames=["x","dy"],this.uniforms="pads : vec2<i32>, strides : vec2<i32>, batchSize : i32, outHeight : i32, outWidth : i32, inHeight : i32, inWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.filterShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,this.shaderKey=`conv2DDerFilter_${this.isChannelsLast}`}getUserCode(){return`\n    ${An("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let wR = coords[0];\n        let wC = coords[1];\n        let d1 = coords[2];\n        let d2 = coords[3];\n\n        // Convolve x(?, ?, d1) with dy(:, :, d2) to get dw(wR, wC, d1, d2).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        for (var b = 0; b < uniforms.batchSize; b = b + 1) {\n          for (var yR = 0; yR < uniforms.outHeight; yR = yR + 1) {\n            let xR = wR + yR * uniforms.strides[0] - uniforms.pads[0];\n            if (xR < 0 || xR >= uniforms.inHeight) {\n              continue;\n            }\n\n            for (var yC = 0; yC < uniforms.outWidth; yC = yC + 1) {\n              let xC = wC + yC * uniforms.strides[1] - uniforms.pads[1];\n\n              if (xC < 0 || xC >= uniforms.inWidth) {\n                continue;\n              }\n\n              if (${this.isChannelsLast}) {\n                let dyValue = getDy(b, yR, yC, d2);\n                let xValue = getX(b, xR, xC, d1);\n                dotProd = dotProd + xValue * dyValue;\n              } else {\n                let dyValue = getDy(b, d2, yR, yC);\n                let xValue = getX(b, d1, xR, xC);\n                dotProd = dotProd + xValue * dyValue;\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}class ga{constructor(e){this.variableNames=["x","dy"],this.uniforms="pads : vec3<i32>, strides : vec3<i32>, batchSize : i32, outDepth : i32,\n       outHeight : i32, outWidth : i32, inDepth : i32, inHeight : i32, inWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.filterShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="conv3DDerFilter"}getUserCode(){return`\n    ${An("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let wF = coords.x;\n        let wR = coords.y;\n        let wC = coords.z;\n        let d1 = coords.w;\n        let d2 = coords.u;\n\n        var dotProd = 0.0;\n        for (var b = 0; b < uniforms.batchSize; b++) {\n          for (var yF = 0; yF < uniforms.outDepth; yF++) {\n            let xF = wF + yF * uniforms.strides[0] - uniforms.pads[0];\n            if (xF < 0 || xF >= uniforms.inDepth) {\n              continue;\n            }\n\n            for (var yR = 0; yR < uniforms.outHeight; yR++) {\n              let xR = wR + yR * uniforms.strides[1] - uniforms.pads[1];\n              if (xR < 0 || xR >= uniforms.inHeight) {\n                continue;\n              }\n\n              for (var yC = 0; yC < uniforms.outWidth; yC++) {\n                let xC = wC + yC * uniforms.strides[2] - uniforms.pads[2];\n                if (xC < 0 || xC >= uniforms.inWidth) {\n                  continue;\n                }\n\n                let dyValue = getDy(b, yF, yR, yC, d2);\n                let xValue = getX(b, xF, xR, xC, d1);\n                dotProd += xValue * dyValue;\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}class xa{constructor(e){this.variableNames=["dy","W"],this.uniforms="filterDims : vec3<i32>, pads : vec3<i32>, strides : vec3<i32>,\n      outDepth : i32, outHeight : i32, outWidth : i32, outChannels : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="conv3DDerInput"}getUserCode(){return`\n    ${An("index")} {\n      if(index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords.x;\n        let d1 = coords.u;\n\n        let dyCorner = vec3<i32>(coords.y, coords.z, coords.w) - uniforms.pads;\n        let dyFCorner = dyCorner.x;\n        let dyRCorner = dyCorner.y;\n        let dyCCorner = dyCorner.z;\n\n        var dotProd = 0.0;\n        for (var wF = 0; wF < uniforms.filterDims[0]; wF++) {\n          let dyF = f32(dyFCorner + wF) / f32(uniforms.strides[0]);\n          if (dyF < 0.0 || dyF >= f32(uniforms.outDepth) || fract(dyF) > 0.0) {\n            continue;\n          }\n          let idyF = i32(dyF);\n\n          let wFPerm = uniforms.filterDims[0] - 1 - wF;\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[1]);\n\n            if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n              continue;\n            }\n            let idyR = i32(dyR);\n\n            let wRPerm = uniforms.filterDims[1] - 1 - wR;\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[2]);\n\n              if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n                continue;\n              }\n              let idyC = i32(dyC);\n\n              let wCPerm = uniforms.filterDims[2] - 1 - wC;\n\n              for (var d2 = 0; d2 < uniforms.outChannels; d2++) {\n                let xValue = getDy(batch, idyF, idyR, idyC, d2);\n                let wValue = getW(wFPerm, wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n  `}}const ya={kernelName:ie,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s,dy:a}=t,{strides:o,pad:u,dataFormat:d,dimRoundingMode:l,filterShape:h}=r,p=n.convertConv2DDataFormat(d),c=n.computeConv2DInfo(s.shape,h,o,1,u,l,!1,p),f=new ma(c),m=[{type:"int32",data:[c.padInfo.top,c.padInfo.left]},{type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.batchSize]},{type:"int32",data:[c.outHeight]},{type:"int32",data:[c.outWidth]},{type:"int32",data:[c.inHeight]},{type:"int32",data:[c.inWidth]}];return i.runWebGPUProgram(f,[s,a],s.dtype,m)}};class wa{constructor(e){this.variableNames=["x","W"],this.uniforms="filterDims : vec2<i32>, pads : vec2<i32>, strides : vec2<i32>, outBackprop : vec4<i32>, dimAOuter : i32, dimBOuter : i32, dimInner : i32,",this.outputShape=e.inShape,i.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),this.isVec4=e.inChannels%4==0&&e.outChannels%4==0,this.dispatchLayout={x:[3],y:[1,2],z:[0]},this.workgroupSize=Vn(this.dispatchLayout,this.outputShape,this.isVec4),this.elementsPerThread=Mn(this.dispatchLayout,this.outputShape,this.isVec4),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,this.elementsPerThread),this.isVec4&&(this.outputComponent=4,this.variableComponents=[4,1]),this.shaderKey=`conv2DDerInputMM_${this.isVec4}_${this.elementsPerThread}`}getUserCode(){const e=this.isVec4?ui(this.elementsPerThread,this.workgroupSize):li(this.elementsPerThread,this.workgroupSize);return`\n    ${function(e=4){const t=`if (row < uniforms.dimAOuter && col < uniforms.dimInner) {\n        \n      let outRow = row / uniforms.outShape[2];\n      let outCol = row % uniforms.outShape[2];\n\n      let WRow = col / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n      let WCol = col / uniforms.outBackprop[3] % uniforms.filterDims[1];\n      let xR = f32(outRow - uniforms.pads[0] + WRow) / f32(uniforms.strides[0]);\n      let xC = f32(outCol - uniforms.pads[1] + WCol) / f32(uniforms.strides[1]);\n      if (xR < 0.0 || xR >= f32(uniforms.outBackprop[1]) || fract(xR) > 0.0) {\n        return ${$n(e)}(0.0);\n      }\n      if (xC < 0.0 || xC >= f32(uniforms.outBackprop[2]) || fract(xC) > 0.0) {\n        return ${$n(e)}(0.0);\n      }\n      let coord = vec4<i32>(\n          batch,\n          i32(xR),\n          i32(xC),\n          col % uniforms.outBackprop[3]);\n      return x[getIndexFromCoords4D(coord, uniforms.xShape)/${e}];\n      }\n      return ${$n(e)}(0.0);`;return`\n  fn mm_readA(batch: i32, row : i32, colIn : i32) -> ${$n(e)} {\n    let col = colIn * ${e};\n    ${t}\n  }\n\n  fn mm_readB(batch: i32, row : i32, colIn : i32) -> ${$n(e)} {\n    let col = colIn * ${e};\n    let coordX = uniforms.filterDims.x - 1 -\n        row / (uniforms.filterDims[1] * uniforms.outBackprop[3]);\n    let coordY = uniforms.filterDims.y - 1 -\n        (row / uniforms.outBackprop[3]) % uniforms.filterDims[1];\n    if (row < uniforms.dimInner && col < uniforms.dimBOuter &&\n        coordX >= 0 && coordY >= 0) {\n      let rowInner = row % uniforms.outBackprop[3];\n      let coord = vec4<i32>(coordX, coordY, col, rowInner);\n      ${(e=>{switch(e){case 1:return"return W[getIndexFromCoords4D(coord, uniforms.wShape)];";case 4:return"\n            let coord1 = vec4<i32>(coordX, coordY, col + 1, rowInner);\n            let coord2 = vec4<i32>(coordX, coordY, col + 2, rowInner);\n            let coord3 = vec4<i32>(coordX, coordY, col + 3, rowInner);\n            let v0 = W[getIndexFromCoords4D(coord, uniforms.wShape)];\n            let v1 = W[getIndexFromCoords4D(coord1, uniforms.wShape)];\n            let v2 = W[getIndexFromCoords4D(coord2, uniforms.wShape)];\n            let v3 = W[getIndexFromCoords4D(coord3, uniforms.wShape)];\n            return vec4<f32>(v0, v1, v2, v3);\n            ";default:throw new Error(`innerElementSize ${e} is not supported.`)}})(e)}\n    }\n    return ${$n(e)}(0.0);\n  }\n\n  fn mm_write(batch: i32, row : i32, colIn : i32, valueInput : ${$n(e)}) {\n    let col = colIn * ${e};\n    if (row < uniforms.dimAOuter && (col + ${e-1}) < uniforms.dimBOuter) {\n      var value = valueInput;\n      let outCoord = vec4<i32>(\n          batch,\n          row / uniforms.outShape[2],\n          row % uniforms.outShape[2],\n          col);\n      result[getIndexFromCoords4D(outCoord, uniforms.outShape)/${e}] = value;\n    }\n  }`}(this.isVec4?4:1)}\n    ${e}\n    `}}const ba={kernelName:re,backendName:"webgpu",kernelFunc:function(e){const{inputs:i,backend:r,attrs:s}=e,{dy:a,filter:o}=i,{inputShape:u,strides:d,pad:l,dataFormat:h,dimRoundingMode:p}=s,c=n.convertConv2DDataFormat(h),f=n.computeConv2DInfo(u,o.shape,d,1,l,p,!1,c),m=[{type:"int32",data:[f.filterHeight,f.filterWidth]},{type:"int32",data:[f.filterHeight-1-f.padInfo.top,f.filterWidth-1-f.padInfo.left]},{type:"int32",data:[f.strideHeight,f.strideWidth]},{type:"int32",data:[f.batchSize,f.outHeight,f.outWidth,f.outChannels]}];let g;if(t().getBool("WEBGPU_USE_NAIVE_CONV2D_TRANSPOSE")||"channelsLast"!==f.dataFormat)g=new fa(f);else{g=new wa(f);const e=f.inHeight*f.inWidth,t=f.inChannels,n=f.filterHeight*f.filterWidth*f.outChannels;m.push({type:"uint32",data:[e]},{type:"uint32",data:[t]},{type:"uint32",data:[n]})}return r.runWebGPUProgram(g,[a,o],"float32",m)}};class Ca{constructor(e){this.variableNames=["x","W"],this.uniforms="filterDims: vec3<i32>, pads: vec3<i32>, strides: vec3<i32>, dilations: vec3<i32>,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="conv3dnaive"}getUserCode(){return`\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let batch = coords.x;\n        let d2 = coords.u;\n\n        let xFRCCorner = vec3<i32>(coords.y, coords.z, coords.w) * uniforms.strides - uniforms.pads;\n        let xFCorner = xFRCCorner.x;\n        let xRCorner = xFRCCorner.y;\n        let xCCorner = xFRCCorner.z;\n\n        let inputDepthNearestVec4 = (uniforms.xShape.u / 4) * 4;\n        let inputDepthVec4Remainder = uniforms.xShape.u % 4;\n\n        var dotProd = 0.0;\n        for (var wF = 0; wF < uniforms.filterDims[0]; wF++) {\n          let xF = xFCorner + wF * uniforms.dilations[0];\n          if (xF < 0 || xF >= uniforms.xShape.y) {\n            continue;\n          }\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let xR = xRCorner + wR * uniforms.dilations[1];\n            if (xR < 0 || xR >= uniforms.xShape.z) {\n              continue;\n            }\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let xC = xCCorner + wC * uniforms.dilations[2];\n              if (xC < 0 || xC >= uniforms.xShape.w) {\n                continue;\n              }\n\n              for (var d1 = 0; d1 < inputDepthNearestVec4; d1 += 4) {\n                let xValues = vec4<f32>(\n                  getX(batch, xF, xR, xC, d1),\n                  getX(batch, xF, xR, xC, d1 + 1),\n                  getX(batch, xF, xR, xC, d1 + 2),\n                  getX(batch, xF, xR, xC, d1 + 3)\n                );\n                let wValues = vec4<f32>(\n                  getW(wF, wR, wC, d1, d2),\n                  getW(wF, wR, wC, d1 + 1, d2),\n                  getW(wF, wR, wC, d1 + 2, d2),\n                  getW(wF, wR, wC, d1 + 3, d2)\n                );\n\n                dotProd += dot(xValues, wValues);\n              }\n\n              if (inputDepthVec4Remainder == 1) {\n                dotProd += getX(batch, xF, xR, xC, inputDepthNearestVec4) *\n                  getW(wF, wR, wC, inputDepthNearestVec4, d2);\n              } else if (inputDepthVec4Remainder == 2) {\n                let xValues = vec2<f32>(\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4),\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4 + 1)\n                );\n                let wValues = vec2<f32>(\n                  getW(wF, wR, wC, inputDepthNearestVec4, d2),\n                  getW(wF, wR, wC, inputDepthNearestVec4 + 1, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              } else if (inputDepthVec4Remainder == 3) {\n                let xValues = vec3<f32>(\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4),\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4 + 1),\n                  getX(batch, xF, xR, xC, inputDepthNearestVec4 + 2)\n                );\n                let wValues = vec3<f32>(\n                  getW(wF, wR, wC, inputDepthNearestVec4, d2),\n                  getW(wF, wR, wC, inputDepthNearestVec4 + 1, d2),\n                  getW(wF, wR, wC, inputDepthNearestVec4 + 2, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }`}}const Sa={kernelName:se,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s,filter:a}=t,{strides:o,pad:u,dilations:d}=r,l=n.computeConv3DInfo(s.shape,a.shape,o,d,u),h=[l.padInfo.front,l.padInfo.top,l.padInfo.left],p=[{type:"int32",data:[l.filterDepth,l.filterHeight,l.filterWidth]},{type:"int32",data:[...h]},{type:"int32",data:[l.strideDepth,l.strideHeight,l.strideWidth]},{type:"int32",data:[l.dilationDepth,l.dilationHeight,l.dilationWidth]}],c=new Ca(l),f=m(s.dtype,a.dtype);return i.runWebGPUProgram(c,[s,a],f,p)}};const va={kernelName:ae,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s,dy:a}=t,{strides:o,pad:u,filterShape:d}=r,l=n.computeConv3DInfo(s.shape,d,o,1,u),h=new ga(l),p=[{type:"int32",data:[l.padInfo.front,l.padInfo.top,l.padInfo.left]},{type:"int32",data:[l.strideDepth,l.strideHeight,l.strideWidth]},{type:"int32",data:[l.batchSize]},{type:"int32",data:[l.outDepth]},{type:"int32",data:[l.outHeight]},{type:"int32",data:[l.outWidth]},{type:"int32",data:[l.inDepth]},{type:"int32",data:[l.inHeight]},{type:"int32",data:[l.inWidth]}];return i.runWebGPUProgram(h,[s,a],a.dtype,p)}};const ka={kernelName:oe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{dy:s,filter:a}=t,{strides:o,pad:u,inputShape:d}=r,l=n.computeConv3DInfo(d,a.shape,o,1,u),h=new xa(l),p=[{type:"int32",data:[l.filterDepth,l.filterHeight,l.filterWidth]},{type:"int32",data:[l.filterDepth-1-l.padInfo.front,l.filterHeight-1-l.padInfo.top,l.filterWidth-1-l.padInfo.left]},{type:"int32",data:[l.strideDepth,l.strideHeight,l.strideWidth]},{type:"int32",data:[l.outDepth]},{type:"int32",data:[l.outHeight]},{type:"int32",data:[l.outWidth]},{type:"int32",data:[l.outChannels]}];return i.runWebGPUProgram(h,[s,a],s.dtype,p)}},Ia={kernelName:ue,backendName:"webgpu",kernelFunc:Ai({opType:ei.COS})},Ra={kernelName:de,backendName:"webgpu",kernelFunc:Ai({opType:ei.COSH})};class $a{constructor(e,t,n,i){this.variableNames=["Image","Boxes","BoxInd"],this.uniforms="extrapolationValue : f32,",this.workgroupSize=[64,1,1],this.size=!0;const[r]=t;this.outputShape=[r,n[0],n[1],e],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.methodId="bilinear"===i?1:0,this.cropHeightBiggerThan1=this.outputShape[1]>1,this.cropWidthBiggerThan1=this.outputShape[2]>1,this.shaderKey=`cropAndResize_${this.methodId}_${this.cropHeightBiggerThan1}_${this.cropWidthBiggerThan1}`}getUserCode(){const[e,t]=["f32(uniforms.imageShape[1] - 1)","f32(uniforms.imageShape[2] - 1)"],[n,i,r]=this.cropHeightBiggerThan1?[`(${e} / f32(uniforms.outShape[1] - 1))`,"(y2-y1) * height_ratio",`y1*${e} + f32(y)*(height_scale)`]:["0.0","0.0",`0.5 * (y1+y2) * ${e}`],[s,a,o]=this.cropWidthBiggerThan1?[`(${t} / f32(uniforms.outShape[2] - 1))`,"(x2-x1) * width_ratio",`x1*${t} + f32(x)*(width_scale)`]:["0.0","0.0",`0.5 * (x1+x2) * ${t}`];return`\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let height_ratio = f32(${n});\n        let width_ratio = f32(${s});\n        let b = coords[0];\n        let y = coords[1];\n        let x = coords[2];\n        let d = coords[3];\n        // get box vals\n        let y1 = getBoxes(b, 0);\n        let x1 = getBoxes(b, 1);\n        let y2 = getBoxes(b, 2);\n        let x2 = getBoxes(b, 3);\n        // get image in batch index\n        let bInd = i32(round(getBoxInd(b)));\n        if(bInd < 0 || bInd >= uniforms.outShape[0]) {\n          return;\n        }\n        let height_scale = ${i};\n        let width_scale = ${a};\n        let in_y = ${r};\n        if( in_y < 0.0 || in_y > ${e} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let in_x = ${o};\n        if( in_x < 0.0 || in_x > ${t} ) {\n          setOutputAtIndex(index, uniforms.extrapolationValue);\n          return;\n        }\n        let sourceFracIndexCR = vec2<f32>(in_x,in_y);\n        if(${this.methodId} == 1) {\n          // Compute the four integer indices.\n          let sourceFloorCR = vec2<i32>(sourceFracIndexCR);\n          let sourceCeilCR = vec2<i32>(ceil(sourceFracIndexCR));\n          let topLeft = getImage(bInd, sourceFloorCR.y, sourceFloorCR.x, d);\n          let bottomLeft = getImage(bInd, sourceCeilCR.y, sourceFloorCR.x, d);\n          let topRight = getImage(bInd, sourceFloorCR.y, sourceCeilCR.x, d);\n          let bottomRight = getImage(bInd, sourceCeilCR.y, sourceCeilCR.x, d);\n          let fracCR = sourceFracIndexCR - vec2<f32>(sourceFloorCR);\n          let top = topLeft + (topRight - topLeft) * fracCR.x;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          let newValue = top + (bottom - top) * fracCR.y;\n          setOutputAtIndex(index, newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          let sourceNearestCR = vec2<i32>(floor(\n            sourceFracIndexCR + vec2<f32>(0.5,0.5)));\n          let newValue = getImage(\n            bInd, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    }\n    `}}const Pa={kernelName:le,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n,attrs:i}=e,{image:r,boxes:s,boxInd:a}=t,{cropSize:o,method:u,extrapolationValue:d}=i,l=new $a(r.shape[3],s.shape,o,u),h=[{type:"float32",data:[d]}];return n.runWebGPUProgram(l,[r,s,a],"float32",h)}};var za;!function(e){e.Prod="*",e.Sum="+"}(za||(za={}));class Aa{constructor(e,t,n,i){this.variableNames=["x"],this.uniforms="index : f32,",this.size=!0,this.workgroupSize=[128,1,1],this.outputShape=t,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.exclusive=n,this.reverse=i,this.op=e,this.shaderKey=`cum_${this.op}_${this.exclusive}_${this.reverse}`}getUserCode(){const e=this.outputShape.length,t=this.op===za.Prod?"1.0":"0.0",n=this.exclusive?t:`getX(${Na(e,"coords",this.op)})`,i=this.outputShape[this.outputShape.length-1];let r="",s="";return this.exclusive?(r=this.reverse?"end != "+(i-1):"end != 0",s=this.reverse?"end + 1":"end - 1"):(r=this.reverse?`end + pow2 < ${i}`:"end >= pow2",s=this.reverse?"end + pow2":"end - pow2"),`\n      ${An("index")} {\n       if (index < uniforms.size) {\n         var coords = getCoordsFromIndex(index);\n\n         let end = ${Da(e,"coords",this.op)};\n         var val = ${n};\n         let pow2 = i32(pow(2.0, uniforms.index));\n         if (${r}) {\n           let idx = ${s};\n           ${Da(e,"coords",this.op)} = idx;\n           val ${this.op}= getX(${Na(e,"coords",this.op)});\n         }\n         setOutputAtIndex(index, val);\n       }\n      }\n    `}}function Na(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.x, ${t}.y`;if(3===e)return`${t}.x, ${t}.y, ${t}.z`;if(4===e)return`${t}.x, ${t}.y, ${t}.z, ${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function Da(e,t,n){if(1===e)return`${t}`;if(2===e)return`${t}.y`;if(3===e)return`${t}.z`;if(4===e)return`${t}.w`;throw Error(`Cumulative ${n} for rank ${e} is not yet supported`)}function Fa(e,t,i,r,s,a){const o=t.shape.length,u=n.getAxesPermutation([r],o);let d=t;null!=u&&(d=ss({inputs:{x:t},backend:i,attrs:{perm:u}}));const l=n.getInnerMostAxes(1,o)[0];if(l!==o-1)throw new Error(`WebGPU cumprod shader expects an inner-most axis=${t.shape.length-1} but got axis=${r}`);const h=d.shape[l];let p=Ii({inputs:{x:d},backend:i});for(let t=0;t<=Math.ceil(Math.log2(h))-1;t++){const n=new Aa(e,d.shape,!1,a),r=p,s=[{type:"float32",data:[t]}];p=i.runWebGPUProgram(n,[p],p.dtype,s),i.disposeData(r.dataId)}if(s){const t=new Aa(e,d.shape,s,a),n=p,r=[{type:"float32",data:[0]}];p=i.runWebGPUProgram(t,[p],p.dtype,r),i.disposeData(n.dataId)}if(null!=u){const e=ss({inputs:{x:p},backend:i,attrs:{perm:n.getUndoAxesPermutation(u)}});return i.disposeData(p.dataId),i.disposeData(d.dataId),e}return p}const Ta={kernelName:he,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,exclusive:a,reverse:o}=i;return Fa(za.Prod,r,n,s,a,o)}};const Ea={kernelName:pe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,exclusive:a,reverse:o}=i;return Fa(za.Sum,r,n,s,a,o)}};const Wa={kernelName:ce,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s,weights:a}=t,{size:o,binaryOutput:u}=r,d=1===s.shape.length,l=i.sizeFromShape(a.shape)>0,h=a.dtype,p=d?[s.shape[0]]:[s.shape[0],s.shape[1]],c=xi({backend:n,attrs:{shape:d?[o]:[s.shape[0],o],value:0,dtype:h}}),f=new Os(p,l,u),m=[{type:"int32",data:[o]}],g=l?[s,a]:[s];return n.runWebGPUProgram(f,g,h,m,c)}};class La{constructor(e,t){this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.uniforms="blockSize : i32,",this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey=`depthToSpace_${t}`,this.dataFormat=t}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let h = ${this.getHeightCoordString()};\n          let w = ${this.getWidthCoordString()};\n          let d = ${this.getDepthCoordString()};\n\n          let in_h = h / uniforms.blockSize;\n          let offset_h = h % uniforms.blockSize;\n          let in_w = w / uniforms.blockSize;\n          let offset_w = w % uniforms.blockSize;\n          let offset_d = (offset_h * uniforms.blockSize + offset_w) *\n            ${this.getOutputDepthSize()};\n          let in_d = d + offset_d;\n\n          let rlt = ${this.getInputSamplingString()};\n          setOutputAtIndex(index, rlt);\n        }\n      }`}getHeightCoordString(){return"NHWC"===this.dataFormat?"coords[1]":"coords[2]"}getWidthCoordString(){return"NHWC"===this.dataFormat?"coords[2]":"coords[3]"}getDepthCoordString(){return"NHWC"===this.dataFormat?"coords[3]":"coords[1]"}getOutputDepthSize(){return"NHWC"===this.dataFormat?"uniforms.outShape[3]":"uniforms.outShape[1]"}getInputSamplingString(){return"NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)"}}const Ba={kernelName:fe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{blockSize:s,dataFormat:a}=i,o=r.shape[0],u=("NHWC"===a?r.shape[1]:r.shape[2])*s,d=("NHWC"===a?r.shape[2]:r.shape[3])*s,l=("NHWC"===a?r.shape[3]:r.shape[1])/(s*s),h=[{type:"int32",data:[s]}],p=new La("NHWC"===a?[o,u,d,l]:[o,l,u,d],a);return n.runWebGPUProgram(p,[r],r.dtype,h)}};class _a{constructor(e,t,n,i=!1,r=null,s=!1){this.variableNames=["x","W"],this.uniforms="pads : vec2<i32>, inDims : vec2<i32>,",this.workgroupSize=[16,16,1],this.outputShape=e,this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),i&&this.variableNames.push("bias"),s&&this.variableNames.push("preluActivationWeights"),this.addBias=i,this.activation=r,this.hasPreluActivation=s,this.filterHeight=t,this.filterWidth=n,this.shaderKey=`depthwiseNCHW_${this.activation}_${this.filterHeight}_${this.filterWidth}`}getUserCode(){const e=this.filterWidth*this.filterHeight,t=this.workgroupSize[0]*this.workgroupSize[1]*this.workgroupSize[2],n=this.workgroupSize[1]+this.filterHeight-1,i=this.workgroupSize[0]+this.filterWidth-1;return`\n      ${ri(this.activation,this.hasPreluActivation,!1,4)}\n\n      var<workgroup> mm_Asub : array<array<f32, ${i}>, ${n}>;\n      var<workgroup> mm_Bsub : array<array<f32, ${this.filterWidth}>, ${this.filterHeight}>;\n      fn readX(batch : i32, channel : i32, row : i32, col : i32) -> f32 {\n        var value = 0.0;\n        if (row >=0 && row < uniforms.inDims[0] && col >=0 && col < uniforms.inDims[1])\n        {\n          value = getX(batch, channel, row, col);\n        }\n        return value;\n      }\n\n      ${An()} {\n        let coords = getOutputCoords();\n        let batch = coords[0];\n        let xRCCorner = vec2<i32>(coords.zw) - uniforms.pads;\n        let channelMul = uniforms.wShape[3];\n        let d1 = coords[1] / channelMul;\n        let q = coords[1] % channelMul;\n\n        let inputRowStart = xRCCorner.x;\n        let inputColStart = xRCCorner.y;\n\n        let localRow = i32(localId.y);\n        let localCol = i32(localId.x);\n\n        // Load one tile of X into local memory.\n        for (var inputRow = localRow; inputRow < ${n}; inputRow = inputRow + ${this.workgroupSize[1]}) {\n          for (var inputCol = localCol; inputCol < ${i}; inputCol = inputCol + ${this.workgroupSize[0]}) {\n            let rowOffset = inputRow - localRow;\n            let colOffset = inputCol - localCol;\n            mm_Asub[inputRow][inputCol] = readX(batch, d1, inputRowStart + rowOffset, inputColStart + colOffset);\n          }\n        }\n\n        // Load one tile of W into local memory.\n        var wIndex = i32(localIndex);\n        ${e<t?`if (wIndex < ${e})`:`for(; wIndex < ${e}; wIndex = wIndex + ${t})`}\n\n        {\n          let wRow = wIndex / ${this.filterWidth};\n          let wCol = wIndex % ${this.filterWidth};\n          mm_Bsub[wRow][wCol] = getW(wRow, wCol, d1, q);\n        }\n\n        workgroupBarrier();\n\n        var value = 0.0;\n        for (var wR = 0; wR < ${this.filterHeight}; wR = wR + 1) {\n          for (var wC = 0; wC < ${this.filterWidth}; wC = wC + 1) {\n            let xVal = mm_Asub[localRow + wR][localCol + wC];\n            let wVal = mm_Bsub[wR][wC];\n            value = fma(xVal, wVal, value);\n          }\n        }\n        ${si(this.addBias,this.activation)}\n        if (coordsInBounds4D(coords, uniforms.outShape)) {\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }\n    `}}class Oa{constructor(e,t=!1,n=null,r=!1){this.variableNames=["x","W"],this.uniforms="pads : vec2<i32>, inDims : vec2<i32>, virtualWidth : i32,",this.workgroupSize=[64,1,1],this.workPerThread=4,this.outputComponent=4,this.outputShape=e.outShape,this.virtualWidth=Math.ceil(this.outputShape[2]/this.workPerThread)*this.workPerThread;const s=[this.outputShape[0],this.outputShape[1],this.virtualWidth,this.outputShape[3]];this.dispatchLayout=Gn(s),this.dispatch=On(this.dispatchLayout,s,this.workgroupSize,[this.outputComponent*this.workPerThread,1,1]),i.assert("channelsLast"===e.dataFormat,(()=>"TODO: NCHW is unimplemented")),t&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=n,this.hasPreluActivation=r,this.shaderKey=`depthwiseVec4_${n}_${this.convInfo.filterHeight}_${this.convInfo.filterWidth}_${this.convInfo.strideHeight}_${this.convInfo.strideWidth}_${this.workPerThread}`}getUserCode(){const e=(this.workPerThread-1)*this.convInfo.strideWidth+this.convInfo.filterWidth,t=this.convInfo.strideHeight,n=this.convInfo.strideWidth;return`\n      ${ri(this.activation,this.hasPreluActivation,!0,4)}\n      fn readX(batch : i32, row : i32, col : i32, channel : i32) -> vec4<f32> {\n        var value = vec4<f32>(0.0);\n        if (col >=0 && col < uniforms.inDims[1]) {\n          value = getX(batch, row, col, channel);\n        }\n        return value;\n      }\n\n      ${An("index")} {\n        let width0 = uniforms.outShape[3] / ${this.outputComponent};\n        let d1 = (index % width0) * ${this.outputComponent};\n        var index1 = index / width0;\n        let width1 = uniforms.virtualWidth / ${this.workPerThread};\n        let c = (index1 % width1) * ${this.workPerThread};\n        index1 = index1 / width1;\n        let r = index1 % uniforms.outShape[1];\n        let batch = index1 / uniforms.outShape[1];\n\n        let xRCCorner = vec2<i32>(r, c) * vec2<i32>(${t}, ${n}) - uniforms.pads;\n\n        let xRCorner = xRCCorner.x;\n        let xCCorner = xRCCorner.y;\n        var xVals : array<vec4<f32>, ${e}>;\n        var dotProd : array<vec4<f32>, ${this.workPerThread}>;\n        for (var i = 0; i < ${this.workPerThread}; i++) {\n          dotProd[i] = vec4<f32>(0.0);\n        }\n\n        // Use constant instead of uniform can give better performance.\n        for (var wR = 0; wR < ${this.convInfo.filterHeight}; wR = wR + 1) {\n          let xR = xRCorner + wR;\n          if (xR >=0 && xR < uniforms.inDims[0]) {\n            for (var i = 0; i < ${e}; i++) {\n              xVals[i] = readX(batch, xR, xCCorner + i, d1);\n            }\n            for (var wC = 0; wC < ${this.convInfo.filterWidth}; wC = wC + 1) {\n              let wValue = getW(wR, wC, d1, 0);\n              for (var i = 0; i < ${this.workPerThread}; i++) {\n                dotProd[i] = fma(xVals[i * ${n} + wC], wValue, dotProd[i]);\n              }\n            }\n          }\n        }\n\n        for (var i = 0; i < ${this.workPerThread}; i = i + 1) {\n          let coords = vec4<i32>(batch, r, c + i, d1);\n          if (coordsInBounds4D(coords, uniforms.outShape)) {\n            var value = dotProd[i];\n            ${si(this.addBias,this.activation)}\n            setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n          }\n        }\n      }\n    `}}class Ua{constructor(e,t=!1,n=null,i=!1){this.variableNames=["x","W"],this.uniforms="pads : vec2<i32>, inDims : vec2<i32>, filterHeight : i32,\n      filterWidth : i32, strides : vec2<i32>, dilations : vec2<i32>,",this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.isChannelsLast="channelsLast"===e.dataFormat,t&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.convInfo=e,this.addBias=t,this.activation=n,this.hasPreluActivation=i,this.shaderKey=`depthwise_${this.activation}_${this.isChannelsLast}`}getUserCode(){const e=this.isChannelsLast?"getX(batch, xR, xC, d1);":"getX(batch, d1, xR, xC);";return`\n      ${ri(this.activation,this.hasPreluActivation,!1,4)}\n\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let batch = coords[0];\n          let xRCCorner = vec2<i32>(coords.${this.isChannelsLast?"yz":"zw"}) * uniforms.strides - uniforms.pads;\n          let d2 = coords[${this.isChannelsLast?3:1}];\n          let channelMul = uniforms.wShape[3];\n          let d1 = d2 / channelMul;\n          let q = d2 % channelMul;\n\n          let inputRowStart = xRCCorner.x;\n          let inputColStart = xRCCorner.y;\n          let inputRowEnd = inputRowStart + uniforms.filterHeight *\n              uniforms.dilations[0];\n          let inputColEnd = inputColStart + uniforms.filterWidth *\n              uniforms.dilations[1];\n\n          // Convolve x(?, ?, d1)|x(d1, ?, ?) with w(:, :, d1, q) to get\n          // y(yR, yC, d2)|y(d2, yR, yC). ? = to be determined. : = across all\n          // values in that axis. x(?, ?, d1) and y(yR, yC, d2) is for NHWC.\n          // x(d1, ?, ?) and y(d2, yR, yC) is for NCHW.\n          var value = 0.0;\n\n          // Extract if checking out of for loop for performance.\n          if (inputRowStart >= 0 && inputColStart >= 0 &&\n            inputRowEnd < uniforms.inDims[0] &&\n                inputColEnd < uniforms.inDims[1]) {\n              for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n                let xR = inputRowStart + wR * uniforms.dilations[0];\n\n                for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                  let xC = inputColStart + wC * uniforms.dilations[1];\n\n                  let xVal = ${e};\n                  let wVal = getW(wR, wC, d1, q);\n                  value = value + xVal * wVal;\n                }\n              }\n            } else {\n              for (var wR = 0; wR < uniforms.filterHeight; wR = wR + 1) {\n                let xR = inputRowStart + wR * uniforms.dilations[0];\n\n                if (xR < 0 || xR >= uniforms.inDims[0]) {\n                  continue;\n                }\n\n                for (var wC = 0; wC < uniforms.filterWidth; wC = wC + 1) {\n                  let xC = inputColStart + wC * uniforms.dilations[1];\n\n                  if (xC < 0 || xC >= uniforms.inDims[1]) {\n                    continue;\n                  }\n\n                  let xVal = ${e};\n                  let wVal = getW(wR, wC, d1, q);\n                  value = value + xVal * wVal;\n                }\n              }\n            }\n            ${si(this.addBias,this.activation)}\n          setOutputAtCoords(coords[0], coords[1], coords[2], coords[3], value);\n        }\n      }\n    `}}const Va={kernelName:me,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s,filter:a}=t,{strides:o,pad:u,dataFormat:d,dilations:l,dimRoundingMode:h}=r,p=n.convertConv2DDataFormat(d);let c=l;null==c&&(c=[1,1]);const f=n.computeConv2DInfo(s.shape,a.shape,o,c,u,h,!0,p),m=[{type:"int32",data:[f.padInfo.top,f.padInfo.left]},{type:"int32",data:[f.inHeight,f.inWidth]}],g="channelsLast"===f.dataFormat;let x;return!g&&f.inHeight>16&&f.inWidth>16&&1===f.strideHeight&&1===f.strideWidth&&1===f.dilationWidth&&1===f.dilationHeight&&f.inChannels===f.outChannels?x=new _a(f.outShape,f.filterHeight,f.filterWidth):g&&f.outHeight>4&&f.outWidth>4&&f.strideWidth<=2&&f.inChannels===f.outChannels&&1===f.dilationHeight&&1===f.dilationWidth&&f.inChannels%4==0?(x=new Oa(f),m.push({type:"int32",data:[x.virtualWidth]})):(x=new Ua(f),m.push({type:"int32",data:[f.filterHeight]},{type:"int32",data:[f.filterWidth]},{type:"int32",data:[f.strideHeight,f.strideWidth]},{type:"int32",data:[f.dilationHeight,f.dilationWidth]})),i.runWebGPUProgram(x,[s,a],s.dtype,m)}};class Ma{constructor(e){this.variableNames=["x","dy"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, filterDims : vec2<i32>, outHeight : i32,\n      outWidth : i32, inHeight : i32, inWidth : i32, batchSize : i32, channelMul : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.filterShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="depthwise_conv2d_backprop_filter"}getUserCode(){return`\n      ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let wR = coords[0];\n        let wC = coords[1];\n        let d1 = coords[2];\n        let dm = coords[3];\n        let d2 = d1 * uniforms.channelMul + dm;\n\n        var dotProd = 0.0;\n        for (var b = 0; b < uniforms.batchSize; b++) {\n          for (var yR = 0; yR < uniforms.outHeight; yR++) {\n            let xR = wR + yR * uniforms.strides[0] - uniforms.pads[0];\n\n            if (xR < 0 || xR >= uniforms.inHeight) {\n              continue;\n            }\n\n            for (var yC = 0; yC < uniforms.outWidth; yC++) {\n              let xC = wC + yC * uniforms.strides[1] - uniforms.pads[1];\n\n              if (xC < 0 || xC >= uniforms.inWidth) {\n                continue;\n              }\n\n              let dyValue = getDy(b, yR, yC, d2);\n              let xValue = getX(b, xR, xC, d1);\n              dotProd += xValue * dyValue;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}class Ga{constructor(e){this.variableNames=["dy","W"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, filterDims : vec2<i32>,\n       outHeight : i32, outWidth : i32, channelMul : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="depthwise_conv2d_backprop_input"}getUserCode(){return`\n      ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d1 = coords[3];\n        let dyCorner = coords.yz - uniforms.pads;\n        let dyRCorner = dyCorner.x;\n        let dyCCorner = dyCorner.y;\n\n        var dotProd = 0.0;\n        for (var wR = 0; wR < uniforms.filterDims[0]; wR++) {\n          let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[0]);\n\n          if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n            continue;\n          }\n\n          let idyR = i32(dyR);\n          let wRPerm = uniforms.filterDims[0] - 1 - wR;\n\n          for (var wC = 0; wC < uniforms.filterDims[1]; wC++) {\n            let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[1]);\n\n            if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n              continue;\n            }\n\n            let idyC = i32(dyC);\n            let wCPerm = uniforms.filterDims[1] - 1 - wC;\n\n            for (var dm = 0; dm < uniforms.channelMul; dm++) {\n              let d2 = d1 * uniforms.channelMul + dm;\n              let xValue = getDy(batch, idyR, idyC, d2);\n              let wValue = getW(wRPerm, wCPerm, d1, dm);\n              dotProd += xValue * wValue;\n            }\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}const Ha={kernelName:ge,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s,dy:a}=t,{strides:o,dilations:u,pad:d,dimRoundingMode:l,filterShape:h}=r,p=n.computeConv2DInfo(s.shape,h,o,u,d,l,!0),c=new Ma(p),f=[{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.filterHeight,p.filterWidth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]},{type:"int32",data:[p.inHeight]},{type:"int32",data:[p.inWidth]},{type:"int32",data:[p.batchSize]},{type:"int32",data:[p.outChannels/p.inChannels]}];return i.runWebGPUProgram(c,[s,a],"float32",f)}};const Xa={kernelName:xe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{dy:s,filter:a}=t,{strides:o,dilations:u,pad:d,dimRoundingMode:l,inputShape:h}=r,p=n.computeConv2DInfo(h,a.shape,o,u,d,l,!0),c=new Ga(p),f=[{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.filterHeight-1-p.padInfo.top,p.filterWidth-1-p.padInfo.left]},{type:"int32",data:[p.filterHeight,p.filterWidth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]},{type:"int32",data:[p.outChannels/p.inChannels]}];return i.runWebGPUProgram(c,[s,a],s.dtype,f)}};class Ka{constructor(e){this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e,e],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="diag"}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let value = select(0.0, getX(coords[0]), coords[0] == coords[1]);\n          setOutputAtIndex(index, value);\n        }\n      }\n    `}}const qa={kernelName:ye,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:r}=t,s=[...r.shape,...r.shape],a=i.sizeFromShape(r.shape),o=wi({inputs:{x:r},backend:n,attrs:{shape:[a]}}),u=new Ka(a),d=n.runWebGPUProgram(u,[o],o.dtype),l=wi({inputs:{x:d},backend:n,attrs:{shape:s}});return n.disposeData(o.dataId),n.disposeData(d.dataId),l}};class Ya{constructor(e){this.variableNames=["x","w"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.outShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="dilation2d"}getUserCode(){return`\n       ${An("index")} {\n         if (index < uniforms.size) {\n           let neg_infinity = -3.4e38;\n           let coords = getOutputCoords();\n           let batch = coords.x;\n           let d1 = coords.w;\n           let outTopLeftCorner = coords.yz * uniforms.strides - uniforms.pads;\n           let hBeg = outTopLeftCorner.x;\n           let wBeg = outTopLeftCorner.y;\n\n           var curVal = neg_infinity;\n           for (var h = 0; h < uniforms.filterDims[0]; h = h + 1) {\n             let hIn = hBeg + h * uniforms.dilations[0];\n\n             if (hIn >= 0 && hIn < uniforms.xShape[1]) {\n               for (var w = 0; w < uniforms.filterDims[1]; w = w + 1) {\n                 let wIn = wBeg + w * uniforms.dilations[1];\n\n                 if (wIn >= 0 && wIn < uniforms.xShape[2]) {\n                   let val = getX(batch, hIn, wIn, d1) + getW(h, w, d1);\n                   if (val > curVal) {\n                     curVal = val;\n                   }\n                 }\n               }\n             }\n           }\n\n           setOutputAtIndex(index, curVal);\n         }\n       }\n     `}}const ja={kernelName:we,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s,filter:a}=t,{strides:o,pad:u,dilations:d}=r,l=n.computeDilation2DInfo(s.shape,a.shape,o,u,"NHWC",d),h=[l.padInfo.top,l.padInfo.left],p=[{type:"int32",data:[l.filterHeight,l.filterWidth]},{type:"int32",data:[...h]},{type:"int32",data:[l.strideHeight,l.strideWidth]},{type:"int32",data:[l.dilationHeight,l.dilationWidth]}],c=new Ya(l);return i.runWebGPUProgram(c,[s,a],s.dtype,p)}};class Qa{constructor(e,t){if(this.variableNames=["x","w","dy"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>, dySize: i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=e.inShape,this.dispatchLayout=Gn(e.outShape),this.dispatch=On(this.dispatchLayout,e.outShape,this.workgroupSize),"float32"!==t&&"int32"!==t)throw new Error(`Dilation2DBackpropInput only supports float32 and int32\n          types, does not support ${t} type.`);this.type=t,this.shaderKey="dilation2DBackpropInput"}getUserCode(){return`\n       ${An("index")} {\n         if (index < uniforms.dySize) {\n           let coords = getDyCoordsFromIndex(index);\n           let b = coords[0];\n           let r = coords[1];\n           let c = coords[2];\n           let d = coords[3];\n\n           let dyCorner = vec2<i32>(r, c) * uniforms.strides - uniforms.pads;\n           var curVal = -3.4e38;  // neg_infinity\n           var xRMax = 0;\n           var xCMax = 0;\n\n           // In the case of multiple argmax branches, we only back-propagate\n           // along the last branch, i.e., the one with largest value of\n           // 'wR * uniforms.filterDims[1] + wC', similarly to the max-pooling\n           // backward routines.\n           for (var wR = 0; wR < uniforms.filterDims[0]; wR++) {\n             let xR = dyCorner.x + wR * uniforms.dilations[0];\n\n             if (xR >= 0 && xR < uniforms.xShape[1]) {\n               for (var wC = 0; wC < uniforms.filterDims[1]; wC++) {\n                 let xC = dyCorner.y + wC * uniforms.dilations[1];\n\n                 if (xC >= 0 && xC < uniforms.xShape[2]) {\n                   let val = getX(b, xR, xC, d) + getW(wR, wC, d);\n                   if (val > curVal) {\n                     curVal = val;\n                     xRMax = xR;\n                     xCMax = xC;\n                   }\n                 }\n               }\n             }\n           }\n\n           let flatIndexIn = d + uniforms.xShape[3] *\n               (xCMax + uniforms.xShape[2] * (xRMax + uniforms.xShape[1] * b));\n           let value = getDy(b, r, c, d);\n           ${In("&result[flatIndexIn]","value",this.type)}\n         }\n       }\n     `}}class Za{constructor(e,t,n){if(this.variableNames=["x","w","dy"],this.uniforms="filterDims: vec2<i32>, pads: vec2<i32>, strides: vec2<i32>, dilations: vec2<i32>, dySize: i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=e.filterShape,this.dispatchLayout=Gn(e.outShape),this.dispatch=On(this.dispatchLayout,e.outShape,this.workgroupSize),"float32"!==n&&"int32"!==n)throw new Error(`Dilation2DBackpropFilter only supports float32 and int32\n          types, does not support ${n} type.`);this.type=n,this.shaderKey="dilation2DBackpropFilter"}getUserCode(){return`\n       ${An("index")} {\n         if (index < uniforms.dySize) {\n           let coords = getDyCoordsFromIndex(index);\n           let b = coords[0];\n           let r = coords[1];\n           let c = coords[2];\n           let d = coords[3];\n\n           let dyCorner = vec2<i32>(r, c) * uniforms.strides - uniforms.pads;\n           var curVal = -3.4e38;  // neg_infinity\n           var wRMax = 0;\n           var wCMax = 0;\n\n           // In the case of multiple argmax branches, we only back-propagate\n           // along the last branch, i.e., the one with largest value of\n           // 'wR * uniforms.filterDims[1] + wC', similarly to the max-pooling\n           // backward routines.\n           for (var wR = 0; wR < uniforms.filterDims[0]; wR++) {\n             let xR = dyCorner.x + wR * uniforms.dilations[0];\n\n             if (xR >= 0 && xR < uniforms.xShape[1]) {\n               for (var wC = 0; wC < uniforms.filterDims[1]; wC++) {\n                 let xC = dyCorner.y + wC * uniforms.dilations[1];\n\n                 if (xC >= 0 && xC < uniforms.xShape[2]) {\n                   let val = getX(b, xR, xC, d) + getW(wR, wC, d);\n                   if (val > curVal) {\n                     curVal = val;\n                     wRMax = wR;\n                     wCMax = wC;\n                   }\n                 }\n               }\n             }\n           }\n\n           let flatIndexIn = d + uniforms.wShape[2] * (wCMax + wRMax * uniforms.wShape[1]);\n           let value = getDy(b, r, c, d);\n           ${In("&result[flatIndexIn]","value",this.type)}\n         }\n       }\n     `}}const Ja={kernelName:be,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:a,filter:o,dy:u}=t,{strides:d,pad:l,dilations:h}=s,p=n.computeDilation2DInfo(a.shape,o.shape,d,l,"NHWC",h),c=o.dtype,f=new Za(p,o.shape,c),m=[{type:"int32",data:[p.filterHeight,p.filterWidth]},{type:"int32",data:[p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.dilationHeight,p.dilationWidth]},{type:"int32",data:[i.sizeFromShape(p.outShape)]}],g=xi({backend:r,attrs:{shape:o.shape,value:0,dtype:c}});return r.runWebGPUProgram(f,[a,o,u],c,m,g)}};const eo={kernelName:Ce,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:a,filter:o,dy:u}=t,{strides:d,pad:l,dilations:h}=s,p=n.computeDilation2DInfo(a.shape,o.shape,d,l,"NHWC",h),c=a.dtype,f=new Qa(p,c),m=[{type:"int32",data:[p.filterHeight,p.filterWidth]},{type:"int32",data:[p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.dilationHeight,p.dilationWidth]},{type:"int32",data:[i.sizeFromShape(p.outShape)]}],g=xi({backend:r,attrs:{shape:p.inShape,value:0,dtype:c}});return r.runWebGPUProgram(f,[a,o,u],c,m,g)}},to=Ni({opType:Zn.MUL,cpuKernelImpl:Tr,supportsComplex:!0}),no={kernelName:Se,backendName:"webgpu",kernelFunc:to};function io(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,keepDims:a}=i;return us(r,s,a,"sum",n)}const ro={kernelName:ve,backendName:"webgpu",kernelFunc:io};const so={kernelName:ke,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{equation:a}=s,o=t,{allDims:u,summedDims:d,idDims:l}=n.decodeEinsumEquation(a,o.length);n.checkEinsumDimSizes(u.length,l,o);const{path:h,steps:p}=n.getEinsumComputePath(d,l),c=p.length;let f=null,m=u.length;const g=[];for(let e=0;e<c;++e){for(const t of p[e]){const{permutationIndices:e,expandDims:s}=n.getEinsumPermutation(m,l[t]);let a;n.isIdentityPermutation(e)?a=o[t]:(a=ss({inputs:{x:o[t]},backend:r,attrs:{perm:e}}),g.push(a));const u=a.shape.slice();for(let e=0;e<s.length;++e)u.splice(s[e],0,1);i.arraysEqual(a.shape,u)||(a=wi({inputs:{x:a},backend:r,attrs:{shape:u}}),g.push(a)),null===f?f=a:(f=to({inputs:{a:a,b:f},backend:r}),g.push(f))}e<c-1&&(h[e]>=0&&(f=io({inputs:{x:f},backend:r,attrs:{axis:h[e]-(u.length-m),keepDims:!1}}),g.push(f)),m--)}for(const e of g)e!==f&&r.disposeData(e.dataId);return f}},ao={kernelName:Ie,backendName:"webgpu",kernelFunc:Ai({opType:ei.ELU})},oo={kernelName:Re,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n}=e,{dy:i,y:r}=t,s=new ki(Zn.ELU_DER,i.shape,r.shape);return n.runWebGPUProgram(s,[i,r],i.dtype)}},uo={kernelName:$e,backendName:"webgpu",kernelFunc:Ni({opType:Zn.EQUAL,dtype:"bool",cpuKernelImpl:wr})},lo={kernelName:Pe,backendName:"webgpu",kernelFunc:Ai({opType:ei.ERF})},ho={kernelName:ze,backendName:"webgpu",kernelFunc:Ai({opType:ei.EXP,cpuKernelImpl:br,dtype:"float32"})};function po(e){const{inputs:t,attrs:n,backend:r}=e,{dim:s}=n,{input:a}=t,o=a.shape.length,u=a.shape.slice();let d=s;return s<0&&(i.assert(-(o+1)<=s,(()=>`Axis must be in the interval [${-(o+1)}, ${o}]`)),d=o+s+1),u.splice(d,0,1),wi({inputs:{x:a},backend:r,attrs:{shape:u}})}const co={kernelName:Ae,backendName:"webgpu",kernelFunc:po},fo={kernelName:Ne,backendName:"webgpu",kernelFunc:Ai({opType:ei.EXPM1,cpuKernelImpl:Cr})};class mo{constructor(e,t){this.variableNames=["real","imag"],this.outputShape=[],this.uniforms="exponentMultiplier : f32, denominator: f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.component=e,this.shaderKey=`fft_${e}`}getUserCode(){return`\n    fn unaryOpComplex(real: f32, expR: f32, imag: f32, expI: f32) -> f32 {\n      ${"real"===this.component?"return real * expR - imag * expI;":"return real * expI + imag * expR;"}\n    }\n\n    fn mulMatDFT(batch: i32, index: i32) -> f32 {\n      let indexRatio = f32(index) / f32(uniforms.realShape[1]);\n      let exponentMultiplierTimesIndexRatio =\n          uniforms.exponentMultiplier * indexRatio;\n\n      var result = 0.0;\n\n      for (var i = 0; i < uniforms.realShape[1]; i = i + 1) {\n        // x = (-2|2 * PI / N) * index * i;\n        let x = exponentMultiplierTimesIndexRatio * f32(i);\n        let expR = cos(x);\n        let expI = sin(x);\n        let real = getReal(batch, i);\n        let imag = getImag(batch, i);\n\n        result = result +\n            unaryOpComplex(real, expR, imag, expI) / uniforms.denominator;\n      }\n\n      return result;\n    }\n\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        setOutputAtIndex(index, mulMatDFT(coords[0], coords[1]));\n      }\n    }\n  `}}function go(e,t,n){const r=n.tensorMap.get(e.dataId),s=i.sizeFromShape(e.shape),a=e.shape[e.shape.length-1],o=[],u=wi({inputs:{x:e},backend:n,attrs:{shape:[s/a,a]}});o.push(u);const d=u.shape,l=new mo("real",d),h=new mo("imag",d),p=[{dataId:r.complexTensorInfos.real.dataId,dtype:r.complexTensorInfos.real.dtype,shape:d},{dataId:r.complexTensorInfos.imag.dataId,dtype:r.complexTensorInfos.imag.dtype,shape:d}],c=[{type:"float32",data:[t?2*Math.PI:-2*Math.PI]},{type:"float32",data:[t?d[1]:1]}],f=n.runWebGPUProgram(l,p,"float32",c);o.push(f);const m=n.runWebGPUProgram(h,p,"float32",c);o.push(m);const g=$i({inputs:{real:f,imag:m},backend:n});o.push(g);const x=wi({inputs:{x:g},backend:n,attrs:{shape:e.shape}});return o.forEach((e=>n.disposeData(e.dataId))),x}const xo={kernelName:De,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{input:i}=t;return go(i,!1,n)}};class yo{constructor(e){this.outputShape=[],this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="flipLeftRight"}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let coordX = uniforms.xShape[2] - coords[2] - 1;\n          let outputValue = getX(coords[0], coords[1], coordX, coords[3]);\n          setOutputAtIndex(index, outputValue);\n        }\n      }\n    `}}const wo={kernelName:Fe,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{image:n}=e,i=t,r=new yo(n.shape);return i.runWebGPUProgram(r,[n],n.dtype)}},bo={kernelName:Te,backendName:"webgpu",kernelFunc:Ai({opType:ei.FLOOR,cpuKernelImpl:Sr})},Co={kernelName:Ee,backendName:"webgpu",kernelFunc:Ni({opType:Zn.INT_DIV,cpuKernelImpl:vr,dtype:"int32"})};class So{constructor(e,t,n=!1){this.isFromPixels=!0,this.outputShape=[0],this.variableNames=[],this.workgroupSize=[256,1,1],this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[t,1,1]),this.importVideo=n,this.shaderKey=`fromPixels_${this.importVideo}`}getUserCode(){const e=this.importVideo?"textureLoad(src, vec2<i32>(coords.yx));":"textureLoad(src, vec2<i32>(coords.yx), 0)";return`\n      @binding(1) @group(0) var src: ${this.importVideo?"texture_external":"texture_2d<f32>"};\n      ${An("index")} {\n        let flatIndex = index * uniforms.numChannels;\n        if (flatIndex < uniforms.size) {\n          let coords = getCoordsFromIndex(flatIndex);\n          let values = ${e};\n          for (var i = 0; i < uniforms.numChannels; i = i + 1) {\n            result[flatIndex + i] = i32(floor(255.0 * values[i]));\n          }\n        }\n      }\n  `}}const vo={kernelName:We,backendName:"webgpu",kernelFunc:function(e){const{inputs:n,backend:r,attrs:s}=e;let{pixels:a}=n;const{numChannels:o}=s;if(null==a)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");const u="undefined"!=typeof HTMLVideoElement&&a instanceof HTMLVideoElement,d="undefined"!=typeof HTMLImageElement&&a instanceof HTMLImageElement,l="undefined"!=typeof HTMLCanvasElement&&a instanceof HTMLCanvasElement||"undefined"!=typeof OffscreenCanvas&&a instanceof OffscreenCanvas,h="undefined"!=typeof ImageBitmap&&a instanceof ImageBitmap,[p,c]=u?[a.videoWidth,a.videoHeight]:[a.width,a.height],f=[c,p,o],m=u||d;if(h||l||m){let e;{if(m){const e=t().getBool("CANVAS2D_WILL_READ_FREQUENTLY_FOR_GPU");null!=ko&&e===Io||(Io=e,ko=document.createElement("canvas").getContext("2d",{willReadFrequently:Io})),ko.canvas.width=p,ko.canvas.height=c,ko.drawImage(a,0,0,p,c),a=ko.canvas}const n=GPUTextureUsage.COPY_DST|GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.TEXTURE_BINDING,i="rgba8unorm",s=r.textureManager.acquireTexture(f[1],f[0],i,n);r.queue.copyExternalImageToTexture({source:a},{texture:s},[f[1],f[0]]),e=s}const n=i.sizeFromShape(f),s=i.computeStrides(f),u=new So(f,o,false),d=[{type:"uint32",data:[n]},{type:"uint32",data:[o]},{type:"uint32",data:[...s]}],l=r.makeTensorInfo([c,p],"int32");r.tensorMap.get(l.dataId).resource=e;const h=r.runWebGPUProgram(u,[l],"int32",d);return r.disposeData(l.dataId),h}const g=a.data;let x=g;if(null!=o&&4!==o){x=new Uint8Array(a.width*a.height*o);const e=g.length;let t=0;for(let n=0;n<e;n++)n%4<o&&(x[t++]=g[n])}const y=r.makeTensorInfo(f,"int32",new Int32Array(x));return r.uploadToGPU(y.dataId),y}};let ko,Io=t().getBool("CANVAS2D_WILL_READ_FREQUENTLY_FOR_GPU");class Ro{constructor(e,t,i,r,s){this.uniforms="varianceEpsilon : f32,",this.workgroupSize=[128,1,1],this.size=!0,this.variableNames=["x","mean","variance"],n.assertAndGetBroadcastShape(e,t),n.assertAndGetBroadcastShape(e,i),this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),null!=r&&(n.assertAndGetBroadcastShape(e,r),this.variableNames.push("offset")),null!=s&&(n.assertAndGetBroadcastShape(e,s),this.variableNames.push("scale")),this.offsetShape=r,this.scaleShape=s,this.shaderKey="batchNorm"}getUserCode(){let e="0.0";null!=this.offsetShape&&(e="getOffsetByOutputIndex(index)");let t="1.0";null!=this.scaleShape&&(t="getScaleByOutputIndex(index)");return`\n      ${An("index")} {\n        if (index < uniforms.size)\n        {\n          let xValue = getXByOutputIndex(index);\n          let meanValue = getMeanByOutputIndex(index);\n          let varianValue = getVarianceByOutputIndex(index);\n          let offsetValue = ${e};\n          let scaleValue = ${t};\n          let inv = scaleValue * inverseSqrt(varianValue + f32(uniforms.varianceEpsilon));\n          setOutputAtIndex(index,dot(vec3<f32>(xValue, -meanValue, offsetValue), vec3<f32>(inv, inv, 1.0)));\n        }\n      }\n  `}}const $o={kernelName:Le,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:i,scale:r,offset:s,mean:a,variance:o}=e,{varianceEpsilon:u}=t,d=n,l=[i,a,o];let h=null;null!=s&&(h=s.shape,l.push(s));let p=null;null!=r&&(p=r.shape,l.push(r));const c=new Ro(i.shape,a.shape,o.shape,h,p),f=[{type:"float32",data:[u]}];return d.runWebGPUProgram(c,l,i.dtype,f)}};const Po={kernelName:Be,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s,filter:a,bias:o,preluActivationWeights:u}=t,{strides:d,pad:l,dataFormat:h,dilations:p,dimRoundingMode:c,activation:f,leakyreluAlpha:m}=r,g=n.convertConv2DDataFormat(h);return pa({x:s,filter:a,convInfo:n.computeConv2DInfo(s.shape,a.shape,d,p,l,c,!1,g),backend:i,bias:o,preluActivationWeights:u,leakyreluAlpha:m,activation:f})}};const zo={kernelName:_e,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:a,filter:o,bias:u,preluActivationWeights:d}=t,{strides:l,pad:h,dilations:p,dimRoundingMode:c,activation:f,leakyreluAlpha:m}=s;let g=p;null==g&&(g=[1,1]),i.assert(n.eitherStridesOrDilationsAreOne(l,g),(()=>`Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides ${l} and dilations '${g}'`));const x=n.computeConv2DInfo(a.shape,o.shape,l,g,h,c,!0),y=[a,o],w=null!=u,b=null!=d;w&&y.push(u),b&&y.push(d);const C=[{type:"int32",data:[x.padInfo.top,x.padInfo.left]},{type:"int32",data:[x.inHeight,x.inWidth]}];let S;return x.outHeight>4&&x.outWidth>4&&x.strideWidth<=2&&x.inChannels===x.outChannels&&1===x.dilationHeight&&1===x.dilationWidth&&x.inChannels%4==0?(S=new Oa(x,w,f,b),C.push({type:"int32",data:[S.virtualWidth]})):(S=new Ua(x,w,f,b),C.push({type:"int32",data:[x.filterHeight]},{type:"int32",data:[x.filterWidth]},{type:"int32",data:[x.strideHeight,x.strideWidth]},{type:"int32",data:[x.dilationHeight,x.dilationWidth]})),"leakyrelu"===f&&(C.push({type:"float32",data:[m]}),S.uniforms+=" alpha : f32,"),r.runWebGPUProgram(S,y,"float32",C)}};class Ao{constructor(e,t){this.variableNames=["A","indices"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey=`gathernd_${e}`,this.sliceDim=e,this.uniforms=`sliceDim : i32, strides : ${Pn(e)},`}getUserCode(){let e;e=this.sliceDim>1?"uniforms.strides[j]":"uniforms.strides";return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          var flattenIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexTemp = i32(round(getIndices(coords[0], j)));\n            let strideNum = ${e};\n            flattenIndex = flattenIndex + indexTemp * strideNum;\n          }\n\n          setOutputAtIndex(index, getA(flattenIndex, coords[1]));\n        }\n      }\n      `}}const No={kernelName:Oe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r}=e,{params:s,indices:a}=t,o=a.shape,u=o[o.length-1],d=i.sizeFromShape(s.shape),[l,h,p,c]=n.prepareAndValidate(s,a),f=wi({inputs:{x:a},backend:r,attrs:{shape:[h,u]}}),m=wi({inputs:{x:s},backend:r,attrs:{shape:[i.sizeFromShape(s.shape)/p,p]}});if(r.shouldExecuteOnCPU([s,a])||"string"===s.dtype){const e=r.readSync(a.dataId),t=r.bufferSync(s),n=kr(e,t,s.dtype,h,u,p,c,s.shape,d);return r.makeTensorInfo(l,s.dtype,n.values)}const g=new Ao(u,[h,p]),x=[{type:"int32",data:[u]},{type:"int32",data:c}],y=r.runWebGPUProgram(g,[m,f],m.dtype,x),w=wi({inputs:{x:y},backend:r,attrs:{shape:l}});return r.disposeData(f.dataId),r.disposeData(m.dataId),r.disposeData(y.dataId),w}};class Do{constructor(e,t){this.variableNames=["A","indices"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.slice(),this.aShape=e,this.outputShape=t,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="gather"}getUserCode(){const e=function(e){const t=["resRC.x","resRC.y","resRC.z","resRC.w"],n=[];for(let i=0;i<e.length;i++)2===i?n.push("indexZ"):n.push(`${t[i]}`);return n.join()}(this.aShape);return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let indexZ = i32(getIndices(resRC.x, resRC.z));\n          let inBounds = select(0.0, 1.0, indexZ >= 0 && indexZ < uniforms.aShape[2]);\n          setOutputAtIndex(index, inBounds * getA(${e}));\n        }\n      }\n    `}}function Fo(e){const{inputs:t,backend:r,attrs:s}=e,{x:a,indices:u}=t,{axis:d,batchDims:l}=s,h=i.parseAxisParam(d,a.shape)[0],p=n.segment_util.collectGatherOpShapeInfo(a,u,h,l),c=i.sizeFromShape(u.shape),f=[],m=wi({inputs:{x:a},backend:r,attrs:{shape:[p.batchSize,p.outerSize,p.dimSize,p.sliceSize]}}),g=wi({inputs:{x:u},backend:r,attrs:{shape:[p.batchSize,c/p.batchSize]}});f.push(m),f.push(g);const x=[p.batchSize,p.outerSize,c/p.batchSize,p.sliceSize];if(r.shouldExecuteOnCPU([a,u])){const e=r.tensorMap.get(g.dataId).values,t=o(g.shape,g.dtype,e),n=r.tensorMap.get(m.dataId).values,i=o(m.shape,m.dtype,n),s=Ir(i,t,x);return f.forEach((e=>r.disposeData(e.dataId))),r.makeTensorInfo(p.outputShape,s.dtype,s.values)}const y=new Do(m.shape,x),w=r.runWebGPUProgram(y,[m,g],m.dtype);f.push(w);const b=wi({inputs:{x:w},backend:r,attrs:{shape:p.outputShape}});return f.forEach((e=>r.disposeData(e.dataId))),b}const To={kernelName:Ue,backendName:"webgpu",kernelFunc:Fo},Eo={kernelName:Ve,backendName:"webgpu",kernelFunc:Ni({opType:Zn.GREATER,cpuKernelImpl:$r,dtype:"bool"})},Wo={kernelName:Me,backendName:"webgpu",kernelFunc:Ni({opType:Zn.GREATER_EQUAL,dtype:"bool",cpuKernelImpl:Rr})};const Lo={kernelName:Ge,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{input:i}=t;return go(i,!0,n)}},Bo={kernelName:He,backendName:"webgpu",kernelFunc:Ai({opType:ei.IS_FINITE,dtype:"bool"})},_o={kernelName:Xe,backendName:"webgpu",kernelFunc:Ai({opType:ei.IS_INF,dtype:"bool"})},Oo={kernelName:Ke,backendName:"webgpu",kernelFunc:Ai({opType:ei.IS_NAN,dtype:"bool"})};const Uo={kernelName:qe,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{alpha:s}=i,a=[{type:"float32",data:[s]}],o=new zi(r.shape,ei.LEAKYRELU,"alpha : f32,");return n.runWebGPUProgram(o,[r],"float32",a)}},Vo={kernelName:Ye,backendName:"webgpu",kernelFunc:Ni({opType:Zn.LESS,dtype:"bool",cpuKernelImpl:zr})},Mo={kernelName:je,backendName:"webgpu",kernelFunc:Ni({opType:Zn.LESS_EQUAL,dtype:"bool",cpuKernelImpl:Pr})};class Go{constructor(e){this.variableNames=[],this.outputShape=[],this.uniforms="start : f32, step : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="linSpace"}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          setOutputAtIndex(index, uniforms.start + f32(index) * uniforms.step);\n        }\n      }\n    `}}const Ho={kernelName:Qe,backendName:"webgpu",kernelFunc:function(e){const{backend:t,attrs:n}=e,{start:i,stop:r,num:s}=n,a=(r-i)/(s-1),o=new Go(s),u=[{type:"float32",data:[i]},{type:"float32",data:[a]}];return t.runWebGPUProgram(o,[],"float32",u)}},Xo={kernelName:Ze,backendName:"webgpu",kernelFunc:Ai({opType:ei.LOG,cpuKernelImpl:Ar})},Ko={kernelName:Je,backendName:"webgpu",kernelFunc:Ai({opType:ei.LOG1P})},qo={kernelName:et,backendName:"webgpu",kernelFunc:Ni({opType:Zn.LOGICAL_AND,dtype:"bool"})},Yo={kernelName:tt,backendName:"webgpu",kernelFunc:Ai({opType:ei.LOGICAL_NOT})},jo={kernelName:nt,backendName:"webgpu",kernelFunc:Ni({opType:Zn.LOGICAL_OR})},Qo="\n  var powValue = 0.0;\n  let basis = uniforms.bias + uniforms.alpha * sum;\n  if (uniforms.beta == 0.5) {\n    powValue = inverseSqrt(basis);\n  } else if (uniforms.beta == 1.0) {\n    powValue = 1.0 / basis;\n  } else {\n    powValue = exp(log(basis) * (-uniforms.beta));\n  }\n";class Zo{constructor(e){this.outputShape=[],this.variableNames=["x"],this.uniforms="radius : i32, bias : f32, alpha : f32, beta : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="lrn"}getUserCode(){return`\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let b = coords[0];\n        let r = coords[1];\n        let c = coords[2];\n        let d = coords[3];\n\n        let x = getX(b, r, c, d);\n        var sum = 0.0;\n        for (var i = -uniforms.radius; i <= uniforms.radius; i = i + 1) {\n          let idx = d + i;\n          if (idx >= 0 && idx < uniforms.xShape[3]) {\n            let z = getX(b, r, c, idx);\n            sum = sum + z * z;\n          }\n        }\n        ${Qo}\n\n        setOutputAtIndex(index, x * powValue);\n      }\n    }\n  `}}class Jo{constructor(e,t){this.outputShape=[],this.variableNames=["x"],this.uniforms="radius : i32, bias : f32, alpha : f32, beta : f32,",this.workgroupSize=[256,1,1],this.maxAllowRadius=16,i.assert(t<=this.maxAllowRadius,(()=>`Radius must be less than or equal to ${this.maxAllowRadius}, current radius is ${t}`)),this.outputShape=e,this.elementsPerWorkgroup=this.workgroupSize[0]-2*this.maxAllowRadius,this.dispatchLayout={x:[3],y:[2],z:[0,1]},this.dispatch=On(this.dispatchLayout,this.outputShape,[this.elementsPerWorkgroup,this.workgroupSize[1],this.workgroupSize[2]]),this.shaderKey="lrn_shared"}getUserCode(){return`\n    var <workgroup>lrnSub: array<f32, ${this.workgroupSize[0]}>;\n    const elementsPerWorkgroup = ${this.elementsPerWorkgroup};\n    const maxAllowRadius = ${this.maxAllowRadius};\n\n    ${An()} {\n      let localDepth = i32(localId.x);\n      let workgroupDepth = i32(workgroupId.x) * elementsPerWorkgroup;\n      let xDepth = workgroupDepth + localDepth - maxAllowRadius;\n      let b = i32(globalId.z) / uniforms.xShape[1];\n      let r = i32(globalId.z) - b * uniforms.xShape[1];\n      let c = i32(globalId.y);\n      let d = workgroupDepth + localDepth;\n\n      var x = 0.0;\n      if (xDepth >= 0 && xDepth < uniforms.xShape[3]) {\n        x = getX(b, r, c, xDepth);\n      }\n      lrnSub[localDepth] = x;\n      workgroupBarrier();\n\n      if (localDepth < elementsPerWorkgroup && d < uniforms.outShape[3]) {\n        var sum = 0.0;\n        let index = localDepth + maxAllowRadius;\n        for (var i = -uniforms.radius; i <= uniforms.radius; i = i + 1) {\n          let z = lrnSub[index + i];\n          sum = sum + z * z;\n        }\n        ${Qo}\n\n        setOutputAtCoords(b, r, c, d, lrnSub[index] * powValue);\n      }\n    } `}}const eu={kernelName:it,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{depthRadius:s,bias:a,alpha:o,beta:u}=i;let d;d=s>16?new Zo(r.shape):new Jo(r.shape,s);const l=[{type:"int32",data:[s]},{type:"float32",data:[a]},{type:"float32",data:[o]},{type:"float32",data:[u]}];return n.runWebGPUProgram(d,[r],r.dtype,l)}};class tu{constructor(e){this.outputShape=[],this.variableNames=["inputImage","outputImage","dy"],this.uniforms="depthRadius : i32, bias : f32, alpha : f32, beta : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="lrn_grad"}getUserCode(){return`\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let b = coords[0];\n        let r = coords[1];\n        let c = coords[2];\n\n        let MIN_DEPTH_BEGIN = 0;\n        let MAX_DEPTH_END = uniforms.outShape[3];\n        var result = 0.0;\n        for (var d = MIN_DEPTH_BEGIN; d < MAX_DEPTH_END; d++) {\n          let depthBegin = max(MIN_DEPTH_BEGIN, d - uniforms.depthRadius);\n          let depthEnd = min(MAX_DEPTH_END, d + uniforms.depthRadius + 1);\n\n          var norm = 0.0;\n          for (var k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; k++) {\n            if (k < depthBegin) {\n              continue;\n            } else if (k >= depthBegin && k < depthEnd) {\n              norm += getInputImage(b, r, c, k) * getInputImage(b, r, c, k);\n            } else {\n              break;\n            }\n          }\n\n          norm = uniforms.alpha * norm + uniforms.bias;\n\n          for (var k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; k++) {\n            if (k < depthBegin) {\n              continue;\n            } else if (k >= depthBegin && k < depthEnd) {\n              var dyi = -2.0 * uniforms.alpha * uniforms.beta\n                * getInputImage(b, r, c, k) * getOutputImage(b, r, c, d) / norm;\n              if (k == d) {\n                dyi += pow(norm, -1.0 * uniforms.beta);\n              }\n              if (k == coords[3]) {\n                dyi *= getDy(b, r, c, d);\n                result += dyi;\n              }\n            } else {\n              break;\n            }\n          }\n        }\n\n        setOutputAtIndex(index, result);\n      }\n    }\n  `}}const nu={kernelName:rt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r,y:s,dy:a}=t,{depthRadius:o,bias:u,alpha:d,beta:l}=i,h=new tu(r.shape),p=[{type:"int32",data:[o]},{type:"float32",data:[u]},{type:"float32",data:[d]},{type:"float32",data:[l]}];return n.runWebGPUProgram(h,[r,s,a],r.dtype,p)}},iu={kernelName:st,backendName:"webgpu",kernelFunc:Ni({opType:Zn.MAX,cpuKernelImpl:Dr})};const ru={kernelName:at,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s}=t,{filterSize:a,strides:o,pad:u,dimRoundingMode:d}=r;return Rs(s,n.computePool2DInfo(s.shape,a,o,1,u,d),"max",i)}};const su={kernelName:ot,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{x:s}=t,{filterSize:a,strides:o,pad:u,dataFormat:d,dimRoundingMode:l}=r,h=n.computePool3DInfo(s.shape,a,o,[1,1,1],u,l,d),p=new Cs(h,"max"),c=[{type:"int32",data:[h.strideDepth,h.strideHeight,h.strideWidth]},{type:"int32",data:[h.padInfo.front,h.padInfo.top,h.padInfo.left]},{type:"int32",data:[h.inDepth,h.inHeight,h.inWidth]},{type:"int32",data:[h.effectiveFilterDepth,h.effectiveFilterHeight,h.effectiveFilterWidth]}];return i.runWebGPUProgram(p,[s],s.dtype,c)}};class au{constructor(e){this.variableNames=["dy","maxPos"],this.uniforms="strides : vec2<i32>, pads : vec2<i32>, dilations : vec2<i32>, filterDims : vec2<i32>,\n       outHeight : i32, outWidth : i32",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="maxPool2DBackprop"}getUserCode(){return`\n      ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords[0];\n        let d = coords[3];\n\n        let dyRCCorner = vec2<i32>(coords.yz) - uniforms.pads;\n        let dyRCorner = dyRCCorner.x;\n        let dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        let lastIndex = uniforms.filterDims[0] * uniforms.filterDims[1] - 1;\n        for (var wR = 0; wR < uniforms.filterDims[0]; wR += uniforms.dilations[0]) {\n          let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[0]);\n\n          if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n            continue;\n          }\n          let idyR = i32(dyR);\n\n          for (var wC = 0; wC < uniforms.filterDims[1]; wC += uniforms.dilations[1]) {\n            let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[1]);\n\n            if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n              continue;\n            }\n            let idyC = i32(dyC);\n\n            let dyValue = getDy(batch, idyR, idyC, d);\n            let maxPosValue = lastIndex - i32(getMaxPos(batch, idyR, idyC, d));\n\n            // Get the current value, check it against the value from the\n            // position matrix.\n            let curPosValue = wR * uniforms.filterDims[1] + wC;\n            let mask = select(0.0, 1.0, maxPosValue == curPosValue);\n            dotProd += dyValue * mask;\n          }\n        }\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}class ou{constructor(e){this.variableNames=["dy","maxPos"],this.uniforms="strides : vec3<i32>, pads : vec3<i32>, filterDims : vec3<i32>,\n      outDepth : i32, outHeight : i32, outWidth : i32",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e.inShape,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="maxPool3DBackprop"}getUserCode(){return`\n      ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n        let batch = coords.x;\n        let ch = coords.u;\n\n        let dyCorner = vec3<i32>(coords.y, coords.z, coords.w) - uniforms.pads;\n        let dyDCorner = dyCorner.x;\n        let dyRCorner = dyCorner.y;\n        let dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, ch) with pos mask(:, :, :, d) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        var dotProd = 0.0;\n        let lastIndex = uniforms.filterDims[0] * uniforms.filterDims[1] * uniforms.filterDims[2] - 1;\n\n        for (var wD = 0; wD < uniforms.filterDims[0]; wD++) {\n          let dyD = f32(dyDCorner + wD) / f32(uniforms.strides[0]);\n\n          if (dyD < 0.0 || dyD >= f32(uniforms.outDepth) || fract(dyD) > 0.0) {\n            continue;\n          }\n          let idyD = i32(dyD);\n\n          for (var wR = 0; wR < uniforms.filterDims[1]; wR++) {\n            let dyR = f32(dyRCorner + wR) / f32(uniforms.strides[1]);\n\n            if (dyR < 0.0 || dyR >= f32(uniforms.outHeight) || fract(dyR) > 0.0) {\n              continue;\n            }\n            let idyR = i32(dyR);\n\n            for (var wC = 0; wC < uniforms.filterDims[2]; wC++) {\n              let dyC = f32(dyCCorner + wC) / f32(uniforms.strides[2]);\n\n              if (dyC < 0.0 || dyC >= f32(uniforms.outWidth) || fract(dyC) > 0.0) {\n                continue;\n              }\n              let idyC = i32(dyC);\n\n              let dyValue = getDy(batch, idyD, idyR, idyC, ch);\n              let maxPosValue = lastIndex - i32(getMaxPos(batch, idyD, idyR, idyC, ch));\n\n              // Get the current value, check it against the value from the\n              // position matrix.\n              let curPosValue = wD * uniforms.filterDims[1] * uniforms.filterDims[2] + wR * uniforms.filterDims[2] + wC;\n              let mask = select(0.0, 1.0, maxPosValue == curPosValue);\n              dotProd += dyValue * mask;\n            }\n          }\n        }\n\n        setOutputAtIndex(index, dotProd);\n      }\n    }\n    `}}const uu={kernelName:ut,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{dy:s,input:a}=t,o=a,{filterSize:u,strides:d,pad:l,dimRoundingMode:h}=r,p=n.computePool3DInfo(o.shape,u,d,[1,1,1],l,h),c=new Cs(p,"max",!0);let f=[{type:"int32",data:[p.strideDepth,p.strideHeight,p.strideWidth]},{type:"int32",data:[p.padInfo.front,p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.inDepth,p.inHeight,p.inWidth]},{type:"int32",data:[p.effectiveFilterDepth,p.effectiveFilterHeight,p.effectiveFilterWidth]}];const m=i.runWebGPUProgram(c,[o],"int32",f),g=new ou(p);f=[{type:"int32",data:[p.strideDepth,p.strideHeight,p.strideWidth]},{type:"int32",data:[p.effectiveFilterDepth-1-p.padInfo.front,p.effectiveFilterHeight-1-p.padInfo.top,p.effectiveFilterWidth-1-p.padInfo.left]},{type:"int32",data:[p.effectiveFilterDepth,p.effectiveFilterHeight,p.effectiveFilterWidth]},{type:"int32",data:[p.outDepth]},{type:"int32",data:[p.outHeight]},{type:"int32",data:[p.outWidth]}];const x=i.runWebGPUProgram(g,[s,m],o.dtype,f);return i.disposeData(m.dataId),x}};const du={kernelName:dt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:i,attrs:r}=e,{dy:s,input:a,output:o}=t,u=a;Kn([a,o],"maxPoolGrad");const{filterSize:d,strides:l,pad:h,dimRoundingMode:p}=r,c=n.computePool2DInfo(u.shape,d,l,1,h,p),f=new bs(c,"max",!0);let m=[{type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.padInfo.top,c.padInfo.left]},{type:"int32",data:[c.dilationHeight,c.dilationWidth]},{type:"int32",data:[c.inHeight,c.inWidth]},{type:"int32",data:[c.effectiveFilterHeight,c.effectiveFilterWidth]}];const g=i.runWebGPUProgram(f,[u],"int32",m),x=new au(c);m=[{type:"int32",data:[c.strideHeight,c.strideWidth]},{type:"int32",data:[c.effectiveFilterHeight-1-c.padInfo.top,c.effectiveFilterWidth-1-c.padInfo.left]},{type:"int32",data:[c.dilationHeight,c.dilationWidth]},{type:"int32",data:[c.effectiveFilterHeight,c.effectiveFilterWidth]},{type:"int32",data:[c.outHeight]},{type:"int32",data:[c.outWidth]}];const y=i.runWebGPUProgram(x,[s,g],u.dtype,m);return i.disposeData(g.dataId),y}};const lu={kernelName:lt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{filterSize:a,strides:o,pad:u,includeBatchInIndex:d}=s,{x:l}=t;i.assert(4===l.shape.length,(()=>`Error in maxPool: input must be rank 4 but got rank ${l.shape.length}.`));const h=[1,1];i.assert(n.eitherStridesOrDilationsAreOne(o,h),(()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${o} and dilations '${h}'`));const p=n.computePool2DInfo(l.shape,a,o,h,u),c=[{type:"int32",data:[p.strideHeight,p.strideWidth]},{type:"int32",data:[p.padInfo.top,p.padInfo.left]},{type:"int32",data:[p.dilationHeight,p.dilationWidth]},{type:"int32",data:[p.inHeight,p.inWidth]},{type:"int32",data:[p.effectiveFilterHeight,p.effectiveFilterWidth]}];let f=new bs(p,"max",!1);const m=r.runWebGPUProgram(f,[l],l.dtype,c);return f=new bs(p,"max",!0,!0,d),[m,r.runWebGPUProgram(f,[l],"int32",c)]}};const hu={kernelName:ht,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,keepDims:a}=i;return us(r,s,a,"min",n)}},pu={kernelName:pt,backendName:"webgpu",kernelFunc:Ni({opType:Zn.MIN,cpuKernelImpl:Fr})};class cu{constructor(e,t,n){this.uniforms="",this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.xShape=e,t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.offset="reflect"===n?0:1,this.shaderKey=`mirrorPad_${n}`}getUserCode(){const e=this.xShape.length,t=this.xShape.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),n=this.xShape.map(((t,n)=>`uniforms.pad${n}[0] + uniforms.xShape${e>1?`[${n}]`:""}`)).join(","),i=1===e?"start":"start[i]",r=1===e?"end":"end[i]",s=1===e?"outC":"outC[i]",a=Pn(e),o=e>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,e):"coords";return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let start = ${a}(${t});\n          let end = ${a}(${n});\n          var outC = getCoordsFromIndex(index);\n          for (var i = 0; i < ${e}; i = i + 1) {\n            if (${s} < ${i}) {\n              ${s} = ${i} * 2 - ${s} - ${this.offset};\n            } else if(${s} >= ${r}) {\n              ${s} = (${r} - 1) * 2 - ${s} + ${this.offset};\n            }\n          }\n          let coords = outC - start;\n          setOutputAtIndex(index, getX(${o}));\n        }\n      }\n    `}}const fu={kernelName:ct,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:n})=>{const{x:i}=e,{paddings:r,mode:s}=t,a=n,o=r.map((e=>({type:"int32",data:[e[0],e[1]]}))),u=new cu(i.shape,r,s);return a.runWebGPUProgram(u,[i],i.dtype,o)}},mu={kernelName:ft,backendName:"webgpu",kernelFunc:Ni({opType:Zn.MOD})};class gu{constructor(e,t){this.variableNames=["probs"],this.outputShape=[],this.uniforms="seed : f32, numOutcomes: i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e,t],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="multinomial"}getUserCode(){return`\n    //Based on the work of Dave Hoskins\n    //https://www.shadertoy.com/view/4djSRW\n    fn random (seed : f32, resultUV : vec2<f32>) -> f32 {\n      let HASHSCALE1 = 443.8975;\n      let p = resultUV * seed;\n      var p3  = fract(vec3<f32>(p.xyx) * HASHSCALE1);\n      p3 = p3 + dot(p3, p3.yzx + 19.19);\n      return fract((p3.x + p3.y) * p3.z);\n    }\n\n    ${An("index")} {\n      if (index < uniforms.size) {\n        let coords = getOutputCoords();\n        let batch = coords[0];\n\n        let resUV = vec2<f32>(f32(coords[1]) / f32(uniforms.outShape[1]),\n            f32(coords[0]) / f32(uniforms.outShape[0]));\n        let r = random(uniforms.seed, resUV);\n        var cdf = 0.0;\n        for (var i = 0; i < uniforms.numOutcomes - 1; i = i + 1) {\n          cdf = cdf + getProbs(batch, i);\n\n          if (r < cdf) {\n            setOutputAtIndexI32(index, i);\n            return;\n          }\n        }\n\n        // If no other event happened, last event happened.\n        setOutputAtIndexI32(index, uniforms.numOutcomes - 1);\n      }\n    }\n  `}}class xu{constructor(e){this.variableNames=["logits"],this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=[this.outputShape[0],1,1],this.outputShape[1]>=4096?this.workgroupSize=[256,1,1]:this.workgroupSize=[64,1,1],this.shaderKey="softmax"}getUserCode(){return`\n    var<workgroup> buf : array<f32, ${this.workgroupSize[0]}>;\n    var<workgroup> rowMaxShared : f32;\n    var<workgroup> rowSumShared : f32;\n    const blockSize = ${this.workgroupSize[0]};\n    ${An("index")} {\n      let row = index / blockSize;\n      let tid = i32(localId.x);\n      let cols = uniforms.outShape[1];\n\n      var threadMax = -3.402823e+38f;\n      for (var col = tid; col < cols; col += blockSize) {\n        let value = getLogits(row, col);\n        threadMax = max(threadMax, value);\n      }\n      if (tid < cols) {\n        buf[tid] = threadMax;\n      }\n      workgroupBarrier();\n\n      var reduceSize = min(cols, blockSize);\n      for (var currSize = reduceSize >> 1;  currSize > 0; currSize = reduceSize >> 1) {\n        reduceSize = currSize + (reduceSize & 1);\n        if (tid < currSize) {\n          buf[tid] = max(buf[tid], buf[tid + reduceSize]);\n        }\n        workgroupBarrier();\n      }\n\n      if (tid == 0) {\n        rowMaxShared = buf[0];\n      }\n      workgroupBarrier();\n\n      var threadSum = 0.0;\n      for (var col = tid; col < cols; col += blockSize) {\n        let subExp = exp(getLogits(row, col) - rowMaxShared);\n        threadSum += subExp;\n      }\n      buf[tid] = threadSum;\n      workgroupBarrier();\n\n      for (var currSize = blockSize >> 1;  currSize > 0; currSize = currSize >> 1) {\n        if (tid < currSize) {\n          buf[tid] = buf[tid] + buf[tid + currSize];\n        }\n        workgroupBarrier();\n      }\n\n      if (tid == 0) {\n        rowSumShared = buf[0];\n      }\n      workgroupBarrier();\n\n      for (var col = tid; col < cols; col += blockSize) {\n        let value = exp(getLogits(row, col) - rowMaxShared) / rowSumShared;\n        setOutputAtCoords(row, col, value);\n      }\n  }\n    `}}function yu(e){const{inputs:t,backend:n,attrs:r}=e,{logits:s}=t,{dim:a}=r,o=wi({inputs:{x:s},backend:n,attrs:{shape:[i.sizeFromShape(s.shape)/s.shape[a],s.shape[a]]}}),u=new xu(o.shape),d=n.runWebGPUProgram(u,[o],s.dtype),l=wi({inputs:{x:d},backend:n,attrs:{shape:s.shape}});return n.disposeData(o.dataId),n.disposeData(d.dataId),l}const wu={kernelName:mt,backendName:"webgpu",kernelFunc:yu};const bu={kernelName:gt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{logits:r}=t,{numSamples:s,seed:a,normalized:o}=i,u=o?r:yu({inputs:{logits:r},backend:n,attrs:{dim:r.shape.length-1}}),d=u.shape[0],l=u.shape[1],h=new gu(d,s),p=[{type:"float32",data:[a]},{type:"int32",data:[l]}],c=n.runWebGPUProgram(h,[u],"int32",p);return o||n.disposeData(u.dataId),c}};const Cu={kernelName:xt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:i}=t;if(n.shouldExecuteOnCPU([i])){const e=n.tensorMap.get(i.dataId),[t,r]=Er(e.values,i.shape,i.dtype);return n.makeTensorInfo(r,i.dtype,t)}const r=new zi(i.shape,ei.NEG);return n.runWebGPUProgram(r,[i],i.dtype)}};const Su={kernelName:yt,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:t,backend:n,attrs:i}=e,{boxes:r,scores:s}=t,{maxOutputSize:a,iouThreshold:o,scoreThreshold:u}=i,d=n.readSync(r.dataId),l=n.readSync(s.dataId),{selectedIndices:h}=wt.nonMaxSuppressionV3Impl(d,l,a,o,u);return n.makeTensorInfo([h.length],"int32",new Int32Array(h))}};const vu={kernelName:bt,backendName:"webgpu",kernelFunc:function(e){console.warn("tf.nonMaxSuppression() in webgpu locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");const{inputs:t,backend:n,attrs:i}=e,{boxes:r,scores:s}=t,{maxOutputSize:a,iouThreshold:o,scoreThreshold:u,softNmsSigma:d}=i,l=n.readSync(r.dataId),h=n.readSync(s.dataId),p=a,c=o,f=u,m=d,{selectedIndices:g,selectedScores:x}=wt.nonMaxSuppressionV5Impl(l,h,p,c,f,m);return[n.makeTensorInfo([g.length],"int32",new Int32Array(g)),n.makeTensorInfo([x.length],"float32",new Float32Array(x))]}};class ku{constructor(e,t){this.variableNames=["x"],this.uniforms="onValue : f32, offValue : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e,t],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="onehot"}getUserCode(){return`\n      ${An("index")} {\n        if(index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          setOutputAtIndex(index, mix(uniforms.offValue, uniforms.onValue,\n                                      f32(i32(round(getX(coords.x))) == coords.y)));\n        }\n      }\n    `}}const Iu={kernelName:Ct,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{indices:s}=t,{dtype:a,depth:o,onValue:u,offValue:d}=r,l=i.sizeFromShape(s.shape),h=new ku(l,o),p=wi({inputs:{x:s},backend:n,attrs:{shape:[l]}}),c=[{type:"float32",data:[u]},{type:"float32",data:[d]}],f=n.runWebGPUProgram(h,[p],a,c);n.disposeData(p.dataId);const m=wi({inputs:{x:f},backend:n,attrs:{shape:[...s.shape,o]}});return n.disposeData(f.dataId),m}};function Ru(e){const{inputs:t,backend:n}=e,{x:i}=t;if("complex64"===i.dtype){const e=Xs({inputs:{input:i},backend:n}),t=Ru({inputs:{x:e},backend:n}),r=ia({inputs:{input:i},backend:n}),s=Ru({inputs:{x:r},backend:n}),a=$i({inputs:{real:t,imag:s},backend:n});return n.disposeData(e.dataId),n.disposeData(t.dataId),n.disposeData(r.dataId),n.disposeData(s.dataId),a}return xi({attrs:{shape:i.shape,dtype:i.dtype,value:"string"===i.dtype?"":0},backend:n})}const $u={kernelName:St,backendName:"webgpu",kernelFunc:Ru};const Pu={kernelName:vt,backendName:"webgpu",kernelFunc:function e(t){const{inputs:n,backend:i}=t,{x:r}=n;if("string"===r.dtype)throw new Error("onesLike is not supported under string dtype");if("complex64"===r.dtype){const t=Xs({inputs:{input:r},backend:i}),n=e({inputs:{x:t},backend:i}),s=ia({inputs:{input:r},backend:i}),a=Ru({inputs:{x:s},backend:i}),o=$i({inputs:{real:n,imag:a},backend:i});return i.disposeData(t.dataId),i.disposeData(n.dataId),i.disposeData(s.dataId),i.disposeData(a.dataId),o}return xi({attrs:{shape:r.shape,dtype:r.dtype,value:1},backend:i})}};const zu={kernelName:kt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{axis:s}=r;if(1===t.length)return po({inputs:{input:t[0]},backend:n,attrs:{dim:s}});const a=t[0].shape,o=t[0].dtype;t.forEach((e=>{i.assertShapesMatch(a,e.shape,"All tensors passed to stack must have matching shapes"),i.assert(o===e.dtype,(()=>"All tensors passed to stack must have matching dtypes"))}));const u=[],d=aa({inputs:t.map((e=>{const t=po({inputs:{input:e},backend:n,attrs:{dim:s}});return u.push(t),t})),backend:n,attrs:{axis:s}});return u.forEach((e=>n.disposeData(e.dataId))),d}};function Au(e,t=!1){const n=e.length,i=Pn(n),r=e.map(((e,t)=>`uniforms.pad${t}[0]`)).join(","),s=e.map(((e,t)=>`uniforms.pad${t}[0] + uniforms.xShape${n>1?`[${t}]`:""}`)).join(",");return`\n        let start = ${n>1?`${i}(${r})`:`${r}`};\n        let end = ${n>1?`${i}(${s})`:`${s}`};\n        if (${n>1?"any(paddedCoords < start)":"paddedCoords < start"} || ${n>1?"any(paddedCoords >= end)":"paddedCoords >= end"}) {\n          setOutputAtIndex(index, ${t?0:"uniforms.constantValue"});\n        } else {\n          let coords = paddedCoords - start;\n          setOutputAtIndex(index, getX(${n>1?["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,n):"coords"}));\n        }\n  `}class Nu{constructor(e,t){this.variableNames=["x"],this.uniforms="constantValue : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t.map(((t,n)=>t[0]+e[n]+t[1])),this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),t.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.xShape=e,this.shaderKey="pad"}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let paddedCoords = getCoordsFromIndex(index);\n          ${Au(this.xShape)}\n        }\n      }\n    `}}const Du={kernelName:It,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{paddings:a,constantValue:o}=r;if(a.every((e=>i.arraysEqual(e,[0,0]))))return Ii({inputs:{x:s},backend:n});if(0===i.sizeFromShape(s.shape)){return xi({backend:n,attrs:{shape:a.map(((e,t)=>e[0]+s.shape[t]+e[1])),value:o,dtype:s.dtype}})}const u=[{type:"float32",data:[o]}];a.map((e=>u.push({type:"int32",data:[e[0],e[1]]})));const d=new Nu(s.shape,a);return n.runWebGPUProgram(d,[s],s.dtype,u)}},Fu={kernelName:Rt,backendName:"webgpu",kernelFunc:Ni({opType:Zn.POW})};const Tu={kernelName:$t,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{x:i,alpha:r}=t,s=new ki(Zn.PRELU,i.shape,r.shape);return n.runWebGPUProgram(s,[i,r],"float32")}};const Eu={kernelName:Pt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{x:r}=t,{axis:s,keepDims:a}=i;return us(r,s,a,"prod",n)}},Wu={kernelName:zt,backendName:"webgpu",kernelFunc:e=>{const{backend:t,attrs:n}=e,{start:i,stop:r,step:s,dtype:a}=n,o=Br(i,r,s,a);return t.makeTensorInfo([o.length],a,o)}},Lu={kernelName:At,backendName:"webgpu",kernelFunc:Ni({opType:Zn.DIV})},Bu={kernelName:Nt,backendName:"webgpu",kernelFunc:Ai({opType:ei.RECIPROCAL})},_u={kernelName:Dt,backendName:"webgpu",kernelFunc:Ai({opType:ei.RELU})},Ou={kernelName:Ft,backendName:"webgpu",kernelFunc:Ai({opType:ei.RELU6})};class Uu{constructor(e,t,n){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, halfPixelCenters : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="resizeBilinear"}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n        let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC =\n            (vec2<f32>(rc) + vec2<f32>(uniforms.halfPixelCenters)) *\n            effectiveInputOverOutputRatioRC - vec2<f32>(uniforms.halfPixelCenters);\n\n          // Compute the four integer indices.\n          let sourceFloorRC = vec2<i32>(sourceFracIndexRC);\n          let sourceCeilRC = vec2<i32>(\n            min(vec2<f32>(uniforms.xShape.yz) - vec2<f32>(1.0), ceil(sourceFracIndexRC)));\n\n          let topLeft = getX(b, sourceFloorRC.x, sourceFloorRC.y, d);\n          let bottomLeft = getX(b, sourceCeilRC.x, sourceFloorRC.y, d);\n          let topRight = getX(b, sourceFloorRC.x, sourceCeilRC.y, d);\n          let bottomRight = getX(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n          let fracRC = sourceFracIndexRC - vec2<f32>(sourceFloorRC);\n\n          let top = topLeft + (topRight - topLeft) * fracRC.y;\n          let bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n          let newValue = top + (bottom - top) * fracRC.x;\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const Vu={kernelName:Tt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r}=t,{alignCorners:s,size:a,halfPixelCenters:o}=i,[u,d]=a,l=[{type:"float32",data:[s&&u>1?1:0,s&&d>1?1:0]},{type:"float32",data:[o?.5:0]}],h=new Uu(r.shape,u,d);return n.runWebGPUProgram(h,[r],"float32",l)}};class Mu{constructor(e,t){this.variableNames=["dy"],this.uniforms="effectiveXSize : vec2<i32>, effectiveYSize : vec2<i32>, heightScale : f32, widthScale : f32,\n       invHeightScale : f32, invWidthScale : f32, winHeight : i32, winWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.alignCorners=t,this.shaderKey=`resizeBilinearBackprop_${t}`}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let b = coords[0];\n          let d = coords[3];\n          let r = coords[1];\n          let c = coords[2];\n\n          var accumulator = 0.0;\n\n          // Compute bounds for where in dy we will look\n          let startRLerp = floor(f32(r) * uniforms.invHeightScale);\n          let startDyR = i32(startRLerp - f32(uniforms.winHeight / 2));\n\n          let startCLerp = floor(f32(c) * uniforms.invWidthScale);\n          let startDyC = i32(startCLerp - f32(uniforms.winWidth / 2));\n\n          // Loop over dy\n          for (var dyROffset = 0; dyROffset < uniforms.winHeight; dyROffset++) {\n            let dyR = startDyR + dyROffset;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyR < 0 || dyR >= uniforms.dyShape[1]) {\n              continue;\n            }\n\n            for (var dyCOffset = 0; dyCOffset < uniforms.winWidth; dyCOffset++) {\n              let dyC = startDyC + dyCOffset;\n\n              // Guard against the window exceeding the bounds of dy\n              if (dyC < 0 || dyC >= uniforms.dyShape[2]) {\n                continue;\n              }\n\n              let dxR = f32(dyR) * uniforms.heightScale;\n              let topDxRIndex = i32(floor(dxR));\n              let bottomDxRIndex = i32(min(ceil(dxR), f32(uniforms.outShape[1] - 1)));\n              let dxRLerp = dxR - f32(topDxRIndex);\n              let inverseDxRLerp = 1.0 - dxRLerp;\n\n              let dxC = f32(dyC) * uniforms.widthScale;\n              let leftDxCIndex = i32(floor(dxC));\n              let rightDxCIndex = i32(min(ceil(dxC), f32(uniforms.outShape[2] - 1)));\n              let dxCLerp = dxC - f32(leftDxCIndex);\n              let inverseDxCLerp = 1.0 - dxCLerp;\n\n              if (r == topDxRIndex && c == leftDxCIndex) {\n                // topLeft\n                accumulator +=\n                  getDy(b, dyR, dyC, d) * inverseDxRLerp * inverseDxCLerp;\n              }\n\n              if (r == topDxRIndex && c == rightDxCIndex) {\n                // topRight\n                accumulator += getDy(b, dyR, dyC, d) * inverseDxRLerp * dxCLerp;\n              }\n\n              if (r == bottomDxRIndex && c == leftDxCIndex) {\n                // bottomLeft\n                accumulator += getDy(b, dyR, dyC, d) * dxRLerp * inverseDxCLerp;\n              }\n\n              if (r == bottomDxRIndex && c == rightDxCIndex) {\n                // bottomRight\n                accumulator += getDy(b, dyR, dyC, d) * dxRLerp * dxCLerp;\n              }\n            }\n          }\n          // End loop over dy\n\n          setOutputAtIndex(index, accumulator);\n        }\n      }\n    `}}const Gu={kernelName:Et,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r,dy:s}=t,{alignCorners:a}=i,[,o,u]=r.shape,[,d,l]=s.shape,h=[a&&d>1?o-1:o,a&&l>1?u-1:u],p=[a&&d>1?d-1:d,a&&l>1?l-1:l],c=h[0]/p[0],f=h[1]/p[1],m=1/c,g=1/f,x=2*Math.ceil(m)+2,y=2*Math.ceil(g)+2,w=new Mu(r.shape,a),b=[{type:"int32",data:h},{type:"int32",data:p},{type:"float32",data:[c]},{type:"float32",data:[f]},{type:"float32",data:[m]},{type:"float32",data:[g]},{type:"int32",data:[x]},{type:"int32",data:[y]}];return n.runWebGPUProgram(w,[s],s.dtype,b)}};class Hu{constructor(e,t,n,i){this.variableNames=["x"],this.uniforms="adjustHeightWidth : vec2<f32>, roundBase : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=[e[0],t,n,e[3]],this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.halfPixelCenters=i,this.shaderKey=`resizeNearest_${i}`}getUserCode(){let e;e=this.halfPixelCenters?"max((vec2<f32>(rc) + vec2<f32>(0.5)) * effectiveInputOverOutputRatioRC, vec2<f32>(0.0))":"vec2<f32>(rc) * effectiveInputOverOutputRatioRC";return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let b = coords[0];\n          let d = coords[3];\n          let rc = coords.yz;\n\n          let effectiveInSize = vec2<f32>(\n            f32(uniforms.xShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.xShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveOutSize = vec2<f32>(\n            f32(uniforms.outShape.y) - uniforms.adjustHeightWidth[0],\n            f32(uniforms.outShape.z) - uniforms.adjustHeightWidth[1]);\n\n          let effectiveInputOverOutputRatioRC =\n              effectiveInSize / effectiveOutSize;\n\n          // Fractional source index\n          let sourceFracIndexRC = ${e};\n\n          // Compute the coordinators of nearest neighbor point.\n          let inputShapeRC = vec2<f32>(f32(uniforms.xShape.y), f32(uniforms.xShape.z));\n          let sourceNearestRC = vec2<i32>(\n            min(inputShapeRC - 1.0, floor(sourceFracIndexRC + uniforms.roundBase)));\n          let newValue = getX(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n          setOutputAtIndex(index, newValue);\n        }\n      }\n    `}}const Xu={kernelName:Wt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r}=t,{alignCorners:s,halfPixelCenters:a,size:o}=i,[u,d]=o,l=[{type:"float32",data:[s&&u>1?1:0,s&&d>1?1:0]},{type:"float32",data:[s?.5:0]}],h=new Hu(r.shape,u,d,a);return n.runWebGPUProgram(h,[r],r.dtype,l)}};class Ku{constructor(e,t){this.variableNames=["dy"],this.uniforms="effectiveXSize : vec2<i32>, effectiveYSize : vec2<i32>, invHeightScale : f32, invWidthScale : f32,\n       winHeight : i32, winWidth : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.alignCorners=t,this.shaderKey=`resizeNearestNeigborBackprop_${t}`}getUserCode(){return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getOutputCoords();\n          let b = coords[0];\n          let d = coords[3];\n          let r = coords[1];\n          let c = coords[2];\n\n          var accumulator = 0.0;\n\n          // Compute bounds for where in dy we will look\n          let startRLerp = floor(f32(r) * uniforms.invHeightScale);\n          let startDyR = i32(floor(startRLerp - f32(uniforms.winHeight / 2)));\n\n          let startCLerp = floor(f32(c) * uniforms.invWidthScale);\n          let startDyC = i32(floor(startCLerp - f32(uniforms.winWidth / 2)));\n\n          // Loop over dy\n          for (var dyROffset = 0; dyROffset < uniforms.winHeight; dyROffset++) {\n            let dyR = startDyR + dyROffset;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyR < 0 || dyR >= uniforms.dyShape[1]) {\n              continue;\n            }\n\n            for (var dyCOffset = 0; dyCOffset < uniforms.winWidth; dyCOffset++) {\n              let dyC = startDyC + dyCOffset;\n\n              // Guard against the window exceeding the bounds of dy\n              if (dyC < 0 || dyC >= uniforms.dyShape[2]) {\n                continue;\n              }\n\n              let sourceFracRow = f32(uniforms.effectiveXSize[0]) *\n                  (f32(dyR) / f32(uniforms.effectiveYSize[0]));\n\n              let sourceFracCol = f32(uniforms.effectiveXSize[1]) *\n                  (f32(dyC) / f32(uniforms.effectiveYSize[1]));\n\n              let sourceNearestRow =\n                  i32(min(f32(uniforms.outShape[1] - 1),\n                  ${this.alignCorners?"floor(sourceFracRow + 0.5)":"floor(sourceFracRow)"}));\n\n              let sourceNearestCol =\n                  i32(min(f32(uniforms.outShape[2] - 1),\n                  ${this.alignCorners?"floor(sourceFracCol + 0.5)":"floor(sourceFracCol)"}));\n\n              if (r == sourceNearestRow && c == sourceNearestCol) {\n                accumulator += getDy(b, dyR, dyC, d);\n              }\n            }\n          }\n          // End loop over dy\n\n          setOutputAtIndex(index, accumulator);\n        }\n      }\n    `}}const qu={kernelName:Lt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{images:r,dy:s}=t,{alignCorners:a}=i,[,o,u]=r.shape,[,d,l]=s.shape,h=[a&&d>1?o-1:o,a&&l>1?u-1:u],p=[a&&d>1?d-1:d,a&&l>1?l-1:l],c=1/(h[0]/p[0]),f=1/(h[1]/p[1]),m=2*Math.ceil(c)+2,g=2*Math.ceil(f)+2,x=new Ku(r.shape,a),y=[{type:"int32",data:h},{type:"int32",data:p},{type:"float32",data:[c]},{type:"float32",data:[f]},{type:"int32",data:[m]},{type:"int32",data:[g]}];return n.runWebGPUProgram(x,[s],s.dtype,y)}};class Yu{constructor(e){this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms=" axis : vec4<i32>,",this.shaderKey="reverse"}getUserCode(){return`\n      \n      // Using uniform variables as judging conditions, so the function has\n      // coherent execution within all threads.\n      fn getReverseCoords(coords : vec4<i32>) -> vec4<i32> {\n        var reverseCoords = coords;\n        if (uniforms.axis[0] == 1) {\n          reverseCoords[0] = uniforms.xShape[0] - coords[0] - 1;\n        }\n        if (uniforms.axis[1] == 1) {\n          reverseCoords[1] = uniforms.xShape[1] - coords[1] - 1;\n        }\n        if (uniforms.axis[2] == 1) {\n          reverseCoords[2] = uniforms.xShape[2] - coords[2] - 1;\n        }\n        if (uniforms.axis[3] == 1) {\n          reverseCoords[3] = uniforms.xShape[3] - coords[3] - 1;\n        }\n\n        return reverseCoords;\n      }\n    \n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let reverseCoords = getReverseCoords(coords);\n          setOutputAtIndex(index, getX(reverseCoords[0],\n              reverseCoords[1], reverseCoords[2], reverseCoords[3]));\n        }\n      }\n    `}}const ju={kernelName:Bt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{dims:a}=r,o=s.shape.length;if(0===o)return Ii({inputs:{x:s},backend:n});const u=s.shape,d=[1,1,1,1];u.forEach(((e,t)=>{d[t+4-o]=e}));const l=i.parseAxisParam(a,s.shape),h=[0,0,0,0];l.forEach((e=>{h[e+4-o]=1}));const p=[{type:"int32",data:h}],c=wi({inputs:{x:s},backend:n,attrs:{shape:d}}),f=new Yu(d),m=n.runWebGPUProgram(f,[c],c.dtype,p);n.disposeData(c.dataId);const g=wi({inputs:{x:m},backend:n,attrs:{shape:u}});return n.disposeData(m.dataId),g}};class Qu{constructor(e,t){this.outputShape=[],this.variableNames=["x"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms="centerX : f32, centerY : f32, sinRadians : f32,\n          cosRadians : f32,",this.shaderKey="rotate",this.outputShape=e,"number"==typeof t?(this.uniforms+=" fillValue : f32,",this.fillSnippet="var outputValue = uniforms.fillValue;",this.shaderKey+="_float"):(this.uniforms+=" fillValue : vec3<f32>,",this.fillSnippet="var outputValue = uniforms.fillValue[coords[3]];",this.shaderKey+="_vec3")}getUserCode(){return`\n        ${An("index")} {\n          if (index < uniforms.size) {\n            let coords = getCoordsFromIndex(index);\n            let coordXFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.cosRadians - (f32(coords[1]) - uniforms.centerY) *\n                uniforms.sinRadians;\n            let coordYFloat = (f32(coords[2]) - uniforms.centerX) *\n                uniforms.sinRadians + (f32(coords[1]) - uniforms.centerY) *\n                uniforms.cosRadians;\n            let coordX = i32(round(coordXFloat + uniforms.centerX));\n            let coordY = i32(round(coordYFloat + uniforms.centerY));\n            ${this.fillSnippet}\n            if(coordX >= 0 && coordX < uniforms.xShape[2] && coordY >= 0 &&\n                coordY < uniforms.xShape[1]) {\n              outputValue = getX(coords[0], coordY, coordX, coords[3]);\n            }\n            setOutputAtIndex(index, outputValue);\n          }\n        }\n      `}}const Zu={kernelName:_t,backendName:"webgpu",kernelFunc:({inputs:e,attrs:t,backend:i})=>{const{image:r}=e,{radians:s,fillValue:a,center:o}=t,u=i,d=new Qu(r.shape,a),[l,h]=n.getImageCenter(o,r.shape[1],r.shape[2]),p=[{type:"float32",data:[l]},{type:"float32",data:[h]},{type:"float32",data:[Math.sin(s)]},{type:"float32",data:[Math.cos(s)]}];"number"==typeof a?p.push({type:"float32",data:[Number.parseFloat(a.toFixed(2))]}):p.push({type:"float32",data:a});return u.runWebGPUProgram(d,[r],r.dtype,p)}},Ju={kernelName:Ot,backendName:"webgpu",kernelFunc:Ai({opType:ei.ROUND})},ed={kernelName:Ut,backendName:"webgpu",kernelFunc:Ai({opType:ei.RSQRT,cpuKernelImpl:_r})};class td{constructor(e,t,n,i,r,s,a,o=!0){this.variableNames=["updates","indices"],this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=s,this.type=a,this.sumDupeIndices=o,this.dispatchLayout=Gn(e),this.dispatch=On(this.dispatchLayout,e,this.workgroupSize),this.sliceDimGreaterThanOne=t>1,this.shaderKey=`scatter_${n}_${i}_${this.sliceDimGreaterThanOne}_${a}_${o}`;const u=Pn(r.length);this.uniforms=`sliceDim : i32, strides: ${u}, updatesSize: i32,`,this.updatesRank=i,this.indicesRank=n}getUserCode(){let e="";1===this.indicesRank?e="coords[0]":2===this.indicesRank&&(e="coords[0], j");const t=`getIndices(${e})`,n=this.sliceDimGreaterThanOne?"uniforms.strides[j]":"uniforms.strides";let i="",r="";1===this.dispatchLayout.x.length?(i="flattenedIndex",r="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> i32 {\n        return index;\n      }\n      "):2===this.dispatchLayout.x.length&&(i="vec2<i32>(flattenedIndex, coords[1])",r="\n      fn getUpdatesCoordsFromFlatIndex(index : i32) -> vec2<i32> {\n        // N.B. |updates| could be a scalar tensor, conceptually representing a\n        // 2D tensor with all values equal to that. By design, its size must be\n        // the same as |outShape[1]| in one dimension, and |indicesShape[0]|\n        // gives the other.\n        let sliceSize = uniforms.outShape[1];\n        let d0 = index / sliceSize;\n        let d1 = index - d0 * sliceSize;\n        return vec2<i32>(d0, d1);\n      }\n      ");const s=`getUpdates(${Array.from({length:this.updatesRank},((e,t)=>`coords[${t}]`)).join(", ")})`;return`\n    ${r}\n      ${An("index")} {\n        if (index < uniforms.updatesSize) {\n          let coords = getUpdatesCoordsFromFlatIndex(index);\n          var flattenedIndex = 0;\n          for (var j = 0; j < uniforms.sliceDim; j = j + 1) {\n            let indexInside = i32(round(${t}));\n            flattenedIndex = flattenedIndex + indexInside * ${n};\n          }\n          let updateValue =\n              ${Ln(this.type)}(${s});\n          let flatIndex = getOutputIndexFromCoords(${i});\n\n          ${this.sumDupeIndices?In("&result[flatIndex]","updateValue",this.type):"atomicStore(&result[flatIndex], bitcast<i32>(updateValue));"}\n        }\n      }`}}const nd={kernelName:Vt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{indices:a,updates:o}=t,{shape:u}=s,{sliceRank:d,numUpdates:l,sliceSize:h,strides:p,outputSize:c}=n.calculateShapes(o,a,u),f=[c/h,h];if(0===c)return r.makeTensorInfo(u,a.dtype);const m=wi({inputs:{x:a},backend:r,attrs:{shape:[l,d]}}),g=wi({inputs:{x:o},backend:r,attrs:{shape:[l,h]}}),x=g.dtype,y=xi({backend:r,attrs:{shape:f,value:0,dtype:x}}),w=[{type:"int32",data:[d]},{type:"int32",data:p},{type:"int32",data:[i.sizeFromShape(g.shape)]}],b=new td(g.shape,d,m.shape.length,g.shape.length,p,f,x),C=r.runWebGPUProgram(b,[g,m],x,w,y),S=wi({inputs:{x:C},backend:r,attrs:{shape:u}});return r.disposeData(m.dataId),r.disposeData(g.dataId),r.disposeData(C.dataId),S}};class id{constructor(e,t){this.outputShape=[],this.variableNames=["sortedSequence","values"],this.uniforms="numInputs : i32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.side=t,this.shaderKey=`search_sorted_${t}`}getUserCode(){return`\n      fn findBound(batch: i32, value: f32) -> i32 {\n        var left = i32(0);\n        var right = uniforms.numInputs;\n        while (left < right) {\n          var mid = (left + right) / 2;\n          if (getSortedSequence(batch, mid) ${"left"===this.side?"<":"<="} value) {\n            left = mid + 1;\n          } else {\n            right = mid;\n          }\n        }\n        return right;\n      }\n\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let value = getValuesByOutputIndex(index);\n          setOutputAtIndexI32(index, findBound(coords[0], value));\n        }\n      }\n    `}}const rd={kernelName:Mt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{sortedSequence:r,values:s}=t,{side:a}=i,o=new id([s.shape[0],s.shape[1]],a),u=[{type:"int32",data:[r.shape[1]]}];return n.runWebGPUProgram(o,[r,s],"int32",u)}};class sd{constructor(e,t,n){this.variableNames=["c","a","b"],this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=t,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.cRank=e,this.rank=n,this.shaderKey="select"}getUserCode(){let e,t;if(this.rank>4)throw Error(`Where for rank ${this.rank} is not yet supported`);if(1===this.rank)t="resRC",e="resRC";else{const n=["resRC.x","resRC.y","resRC.z","resRC.w"],i=[],r=[];for(let e=0;e<this.outputShape.length;e++)r.push(`${n[e]}`),e<this.cRank&&i.push(`${n[e]}`);e=i.join(),t=r.join()}return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          let cVal = getC(${e});\n          if (cVal >= 1.0) {\n            setOutputAtIndex(index, getA(${t}));\n          } else {\n            setOutputAtIndex(index, getB(${t}));\n          }\n        }\n      }\n    `}}const ad={kernelName:Gt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n}=e,{condition:i,t:r,e:s}=t,a=new sd(i.shape.length,r.shape,r.shape.length);return n.runWebGPUProgram(a,[i,r,s],m(r.dtype,s.dtype))}},od={kernelName:Ht,backendName:"webgpu",kernelFunc:Ai({opType:ei.SELU})},ud={kernelName:Xt,backendName:"webgpu",kernelFunc:Ai({opType:ei.SIGMOID})},dd={kernelName:Kt,backendName:"webgpu",kernelFunc:Ai({opType:ei.SIGN})},ld={kernelName:qt,backendName:"webgpu",kernelFunc:Ai({opType:ei.SIN})},hd={kernelName:Yt,backendName:"webgpu",kernelFunc:Ai({opType:ei.SINH})},pd={kernelName:jt,backendName:"webgpu",kernelFunc:Ai({opType:ei.SOFTPLUS})};class cd{constructor(e,t,n,i,r,s){this.variableNames=["x"],this.outputShape=[],this.uniforms="",this.workgroupSize=[64,1,1],this.size=!0;const a=new Array(i.length);for(let e=0;e<a.length;e++)a[e]=i[r[e]];this.outputShape=a,this.newDim=r,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.xShape=e,this.paddedXShape=t,this.uniforms+=`reshapedPaddedXShape : ${Pn(i.length)}, paddedXShapeStrides : ${Pn(s)}, `,n.map(((e,t)=>{this.uniforms+=` pad${t} : vec2<i32>,`})),this.shaderKey=`spaceToBatchND_${r}`}getUserCode(){const e=Pn(this.outputShape.length),t=rs(this.newDim);return`\n      ${Tn(this.paddedXShape,"PaddedX")}\n      ${An("index")} {\n        if(index < uniforms.size) {\n          let coords = getCoordsFromIndex(index);\n          let switchedIndex = getIndexFromCoords${this.outputShape.length}D(${e}(${t}), uniforms.reshapedPaddedXShape);\n          let paddedCoords = getPaddedXCoordsFromIndex(switchedIndex);\n          ${Au(this.xShape,!0)}\n        }\n      }\n    `}}const fd={kernelName:Qt,backendName:"webgpu",kernelFunc:e=>{const{inputs:t,backend:r,attrs:s}=e,{x:a}=t,{blockShape:o,paddings:u}=s;i.assert(a.shape.length<=4,(()=>"spaceToBatchND for rank > 4 with a WebGPU backend not implemented yet"));const d=o.reduce(((e,t)=>e*t)),l=[[0,0]];l.push(...u);for(let e=1+o.length;e<a.shape.length;++e)l.push([0,0]);const h=l.map(((e,t)=>e[0]+a.shape[t]+e[1])),p=n.getReshaped(h,o,d,!1),c=n.getPermuted(p.length,o.length,!1),f=n.getReshapedPermuted(h,o,d,!1),m=i.computeStrides(h),g=new cd(a.shape,h,l,p,c,m.length),x=[{type:"int32",data:p},{type:"int32",data:m}];l.map((e=>x.push({type:"int32",data:[e[0],e[1]]})));const y=r.runWebGPUProgram(g,[a],a.dtype,x),w=wi({inputs:{x:y},backend:r,attrs:{shape:f}});return r.disposeData(y.dataId),w}};class md{constructor(e,t){this.variableNames=["A"],this.workgroupSize=[64,1,1],this.size=!0;const n=new Array(e.length);for(let i=0;i<n.length;i++)n[i]=e[i]*t[i];this.outputShape=n,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.rank=this.outputShape.length,this.shaderKey="tile"}getUserCode(){const e=function(e,t=""){if(e>=5)throw Error(`Tile for rank ${e} is not yet supported`);if(1===e)return`(resRC % ${t}aShape)`;const n=["resRC.x","resRC.y","resRC.z","resRC.w"],i=[];for(let r=0;r<e;r++)i.push(`(${n[r]} % ${t}aShape[${r}])`);return i.join()}(this.rank,"uniforms.");return`\n      ${An("index")} {\n        if (index < uniforms.size) {\n          let resRC = getCoordsFromIndex(index);\n          setOutputAtIndex(index, getA(${e}));\n        }\n      }\n    `}}function gd(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{reps:a}=r;if(n.shouldExecuteOnCPU([s])||"string"===s.dtype||s.shape.length>=5){const e=n.readSync(s.dataId),t="string"===s.dtype?e.map((e=>i.decodeString(e))):e,r=o(s.shape,s.dtype,t),u=Xr(r,a);return n.makeTensorInfo(u.shape,u.dtype,u.values)}const u=new md(s.shape,a);return n.runWebGPUProgram(u,[s],s.dtype)}const xd={kernelName:Zt,backendName:"webgpu",kernelFunc:gd};const yd={kernelName:Jt,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{sparseIndices:a,sparseValues:o,defaultValue:u}=t,{outputShape:d}=s,{sliceRank:l,numUpdates:h,sliceSize:p,strides:c,outputSize:f}=n.calculateShapes(o,a,d),m=!1;if("string"===o.dtype){const e=r.bufferSync(a),t=r.bufferSync(o),n=i.decodeString(r.readSync(u.dataId)[0]),s=Or(e,t,d,f,p,h,l,c,n,m);return r.makeTensorInfo(d,s.dtype,s.values)}const g=[f/p,p],x=wi({inputs:{x:a},backend:r,attrs:{shape:[h,l]}}),y=o.shape.length?wi({inputs:{x:o},backend:r,attrs:{shape:[h,p]}}):Ii({inputs:{x:o},backend:r}),w=y.dtype,b=r.makeTensorInfo([],w,i.makeZerosTypedArray(1,w)),C=wi({inputs:{x:u},backend:r,attrs:{shape:Array(g.length).fill(1)}}),S=gd({inputs:{x:C},backend:r,attrs:{reps:g}}),v=[{type:"int32",data:[l]},{type:"int32",data:c},{type:"int32",data:[i.sizeFromShape([h,p])]}];switch(h){case 0:break;case 1:{const e=new td([h,p],l,x.shape.length,y.shape.length,c,g,w,m);r.runWebGPUProgram(e,[y,x],w,v,S)}break;default:{const e=new td([h,p],l,x.shape.length,b.shape.length,c,g,w,m);r.runWebGPUProgram(e,[b,x],w,v,S)}{const e=new td([h,p],l,x.shape.length,y.shape.length,c,g,w);r.runWebGPUProgram(e,[y,x],w,v,S)}}const k=wi({inputs:{x:S},backend:r,attrs:{shape:d}});return r.disposeData(x.dataId),r.disposeData(y.dataId),r.disposeData(C.dataId),r.disposeData(b.dataId),r.disposeData(S.dataId),k}};const wd={kernelName:en,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:a}=t,{numOrSizeSplits:o,axis:u}=s,d=i.parseAxisParam(u,a.shape)[0],l=n.prepareSplitSize(a,o,d),h=a.shape.length,p=new Array(h).fill(0),c=a.shape.slice();return l.map((e=>{const t=[...c];t[d]=e;const n=Ws({inputs:{x:a},backend:r,attrs:{begin:p,size:t}});return p[d]+=e,n}))}},bd={kernelName:tn,backendName:"webgpu",kernelFunc:Ai({opType:ei.SQRT})},Cd={kernelName:nn,backendName:"webgpu",kernelFunc:({inputs:e,backend:t})=>{const{x:n}=e,i=t,r=new zi(n.shape,ei.SQUARE);return i.runWebGPUProgram(r,[n],n.dtype)}},Sd={kernelName:rn,backendName:"webgpu",kernelFunc:Ni({opType:Zn.SQUARED_DIFFERENCE})};const vd={kernelName:sn,backendName:"webgpu",kernelFunc:function({inputs:e,attrs:t,backend:n}){const{x:i}=e,r=new zi(i.shape,ei.STEP,"stepAlpha : f32,"),s=[{type:"float32",data:[t.alpha]}];return n.runWebGPUProgram(r,[i],i.dtype,s)}};class kd{constructor(e){this.variableNames=["x"],this.workPerThread=1,this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize,[this.workPerThread,1,1]);const t=Pn(this.outputShape.length);this.uniforms=`begin : ${t},  strides : ${t}, `,this.shaderKey="stridedSlice"}getUserCode(){let e="";if(1===this.outputShape.length)e="coords * uniforms.strides + uniforms.begin";else{let t=0;e=this.outputShape.map(((e,n)=>(t++,1===this.outputShape.length?`coords * uniforms.strides[${n}] + uniforms.begin[${n}]`:`coords[${t-1}] * uniforms.strides[${n}] + uniforms.begin[${n}]`))).join(",")}return`\n       ${An("index")} {\n         if (index < uniforms.size) {\n           let coords = getCoordsFromIndex(index);\n           setOutputAtIndex(index, getX(${e}));\n         }\n       }\n     `}}const Id={kernelName:an,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{begin:a,end:u,strides:d,beginMask:l,endMask:h,ellipsisMask:p,newAxisMask:c,shrinkAxisMask:f}=r,{finalShapeSparse:m,finalShape:g,isIdentity:x,sliceDim0:y,isSimpleSlice:w,begin:C,end:S,strides:v}=b.sliceInfo(s.shape,a,u,d,l,h,p,c,f);let k;if(x)k=wi({inputs:{x:s},backend:n,attrs:{shape:g}});else if(y||w){i.assert(s.shape.length>=1,(()=>`Input must have rank at least 1, got: ${s.shape.length}`));const e=b.computeOutShape(C,S,v),t=Ws({inputs:{x:s},backend:n,attrs:{begin:C,size:e}});k=wi({inputs:{x:t},backend:n,attrs:{shape:g}}),n.disposeData(t.dataId)}else{if(n.shouldExecuteOnCPU([s])){const e=n.readSync(s.dataId),t=o(s.shape,s.dtype,e),i=Mr(m,t,v,C);k=n.makeTensorInfo(g,s.dtype,i.values)}else{const e=new kd(m),t=[{type:"int32",data:C},{type:"int32",data:v}],i=n.runWebGPUProgram(e,[s],s.dtype,t);k=wi({inputs:{x:i},backend:n,attrs:{shape:g}}),n.disposeData(i.dataId)}}return k}};const Rd={kernelName:on,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{separator:r,nGramWidths:s,leftPad:a,rightPad:o,padWidth:u,preserveShortSequences:d}=i,{data:l,dataSplits:h}=t,p=n.readSync(l.dataId),c=n.readSync(h.dataId),[f,m]=Gr(p,c,r,s,a,o,u,d);return[n.makeTensorInfo([f.length],"string",f),n.makeTensorInfo(h.shape,"int32",m)]}},$d={kernelName:un,backendName:"webgpu",kernelFunc:Ni({opType:Zn.SUB,cpuKernelImpl:Hr,supportsComplex:!0})},Pd={kernelName:dn,backendName:"webgpu",kernelFunc:Ai({opType:ei.TAN})},zd={kernelName:ln,backendName:"webgpu",kernelFunc:Ai({opType:ei.TANH})};const Ad={kernelName:hn,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{tensor:a,indices:o,updates:u}=t,{sliceRank:d,numUpdates:l,sliceSize:h,strides:p,outputSize:c}=n.calculateShapes(u,o,a.shape),f=[c/h,h];if(0===c)return r.makeTensorInfo(a.shape,o.dtype);const m=[],g=wi({inputs:{x:o},backend:r,attrs:{shape:[l,d]}});m.push(g);const x=wi({inputs:{x:u},backend:r,attrs:{shape:[l,h]}});m.push(x);const y=wi({inputs:{x:a},backend:r,attrs:{shape:f}});m.push(y);const w=gd({inputs:{x:y},backend:r,attrs:{reps:Array(f.length).fill(1)}}),b=new td([l,h],d,g.shape.length,x.shape.length,p,f,a.dtype,!1),C=[{type:"int32",data:[d]},{type:"int32",data:p},{type:"int32",data:[i.sizeFromShape([l,h])]}],S=r.runWebGPUProgram(b,[x,g],y.dtype,C,w);m.push(S);const v=wi({inputs:{x:S},backend:r,attrs:{shape:a.shape}});return m.forEach((e=>r.disposeData(e.dataId))),v}};class Nd{constructor(e){this.variableNames=["x","indices"],this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms="inputSize : i32, firstPass : i32, negativeInf : f32,\n        dir : i32, inc : i32,",this.shaderKey="swap"}getUserCode(){return`\n        ${An("index")} {\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // We compare elements pair-wise within a group of size 2 * inc.\n            // The comparing rule for each group alternates between ascending\n            // and descending. Within each group, we compare each pair at\n            // positions i and i+inc. To decide whether an element at position i\n            // is x0 or x1, we mod it by 2 * inc, if the result is smaller than\n            // inc, it is in the first half of the group, we denote it as x0,\n            // otherwise we denote it as x1.\n            // For example, as shown in the Bitonic top K paper referenced\n            // above, Figure5(a) shows that element[1] is in the second half of\n            // the group when group size is 2, but it is in the first half of\n            // the group when group size is 4.\n            let isFirstInPair = elemIdx % (2 * uniforms.inc) < uniforms.inc;\n            var i = 0;\n            if (isFirstInPair) {\n              i = elemIdx;\n            } else {\n              i = elemIdx - uniforms.inc;\n            }\n\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.inc;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.inc));\n            }\n\n            var x0 = f32(0.0);\n            var x1 = f32(0.0);\n            if (i0 < uniforms.inputSize) {\n              x0 = getX(batch, i0);\n            } else {\n              x0 = uniforms.negativeInf;\n            }\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = uniforms.negativeInf;\n            }\n\n            let reverse = elemIdx % (2 * uniforms.dir) >= uniforms.dir;\n            let isGreater = x0 > x1 || (x0 == x1 && i1 > i0);\n            if (reverse == isGreater) {\n              // Elements in opposite order of direction\n              let iTemp = i0;\n              i0 = i1;\n              i1 = iTemp;\n            }\n            if (isFirstInPair) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      `}}class Dd{constructor(e){this.variableNames=["x","indices"],this.workgroupSize=[256,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.uniforms="inputSize : i32, firstPass : i32, k : i32,",this.shaderKey="merge"}getUserCode(){return`\n        ${An("index")} {\n          if (index < uniforms.size) {\n            let outC = getCoordsFromIndex(index);\n            let batch = outC[0];\n            let elemIdx = outC[1];\n            // The output size is half of the previous size.\n            // If the previous sequence is | | | | _ _ _ _  | | | |  _ _ _ _\n            // (k=4), we only need to output the indices at positions |, the\n            // indices at positions _ can be thrown away, see Figure5(b) After\n            // Phase 2 (Merge phase) in the Bitonic Top K paper referenced\n            // above.\n            // For example, the paper shows we only need to output the orange\n            // bars. The output sequence should look like this | | | | | | | |.\n            // Because the sequence is halved, to map the output index back to\n            // the previous sequence to find the corresponding value, we need\n            // to double the index. When we double the index, we basically\n            // interpolate a position, so 2i looks like\n            // | _ | _ | _ | _ | _ | _ | _. We move the | to the first k\n            // position of each 2k positions by - elemIdx % k. E.g. for output\n            // at index 4,5,6,7, we want to get the corresponding element at\n            // original index 8,9,10,11, for output at index 8,9,10,11,\n            // we want to get the corresponding element at original index\n            // 16,17,18,19, so on and so forth.\n\n            var i = 0;\n            if (elemIdx < uniforms.k) {\n              i = elemIdx;\n            } else {\n              i = elemIdx * 2 - elemIdx % uniforms.k;\n            }\n            var i0 = 0;\n            if (uniforms.firstPass == 1) {\n              i0 = i;\n            } else {\n              i0 = i32(getIndices(batch, i));\n            }\n            var i1 = 0;\n            if (uniforms.firstPass == 1) {\n              i1 = i + uniforms.k;\n            } else {\n              i1 = i32(getIndices(batch, i + uniforms.k));\n            }\n\n            let x0 = getX(batch, i0);\n            var x1 = f32(0.0);\n            if (i1 < uniforms.inputSize) {\n              x1 = getX(batch, i1);\n            } else {\n              x1 = x0;\n            }\n\n            if (x0 >= x1) {\n              setOutputAtIndex(index, f32(i0));\n            } else {\n              setOutputAtIndex(index, f32(i1));\n            }\n          }\n        }\n      `}}function Fd(e,t){null!==t&&e.disposeData(t.dataId)}function Td(e){let t=1;for(;t<e;)t*=2;return t}const Ed={kernelName:pn,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:r}=e,{x:s}=t,{k:a,sorted:o}=r,u=s.shape,d=u[u.length-1];if(n.shouldExecuteOnCPU([s])){const e=n.readSync(s.dataId),[t,i]=Kr(e,u,s.dtype,a,o);return[n.makeTensorInfo(t.shape,t.dtype,t.values),n.makeTensorInfo(i.shape,i.dtype,i.values)]}if(0===a)return u[u.length-1]=0,[n.makeTensorInfo(u,s.dtype,[]),n.makeTensorInfo(u,"int32",[])];if(1===d)return[s,xi({attrs:{shape:u,dtype:"int32",value:0},backend:n})];const l=i.sizeFromShape(u)/d,h=wi({inputs:{x:s},attrs:{shape:[l,d]},backend:n}),p=Td(a),c=Td(d);let f=null;const m=()=>null===f?[h,h]:[h,f],g=(e,t,i)=>{const r=m(),s=new Nd(i),a=[{type:"int32",data:[d]},{type:"int32",data:[null===f?1:0]},{type:"float32",data:[Number.NEGATIVE_INFINITY]},{type:"int32",data:[e]},{type:"int32",data:[t]}],o=f;f=n.runWebGPUProgram(s,r,"int32",a),Fd(n,o)};for(let e=1;e<p;e*=2){const t=2*e;for(let n=e;n>=1;n/=2)g(t,n,[l,c])}for(let e=c;e>p;e/=2){const t=m(),i=new Dd([l,e/2]),r=[{type:"int32",data:[d]},{type:"int32",data:[null===f?1:0]},{type:"int32",data:[p]}],s=f;f=n.runWebGPUProgram(i,t,"int32",r),Fd(n,s);const a=p/2,o=2*a;for(let e=a;e>=1;e/=2)g(o,e,f.shape)}let x=f;f=Ws({inputs:{x:f},backend:n,attrs:{begin:0,size:[l,a]}}),Fd(n,x);let y=Fo({inputs:{x:h,indices:f},backend:n,attrs:{axis:1,batchDims:1}});Fd(n,h);const w=u.slice(0,-1);w.push(a),x=f,f=wi({inputs:{x:f},attrs:{shape:w},backend:n}),Fd(n,x);const b=y;return y=wi({inputs:{x:y},attrs:{shape:w},backend:n}),Fd(n,b),[y,f]}};class Wd{constructor(e){this.variableNames=["Image","Transforms"],this.uniforms="interpolationModeId : i32, fillModeId : i32, fillValue : f32,",this.workgroupSize=[64,1,1],this.size=!0,this.outputShape=e,this.dispatchLayout=Gn(this.outputShape),this.dispatch=On(this.dispatchLayout,this.outputShape,this.workgroupSize),this.shaderKey="transform"}getUserCode(){return`\n          fn mapCoord(outCoord : f32, len : f32) -> f32{\n            var inCoord = outCoord;\n            if(uniforms.fillModeId == 2) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  if (inCoord < sz2) {\n                    inCoord = sz2 * f32(i32(f32(-inCoord / sz2))) +\n                    inCoord;\n                  }\n                  if (inCoord < -len) {\n                    inCoord = inCoord + sz2;\n                  } else {\n                    inCoord = -inCoord - 1.0;\n                  }\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz2 = 2.0 * len;\n                  inCoord = inCoord - sz2 * f32(i32(f32(inCoord / sz2)));\n                  if (inCoord >= len) {\n                    inCoord = sz2 - inCoord - 1.0;\n                  }\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 3) {\n              if (inCoord < 0.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord + len * (f32(i32(f32(-inCoord / sz))) + 1.0);\n                }\n              } else if (inCoord > len - 1.0) {\n                if (len <= 1.0) {\n                  inCoord = 0.0;\n                } else {\n                  let sz = len - 1.0;\n                  inCoord = inCoord - len * f32(i32(f32(inCoord / sz)));\n                }\n              }\n              return clamp(inCoord, 0.0, len - 1.0);\n            } else if (uniforms.fillModeId == 4) {\n              return clamp(outCoord, 0.0, len - 1.0);\n            }\n            return outCoord;\n          }\n          fn readWithFillValue(batch : i32, coordY : i32, coordX : i32,\n            channel : i32) -> f32 {\n            var outputValue : f32;\n            if (0 <= coordY && coordY < uniforms.imageShape[1] && 0 <= coordX && coordX < uniforms.imageShape[2]) {\n                outputValue = getImage(batch, coordY, coordX, channel);\n            } else {\n              outputValue = uniforms.fillValue;\n            }\n            return outputValue;\n          }\n\n          ${An("index")} {\n            if (index < uniforms.size) {\n              let coords = getCoordsFromIndex(index);\n              var outputValue : f32;\n              let batch = coords[0];\n              let x = coords[2];\n              let y = coords[1];\n              let channel = coords[3];\n              let xf = f32(x);\n              let yf = f32(y);\n              let a1 = getTransforms(batch, 0);\n              let a2 = getTransforms(batch, 1);\n              let a3 = getTransforms(batch, 2);\n              let b1 = getTransforms(batch, 3);\n              let b2 = getTransforms(batch, 4);\n              let b3 = getTransforms(batch, 5);\n              let c1 = getTransforms(batch, 6);\n              let c2 = getTransforms(batch, 7);\n              let projection = c1 * xf + c2 * yf + 1.0;\n              if (projection == 0.0) {\n                outputValue = uniforms.fillValue;\n              } else {\n                let inX = (a1 * xf + a2 * yf + a3) / projection;\n                let inY = (b1 * xf + b2 * yf + b3) / projection;\n                let mapX = mapCoord(inX, f32(uniforms.imageShape[2]));\n                let mapY = mapCoord(inY, f32(uniforms.imageShape[1]));\n\n                if (uniforms.interpolationModeId == 1) {\n                  let coordY = i32(round(mapY));\n                  let coordX = i32(round(mapX));\n                  outputValue = readWithFillValue(batch, coordY, coordX,\n                    channel);\n                } else {\n                  let yFloor = floor(mapY);\n                  let xFloor = floor(mapX);\n                  let yCeil = yFloor + 1.0;\n                  let xCeil = xFloor + 1.0;\n                  let valueYFloor = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yFloor), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yFloor), i32(xCeil), channel);\n                  let valueYCeil = (xCeil - mapX) *\n                  readWithFillValue(batch, i32(yCeil), i32(xFloor), channel) +\n                  (mapX - xFloor) *\n                  readWithFillValue(batch, i32(yCeil), i32(xCeil), channel);\n                  outputValue = (yCeil - mapY) * valueYFloor +\n                  (mapY - yFloor) * valueYCeil;\n                }\n              }\n              setOutputAtIndex(index, outputValue);\n            }\n          }\n        `}}const Ld={kernelName:cn,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{image:r,transforms:s}=t,{interpolation:a,fillMode:o,fillValue:u,outputShape:d}=i,[l,h,p,c]=r.shape,[f,m]=null!=d?d:[h,p],g=new Wd([l,f,m,c]),x="nearest"===a?1:2;let y;switch(o){case"constant":default:y=1;break;case"reflect":y=2;break;case"wrap":y=3;break;case"nearest":y=4}const w=[{type:"int32",data:[x]},{type:"int32",data:[y]},{type:"float32",data:[u]}];return n.runWebGPUProgram(g,[r,s],"float32",w)}};const Bd={kernelName:fn,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:n,attrs:i}=e,{value:r}=t;let{axis:s}=i;s<0&&(s+=r.shape.length);const a=r,o=a.shape.length,u=r.shape[s],d=new Array(o-1);let l=0;for(let e=0;e<o;e++)e!==s&&(d[l++]=a.shape[e]);const h=[],p=new Array(o).fill(0),c=a.shape.slice();c[s]=1;const f=new Array(u);for(let e=0;e<f.length;e++){p[s]=e;const t=Ws({inputs:{x:a},backend:n,attrs:{begin:p,size:c}}),i=wi({inputs:{x:t},backend:n,attrs:{shape:d}});f[e]=i,h.push(t)}return h.forEach((e=>n.disposeData(e.dataId))),f}};class _d{constructor(e,t,n){if(this.outputShape=[],this.variableNames=["x","segmentIds"],this.uniforms="numSegments : i32, xSize: i32,",this.workgroupSize=[64,1,1],this.atomic=!0,this.outputShape=t,this.dispatchLayout=Gn(e),this.dispatch=On(this.dispatchLayout,e,this.workgroupSize),"float32"!==n&&"int32"!==n)throw new Error(`UnsortedSegmentSum only supports float32 and int32\n              types, does not support ${n} type.`);this.type=n,this.shaderKey="unsortedSegmentSum"}getUserCode(){return`\n    ${An("index")} {\n      if (index < uniforms.xSize) {\n        let coords = getXCoordsFromIndex(index);\n        let b = coords[0];\n        let inCol = coords[1];\n\n        let segmentId = i32(getSegmentIds(inCol));\n        if (segmentId >= 0) {\n          let flatIndex = b * uniforms.numSegments + segmentId % uniforms.numSegments;\n          let value = getX(b, inCol);\n\n          ${In("&result[flatIndex]","value",this.type)}\n        }\n      }\n    }\n  `}}const Od=[Si,jr,Qr,Zr,Jr,ts,ds,ls,ps,cs,fs,ms,gs,xs,ys,$s,Ps,Ns,Ds,Fs,Bs,Us,Ms,qs,Ys,Zs,Pi,ta,oa,ca,ya,ba,Sa,va,ka,Ia,Ra,Pa,Ta,Ea,Wa,Ba,Ha,Xa,Va,qa,ja,Ja,eo,so,ao,oo,uo,lo,ho,co,fo,xo,yi,wo,vo,bo,Co,$o,Po,zo,No,To,Eo,Wo,Ri,Lo,ra,Bo,_o,Oo,Uo,Vo,Mo,Ho,Ko,Xo,qo,Yo,jo,eu,nu,vs,iu,ru,du,su,uu,lu,Is,hu,pu,fu,mu,bu,no,Cu,Su,vu,Hs,Iu,Pu,zu,Du,Fu,Tu,Eu,Wu,Ks,Lu,Bu,_u,Ou,bi,Vu,Gu,Xu,qu,ju,Zu,Ju,ed,nd,rd,ad,od,ud,dd,ld,hd,Ls,vd,Id,Rd,wu,pd,fd,yd,wd,bd,Cd,Sd,$d,ro,Pd,zd,Ad,xd,Ed,Ld,as,Bd,{kernelName:mn,backendName:"webgpu",kernelFunc:function(e){const{inputs:t,backend:r,attrs:s}=e,{x:a,segmentIds:o}=t,{numSegments:u}=s,d=a.shape.length,l=[];let h=0;const p=n.getAxesPermutation([h],d);let c=a;null!=p&&(c=ss({inputs:{x:a},backend:r,attrs:{perm:p}}),l.push(c),h=n.getInnerMostAxes(1,d)[0]);const f=n.segment_util.computeOutShape(c.shape,h,u),m=i.sizeFromShape([c.shape[h]]),g=wi({inputs:{x:c},backend:r,attrs:{shape:[-1,m]}});l.push(g);const x=a.dtype,y=[g.shape[0],u],w=xi({backend:r,attrs:{shape:y,value:0,dtype:x}}),b=new _d(g.shape,y,x),C=[{type:"int32",data:[u]},{type:"int32",data:[i.sizeFromShape(g.shape)]}],S=r.runWebGPUProgram(b,[g,o],x,C,w),v=wi({inputs:{x:S},backend:r,attrs:{shape:f}});l.push(S);let k=v;if(null!=p){l.push(v);const e=n.getUndoAxesPermutation(p);k=ss({inputs:{x:k},backend:r,attrs:{perm:e}})}return l.forEach((e=>r.disposeData(e.dataId))),k}},$u];for(const e of Od)gn(e);export{Qn as WebGPUBackend,Yn as webgpu_util};
//# sourceMappingURL=tf-backend-webgpu.fesm.min.js.map
